/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package ae;

import java.awt.*;
import java.awt.event.*;
import common.*;
import ae.*;

public class AESetup extends Panel implements ItemListener, ActionListener, ComponentListener, Messages
{

  Frame frame;
  Memory mem;

  List panelList;
  CardPanel cards;


  DButton buttonAutoSetup;
  DButton buttonSave;
  DButton buttonDefault;

  // Setup general
  Panel tabGeneral;
  Spinner spinnerMemory;
  Spinner spinnerMemBase;
  Spinner spinnerMenu;
  DCheckbox checkMemory;
  DCheckbox checkAutosave;
  DCheckbox checkSound;
//  DCheckbox checkViewer;
  Label labelLang;
  Choice choiceLang;
  Label labelTab;
  Choice choiceTab;
//  Choice choiceProgramBg;

  // Image
  DCheckbox checkScale;
  DCheckbox checkDirect;
  DCheckbox checkFScale;

  // Setup dir
  Panel tabFiles;
  Label labelSetupDirBack;
  Label labelSetupDirFore;
  DCheckbox checkZipSort;
  DCheckbox checkArcRestore;
  DCheckbox checkArcReplace;
  DCheckbox checkDeleteDir;
  DCheckbox checkDeleteFile;
  DCheckbox checkReplace;
  DCheckbox checkFloppies;
  DCheckbox checkOpen;

  DCheckbox checkHtml;
  TextField fieldShort;
  TextField fieldPath;
  TButton   buttonShortSet;
  Choice choiceShort;

  // Setup style
  public StylePanel tabStylePanel;

  // Setup Text
  Panel tabText;
  DCheckbox checkEd;
  DCheckbox checkWrap;
  Label labelEd;
  TextField inputEd;
  TButton   buttonEdLocate;
  DLabel  labelBrowser;
  TButton   buttonBBrowse;


  // Setup associations
  Panel panelSetupAss;
  DComboBox comboExt;
  DComboBox comboAss;
  TButton buttonAssAdd;
  TButton buttonAssDef;
  TButton buttonAssAll;
  TButton buttonAssClear;
  TButton buttonAssCls;
  TButton buttonAssSearch;
  TButton buttonAssBrowse;
  DLabel labelAss;
  DCheckbox checkFirst;
  DCheckbox checkEnable;

  // Setup thumb nail
  PageSetup pageSetup;

  static boolean resizeMemory = false;
  static int shortnum = 0;
  static boolean enableAss[] = new boolean[256];
  static boolean WINDOWS;

  int listNo = 0;

  public AESetup(Frame f,
     Color PrgBackground,
     Font AEFont,
     Font AEBold)
  {

    frame = f;
    mem = null;

    WINDOWS = OS.isWindows();

    setLayout(new BorderLayout());

    // Header

    Dimension screen = getToolkit().getScreenSize();
    int fontSize = 14;
    int textSize = 30;
    if(screen.width >= 1024)
    {
       fontSize = 16;
    }
    if(WINDOWS) textSize = 24;

    Font setupFont = new Font("Dialog", Font.PLAIN, 14);


    DBPanel panelControl = new DBPanel(DBPanel.LINE);
    panelControl.setBounds(0, 0, 616, 40);
    panelControl.setPadding(0, 3, 0, 3);
    panelControl.setIPadding(0, 0, 0, 0);
    panelControl.setInnerBackground(ColorUtils.shadow(PrgBackground));
    add(panelControl, BorderLayout.NORTH);

    // Setup

    buttonDefault = new DButton(Icons.New,"Defaults");
    buttonDefault.setBounds(16, 4,104, 30);
    buttonDefault.setTip("Restore default settings");
    buttonDefault.addActionListener(this);
    //buttonDefault.setFont(AEBold);
    panelControl.add(buttonDefault);

    buttonAutoSetup = new DButton(Icons.Locate,"AutoSetup");
    buttonAutoSetup.setBounds(144,4,120, 30);
    buttonAutoSetup.setTip("Search for drives and useful programs");
    buttonAutoSetup.addActionListener(this);
    //buttonAutoSetup.setFont(AEBold);
    panelControl.add(buttonAutoSetup);

    buttonSave = new DButton(Icons.Save,"Save");
    buttonSave.setBounds(272, 4, 96, 30);
    buttonSave.setTip("Save the settings");
    buttonSave.addActionListener(this);
    //buttonSave.setFont(AEBold);
    panelControl.add(buttonSave);

    DLabel labelTitle = new DLabel("USER'S PREFERENCES", DLabel.ALIGN_LEFT, DLabel.BEVEL_RAISED);
    labelTitle.setBounds(500, 7, 200, 24);
    labelTitle.setFont(AEBold);
    labelTitle.setForeground(Color.white);
    panelControl.add(labelTitle);


    DPanel panelContent = new DPanel(new BorderLayout());
    add(panelContent, BorderLayout.CENTER);

    panelList = new List();
    panelList.add("Desktop");
    panelList.add("Styles");
    panelList.add("File management");
    panelList.add("Editor / Html");
    panelList.add("Images");
    panelList.add("Associations");
    panelList.add("Web pages");
    panelList.setSize(1024, 256);
    panelList.addItemListener(this);
    panelContent.add(panelList, BorderLayout.WEST);

    cards = new CardPanel();   // Dfaut SLANTED
    panelContent.add(cards);

    // Setup general
    tabGeneral = new Panel();
    tabGeneral.setLayout(null);
    tabGeneral.setVisible(false);
    tabGeneral.setBounds(12,33,574,328);
    tabGeneral.addComponentListener(this);
    cards.add(tabGeneral);

    spinnerMemory = new Spinner(Preferences.MemorySize, 0, 64);
    spinnerMemory.setBounds(32,44,54,27);
    //spinnerMemory.setBackground(PrgBackground);
    spinnerMemory.addActionListener(this);
    tabGeneral.add(spinnerMemory);

    Label labelMemory = new Label("Entries in lists of paths");
    labelMemory.setBounds(96, 43, 200,28);
    //labelMemory.setBackground(PrgBackground);
    tabGeneral.add(labelMemory);

    spinnerMemBase = new Spinner(Preferences.MemBaseSize, 0, 32);
    spinnerMemBase.setBounds(308, 44, 54,27);
    spinnerMemBase.addActionListener(this);

    Label labelMemBase = new Label("Permanent entries up to");
    labelMemBase.setBounds(374,43,200,28);

    // Sous windows les permanents sont les units
    // sous unix, l'utilisateur choisit
    if(!WINDOWS)
     {
         tabGeneral.add(spinnerMemBase);
 	 tabGeneral.add(labelMemBase);
     }

    spinnerMenu = new Spinner(Preferences.menuSize, 0, 64);
    spinnerMenu.setBounds(32,92,54,27);
    spinnerMenu.addActionListener(this);
    tabGeneral.add(spinnerMenu);

    Label labelMenu = new Label("Entries in menues");
    labelMenu.setBounds(96, 91, 200,28);
    tabGeneral.add(labelMenu);


    checkMemory = new DCheckbox("Saving lists at exit", Preferences.SaveMemory);
    checkMemory.setBounds(32,140, 200,22);
    //checkMemory.setBackground(PrgBackground);
    checkMemory.addItemListener(this);
    tabGeneral.add(checkMemory);

    checkAutosave = new DCheckbox("Auto save setup", Preferences.AutoSave);
    checkAutosave.setBounds(32,164, 200,22);
    //checkMemory.setBackground(PrgBackground);
    checkAutosave.addItemListener(this);
    tabGeneral.add(checkAutosave);

    checkSound = new DCheckbox("Sound", Preferences.Sound);
    checkSound.setBounds(32,188, 80,22);
    checkSound.addItemListener(this);
    tabGeneral.add(checkSound);

    labelTab = new Label("Tabs");
    labelTab.setBounds(32, 228, 40, 22);
    tabGeneral.add(labelTab);

    choiceTab = new Choice();
    choiceTab.setBounds(80, 228, 112, 24);
    choiceTab.setBackground(PrgBackground);
    choiceTab.addItem("Rounded");
    choiceTab.addItem("Cutted");
    choiceTab.addItem("Slanted");
    choiceTab.addItemListener(this);
    tabGeneral.add(choiceTab);

    labelLang = new Label("Manual");
    labelLang.setBounds(32, 268, 64, 22);
    tabGeneral.add(labelLang);

    choiceLang = new Choice();
    choiceLang.setBounds(100, 268, 132, 24);
    choiceLang.setBackground(PrgBackground);
    choiceLang.addItem("English");
    choiceLang.addItem("Franais");
    choiceLang.addItem("Espanol");
    choiceLang.addItem("Deutsch");
    choiceLang.addItem("Russian");
    choiceLang.addItem("Italiano");
    choiceLang.addItem("Portugues");
    choiceLang.addItem("Dansk");
    choiceLang.addItem("Norsk");
    choiceLang.addItem("Svensk");
    choiceLang.addItem("Suomi");
    choiceLang.addItem("Roman");
    choiceLang.addItem("Polski");
    choiceLang.addItem("Hungarian");
    choiceLang.addItem("Cesko");
    choiceLang.addItem("Slovnik");
    choiceLang.addItem("Other");
    choiceLang.addItemListener(this);
    tabGeneral.add(choiceLang);

    // Style

    tabStylePanel = new StylePanel(48, 32);
    tabStylePanel.setBounds(12,12,574,358);
    tabStylePanel.addActionListener(this);
    tabStylePanel.addComponentListener(this);
    cards.add(tabStylePanel);

    // Directory

    tabFiles = new Panel();
    tabFiles.setLayout(null);
    tabFiles.setVisible(false);
    tabFiles.setBounds(12,12,574,372);
    //tabFiles.setBackground(PrgBackground);
    tabFiles.addComponentListener(this);
    cards.add(tabFiles);

    checkZipSort = new DCheckbox("Display content of archive sorted", Preferences.ArcSort);
    checkZipSort.setBounds(32, 32, 256, 22);
    //checkZipSort.setBackground(PrgBackground);
    checkZipSort.addItemListener(this);
    tabFiles.add(checkZipSort);

    checkDeleteDir = new DCheckbox("Prompt to delete no empty dir", Preferences.AskDeleteDir);
    checkDeleteDir.setBounds(32, 64, 232,22);
    //checkDeleteDir.setBackground(PrgBackground);
    checkDeleteDir.addItemListener(this);
    tabFiles.add(checkDeleteDir);

    checkDeleteFile = new DCheckbox("Prompt to delete file", Preferences.AskDeleteFile);
    checkDeleteFile.setBounds(32,96,200,22);
    //checkDeleteFile.setBackground(PrgBackground);
    checkDeleteFile.addItemListener(this);
    tabFiles.add(checkDeleteFile);

    checkReplace = new DCheckbox("Prompt before replacing existing file", Preferences.AskReplace);
    checkReplace.setBounds(32,128, 280, 22);
    //checkDeleteFile.setBackground(PrgBackground);
    checkReplace.addItemListener(this);
    tabFiles.add(checkReplace);

    checkHtml = new DCheckbox("Prompt to replace generated html", Preferences.AskHtml);
    checkHtml.setBounds(32,160,256, 22);
    checkHtml.addItemListener(this);
    tabFiles.add(checkHtml);

    checkArcRestore = new DCheckbox("Restore paths when unarchiving", Preferences.ArcRestore);
    checkArcRestore.setBounds(32, 192, 248,22);
    //checkArcRestore.setBackground(PrgBackground);
    checkArcRestore.addItemListener(this);
    tabFiles.add(checkArcRestore);

    checkArcReplace = new DCheckbox("Erase previous when unarchiving", Preferences.ArcReplace);
    checkArcReplace.setBounds(32, 224, 248,22);
    //checkArcReplace.setBackground(PrgBackground);
    checkArcReplace.addItemListener(this);
    tabFiles.add(checkArcReplace);

    checkFloppies = new DCheckbox("Including floppies in tree list", Preferences.FLOPPIES);
    checkFloppies.setBounds(32, 256, 248,22);
    //checkArcReplace.setBackground(PrgBackground);
    checkFloppies.addItemListener(this);
    tabFiles.add(checkFloppies);

    checkOpen = new DCheckbox("Open dir created in target", Preferences.OpenDir);
    checkOpen.setBounds(32, 288, 248,22);
    checkOpen.addItemListener(this);
    tabFiles.add(checkOpen);


    choiceShort = new Choice();
    choiceShort.setBounds(32, 340, 100, textSize);
    choiceShort.setBackground(PrgBackground);
    choiceShort.addItem("Button 1");
    choiceShort.addItem("Button 2");
    choiceShort.addItem("Button 3");
    choiceShort.addItem("Button 4");
    choiceShort.addItem("Button 5");
    choiceShort.addItem("Button 6");
    choiceShort.addItem("Button 7");
    choiceShort.addItem("Button 8");
    choiceShort.addItemListener(this);
    choiceShort.select(0);
    tabFiles.add(choiceShort);

    Label lfs = new Label("Name");
    lfs.setBounds(134, 316, 128, 22);
    tabFiles.add(lfs);
    Label lfp = new Label("Path");
    lfp.setBounds(264, 316, 200, 22);
    tabFiles.add(lfp);

    fieldShort = new TextField(Preferences.shortcut[0],1);
    fieldShort.setBounds(134, 340, 128, textSize);
    fieldShort.setFont(setupFont);
    tabFiles.add(fieldShort);

    fieldPath = new TextField(Preferences.longpath[0],1);
    fieldPath.setBounds(264, 340, 200, textSize);
    fieldPath.setFont(setupFont);
    tabFiles.add(fieldPath);

    buttonShortSet = new TButton("Set it");
    buttonShortSet.setBounds(466, 340, 72, textSize);
    buttonShortSet.setStyle(true, true, 1);
    buttonShortSet.addActionListener(this);
    buttonShortSet.setTip("Set changes");
    tabFiles.add(buttonShortSet);

    // Setup text

    tabText = new Panel(null);
    tabText.setVisible(false);
    tabText.setBounds(12,33,574,258);
    //panelSetupDir.setBackground(PrgBackground);
    tabText.addComponentListener(this);
    cards.add(tabText);

    labelEd = new Label("Alternate text editor:");
    labelEd.setBounds(16, 26, 192, 20);
    tabText.add(labelEd);

    inputEd = new TextField();
    inputEd.setBounds(16,48,400, textSize);
    inputEd.setFont(setupFont);
    tabText.add(inputEd);

    buttonEdLocate = new TButton(Icons.Locate, "Browse");
    buttonEdLocate.setBounds(418, 48, 96, textSize);
    buttonEdLocate.setStyle(true, true, 1);
    buttonEdLocate.setTip("Find the editor");
    buttonEdLocate.addActionListener(this);
    tabText.add(buttonEdLocate);

    checkEd = new DCheckbox("Use this alternate editor for any text", Preferences.EditorAss);
    checkEd.setBounds(16, 96, 308, 22);
    //checkEd.setBackground(PrgBackground);
    checkEd.addItemListener(this);
    tabText.add(checkEd);

    checkWrap = new DCheckbox("Wrap-around - AE must be restarted", Preferences.wordWrap);
    checkWrap.setBounds(16, 124, 300, 22);
    checkWrap.addItemListener(this);
    tabText.add(checkWrap);

    // State: default = false
/*
	checkViewer = new DCheckbox("View only, disable editing");
	checkViewer.setBounds(16,128, 200, 22);
	//checkViewer.setBackground(PrgBackground);
	checkViewer.addItemListener(this);
	tabText.add(checkViewer);
*/

    Label lb = new Label("Html viewer:");
    lb.setBounds(16, 188, 160, 20);
    tabText.add(lb);

    String brow;
    if(WINDOWS)
         brow = "Internet Explorer";
    else brow = "Mozilla";

    labelBrowser = new DLabel(brow, DLabel.BEVEL_LOWERED, DLabel.ALIGN_CENTER);
    labelBrowser.setBounds(16, 210, 222, textSize);
    tabText.add(labelBrowser);

    buttonBBrowse = new TButton(Icons.Locate, "Browse");
    buttonBBrowse.setBounds(240, 210, 96, textSize);
    buttonBBrowse.setStyle(true, true, 1);
    buttonBBrowse.setTip("Locate the browser");
    buttonBBrowse.addActionListener(this);
    tabText.add(buttonBBrowse);


    Panel tabImage = new Panel(null);
    tabImage.setVisible(false);
    tabImage.setBounds(12,12,574,258);
    //tabText.addComponentListener(this);
    cards.add(tabImage);

    checkScale = new DCheckbox("Scaled to panel", Preferences.Scale);
    checkScale.setBounds(32, 48, 140, 22);
    checkScale.addItemListener(this);
    tabImage.add(checkScale);

    checkDirect = new DCheckbox("Directly full screen", Preferences.Direct);
    checkDirect.setBounds(32, 80, 160, 22);
    checkDirect.addItemListener(this);
    tabImage.add(checkDirect);

    checkFScale = new DCheckbox("Scaled to screen", Preferences.FScale);
    checkFScale.setBounds(32, 112, 160, 22);
    checkFScale.addItemListener(this);
    tabImage.add(checkFScale);

    // Associations
    panelSetupAss = new Panel(null);
    panelSetupAss.setVisible(false);
    panelSetupAss.setBounds(4,12,628,358);
    //panelSetupDir.setBackground(PrgBackground);
    cards.add(panelSetupAss);


    labelAss = new DLabel("Type an extension");
    labelAss.setBounds(10, 20, 320, 20);
    panelSetupAss.add(labelAss);

    comboExt = new DComboBox();
    comboExt.setBounds(16,48, 128, textSize);
    comboExt.setFont(AEFont);
    comboExt.setBackground(PrgBackground);
    comboExt.setArrowStyle(true, false, 1);
    comboExt.setMaxItems(256);
    comboExt.addActionListener(this);
    panelSetupAss.add(comboExt);

    checkEnable = new DCheckbox("Enabled", false);
    checkEnable.setBounds(224, 50, 80, 24);
    checkEnable.addItemListener(this);
    panelSetupAss.add(checkEnable);

    DLabel labelProg = new DLabel("Program using this extension");
    labelProg.setBounds(10, 96, 320, 20);
    panelSetupAss.add(labelProg);

    comboAss = new DComboBox();
    comboAss.setBounds(16, 124, 480, textSize);
    comboAss.setFont(AEFont);
    comboAss.setBackground(PrgBackground);
    comboAss.setArrowStyle(true, false, 1);
    comboAss.setMaxItems(256);
    comboAss.addActionListener(this);
    panelSetupAss.add(comboAss);

    buttonAssCls = new TButton("X");
    buttonAssCls.setBounds(498, 124, 24, 26);
    buttonAssCls.setBackground(PrgBackground);
    buttonAssCls.setStyle(true, true, 1);
    buttonAssCls.setTip("Clear the field");
    buttonAssCls.addActionListener(this);
    panelSetupAss.add(buttonAssCls);

    buttonAssSearch = new TButton(Icons.Locate, "Find");
    buttonAssSearch.setBounds(526, 124, 96, 28);
    //buttonAssSearch.setBackground(PrgBackground);
    buttonAssSearch.setStyle(true, true, 1);
    buttonAssSearch.setTip("Find the program");
    buttonAssSearch.addActionListener(this);
    panelSetupAss.add(buttonAssSearch);

    buttonAssBrowse = new TButton(Icons.Locate, "Browse");
    buttonAssBrowse.setBounds(526, 156, 96, 28);
    //buttonAssBrowse.setBackground(PrgBackground);
    buttonAssBrowse.setStyle(true, true, 1);
    buttonAssBrowse.setTip("Browse directories");
    buttonAssBrowse.addActionListener(this);
    panelSetupAss.add(buttonAssBrowse);


    buttonAssAdd = new TButton("Add");
    buttonAssAdd.setBounds(16, 200, 90, 26);
    buttonAssAdd.setBackground(Color.green.darker());
    buttonAssAdd.setStyle(true, true, 1);
    buttonAssAdd.setTip("Add the new association to the list");
    buttonAssAdd.addActionListener(this);
    panelSetupAss.add(buttonAssAdd);

    buttonAssDef = new TButton("Defaults");
    buttonAssDef.setBounds(122, 200, 90, 26);
    buttonAssDef.setBackground(PrgBackground);
    buttonAssDef.setStyle(true, true, 1);
    buttonAssDef.setTip("Clear and set the default list");
    buttonAssDef.addActionListener(this);
    panelSetupAss.add(buttonAssDef);

    buttonAssClear = new TButton("Delete");
    buttonAssClear.setBounds(228, 200, 90, 26);
    buttonAssClear.setBackground(PrgBackground);
    buttonAssClear.setStyle(true, true, 1);
    buttonAssClear.setTip("Delete the displayed association");
    buttonAssClear.addActionListener(this);
    panelSetupAss.add(buttonAssClear);

    buttonAssAll = new TButton("Clear all");
    buttonAssAll.setBounds(334, 200, 90, 26);
    buttonAssAll.setBackground(PrgBackground);
    buttonAssAll.setStyle(true, true, 1);
    buttonAssAll.setTip("Reset the whole list");
    buttonAssAll.addActionListener(this);
    panelSetupAss.add(buttonAssAll);

    checkFirst = new DCheckbox("Priority over built-in associations",Preferences.AssFirst);
    checkFirst.setBounds(16, 248, 280,24);
    checkFirst.addItemListener(this);
    panelSetupAss.add(checkFirst);

    // page web
    pageSetup = new PageSetup(frame);
    pageSetup.setVisible(false);
    pageSetup.setBounds(12,12,574,328);
    //panelSetupDir.setBackground(PrgBackground);
    cards.add(pageSetup);

    choiceTab.select(Preferences.tabStyle);
    choiceLang.select(Preferences.Language);

    // Style

    tabStylePanel.addItem(Preferences.TextStyle, "Editor");
    tabStylePanel.addItem(Preferences.DirStyle, "Directories");
    tabStylePanel.addItem(Preferences.TreeStyle, "Tree");
    tabStylePanel.addItem(Preferences.MessageStyle, "Message Bar");
    tabStylePanel.setCurrentStyle(Preferences.CurrentStyle);
    // Affecte WorkStyle selon le Style concern

    for(int i = 0; i < 256; i++) enableAss[i] = true;


    inputEd.setText(Preferences.edName);

    cards.first();

  }

  public void setMemory(Memory m)
  {
    mem = m;
  }

  public void setTab(int no)
  {
    cards.select(no);
    panelList.select(no);
    listNo = no;
  }

  ActionListener actionListener = null;

  protected void sourceActionEvent(int action)
   {
	 if (actionListener == null) return;

	 String actionCommand = new Integer(action).toString();
	 actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, actionCommand));
   }

  /** Adds a to receive action events  */
  public void addActionListener(ActionListener l)
   {
	 actionListener = AWTEventMulticaster.add(actionListener, l);
   }



//----------------------------------------------- Associations

   String message = "";


   void Message(String s) { message = s; sourceActionEvent(MESSAGE); };
   void dispTip(String s) { message = s; sourceActionEvent(TIP); };
   void beep() {sourceActionEvent(BEEP); };
   void Exit_Action() {sourceActionEvent(EXIT); };
   void updateConditional() { sourceActionEvent(UPDATE); }
   void setTabs() {sourceActionEvent(TABS); };

    void ExtensionAction()
    {
      int num = comboExt.getSelectedIndex();
      comboAss.select(num);
      checkEnable.setState(enableAss[num]);
    }

    void AssocAction()
    {
      int num = comboAss.getSelectedIndex();
      comboExt.select(num);
      checkEnable.setState(enableAss[num]);
    }

    boolean assocFilled()
    {
     String ext = comboExt.editBox.getText();
     String ass = comboAss.editBox.getText();
     boolean valid = true;
     if(ext == null) valid = false;
     else if(ext.length() ==0) valid = false;
     if(ass == null) valid = false;
     else if(ass.length() ==0) valid = false;
     return valid;
    }

   void AssocAdd()
   {
     if(!assocFilled())
     {
      dispTip("Fill the two fields first, please!");
      beep();
      return;
     }

     String ext = comboExt.editBox.getText();
     if(comboExt.addUnicItem(ext))
     {
      comboAss.addItem(comboAss.editBox.getText());
      enableAss[comboExt.countItems() - 1] = true;
      checkEnable.setState(true);
      Message("Extension " + ext +" added to the list");
     }
     else
      dispTip("Sorry, already in the list");
   }


  void assAdd(String ext, String prog)
  {
    comboExt.addItem(ext);
    comboAss.addItem(prog);
    enableAss[comboExt.countItems() - 1] = true;
    checkEnable.setState(true);
  }



  void assDel(String ext, String path)
  {
    int num = comboExt.search(ext);

    comboExt.delItem(num);
    comboAss.delItem(num);

    int max = comboExt.countItems();
    for(int i = num; i < (max-1); i++)
      enableAss[i] = enableAss[i+1];

  }


  // efface tout
  void assocAll()
  {
    comboExt.clear();
    comboAss.clear();
    Message("All extensions removed");
  }


  // dfauts
  void assocDef()
  {
    //System.out.println("enter assocdef");

    assocAll();

    assAdd("htm", Preferences.htmName);
    assAdd("html", Preferences.htmName);
    assAdd("asp", Preferences.htmName);
    assAdd("php", Preferences.htmName);
    assAdd("rtf", Preferences.edName);
    assAdd("pcx", Preferences.paintPath);
    assAdd("png", Preferences.htmName);
    assAdd("wav", Preferences.playPath);
    assAdd("au",  Preferences.playPath);
    assAdd("avi", Preferences.playPath);
    assAdd("mpg", Preferences.playPath);
    assAdd("mpeg", Preferences.playPath);
    assAdd("mid",  Preferences.playPath);
    assAdd("pdf", Preferences.pdfPath);

    if(WINDOWS)
    {
     assAdd("bmp", Preferences.paintPath);
     assAdd("doc", Preferences.edName);
     assAdd("wri", Preferences.edName);
     assAdd("hlp", Preferences.helpPath);
     assAdd("chm", "hh.exe");
     assAdd("fon", "fontview.exe");
     assAdd("ttf", "fontview.exe");
     assAdd("cda", "cdplayer");
    }
    else
    {
     assAdd("tga", Preferences.paintPath);
    }

    Message("List filled with default extensions");
  }

   void assocSearch()
   {
      String type = "program";
      String name = Path.splitFile(comboAss.editBox.getText());

      LocateDialog ld = new LocateDialog(frame);
      //ld.setCurDrive(source.getDrive());

      ld.show();
      if((ld.result > 0))
       {
         String found = Path.merge(ld.dirfound, ld.filefound);
         comboAss.editBox.setText(found);
         assAdd(comboExt.editBox.getText(), found);
         return;
       }

     beep();
 }

  // locate assoc
  void assocBrowse()
  {
   FileDialog openDialog = new FileDialog(frame, " Locate the program", FileDialog.LOAD);
   if(WINDOWS)
    openDialog.setDirectory("c:\\");
   else
    openDialog.setDirectory("/");
   openDialog.show();

   String name = openDialog.getFile();
   if(name == null) return;

   String path = Path.merge(openDialog.getDirectory(), name);
   String ext = comboExt.editBox.getText();

   comboAss.editBox.setText(path);
   assAdd(ext, path);

  }



  void AssocDel()
  {
     if(!assocFilled())
     {
      dispTip("Select an entry, please!");
      beep();
      return;
     }

    int num = comboExt.getSelectedIndex();
    if(num >= 0)
    {
    String ext = comboExt.getSelectedItem();

    comboExt.deselect(num);
    comboExt.delItem(num);
    comboAss.deselect(num);
    comboAss.delItem(num);
    checkEnable.setState(false);
    Message("Extension " + ext + " removed from the list");
    }
    else
    dispTip("Select an item to delete");
  }

//------------------------------ fin assoc

 void setupDefault()
  {
	if(Preferences.delete())
	 {
	  Preferences.Load();
	  Preferences.Save();
	  Message("Setup restored");
	  DialogYN mb = new DialogYN(frame, "AE must be restarted to keep the change. Close it?");
	  mb.show();
	  if(mb.choice) Exit_Action();
	 }
	else
	 Message("Enable to delete old setup");

    return;
  }



 void autoSetup()
 {
  try
  {
   SetupWindow sw = new SetupWindow(frame);
   sw.show();
  }
  catch(Exception e1) {};

  if(OS.isWindows() || OS.isMacintosh())
  {
   try { mem.addDrives(Windows.DiskBase);}
   catch(Exception e2) { };
  }

  assocDef();
 }



  void locateEditor()
  {
   String root;
   if(WINDOWS)
      root = "c:\\";
   else
      root = "/";

   FileDialog openDialog = new FileDialog(frame, " Locate editor", FileDialog.LOAD);

   openDialog.setDirectory(root);
   openDialog.setFile("");
   openDialog.show();

   String name = openDialog.getFile();
   if(name == null) return;

   String path = Path.merge(openDialog.getDirectory(), name);

   inputEd.setText(path);
   Preferences.edName = path;

   assDel("doc", Preferences.edName);
   assAdd("doc", Preferences.edName);

   assDel("wri", Preferences.edName);
   assAdd("wri", Preferences.edName);

   assDel("rtf", Preferences.edName);
   assAdd("rtf", Preferences.edName);

  }



  // Browser locate
  void browserBrowse()
  {
    String root;
    String navigator;
    if(WINDOWS)
    {
      root = "c:\\";
      navigator = "iexplore.exe";
    }
    else
    {
      root = "/";
      navigator = "mozilla";
    }

   FileDialog openDialog = new FileDialog(frame, " Locate browser", FileDialog.LOAD);

   openDialog.setDirectory(root);
   openDialog.setFile(navigator);
   openDialog.show();

   String name = openDialog.getFile();
   if(name == null) return;

   String path = Path.merge(openDialog.getDirectory(), name);

   if(name.equalsIgnoreCase("iexplore.exe")) name = "Internet Explorer";
   else
   if(name.equalsIgnoreCase("netscape.exe")) name = "Netscape";

   labelBrowser.setText(name);
   Preferences.htmName = path;

   assDel("htm", Preferences.htmName);
   assAdd("htm", Preferences.htmName);

   assDel("html", Preferences.htmName);
   assAdd("html", Preferences.htmName);

   assDel("php", Preferences.htmName);
   assAdd("php", Preferences.htmName);

  }


 void save()
 {
    if(Preferences.Save())
    {
      Message("User settings saved");
      updateConditional();
    }
    else Message("Enable to save " + Preferences.Filename);
 }


 public boolean hasHtml()
 {
    int l = comboExt.countItems();
    if (l == 0) return false;

    int l2 = comboAss.countItems();
    if (l2 == 0) return false;

    for (int i = 0; i < l; i++)
    {
      if (comboExt.getListText(i).compareTo("html") == 0) return true;
    }
    return false;
 }


 public void itemStateChanged(java.awt.event.ItemEvent event)
  {
	Object object = event.getSource();

	if (object == checkMemory)
	 { Preferences.SaveMemory = checkMemory.getState(); }
	else if (object == checkAutosave)
	 { Preferences.AutoSave = checkAutosave.getState(); }
	else if (object == checkSound)
	 { Preferences.Sound = checkSound.getState(); }
	else if (object == checkScale)
	 { Preferences.Scale = checkScale.getState(); }
	else if (object == checkDirect)
	 { Preferences.Direct = checkDirect.getState(); }
	else if (object == checkFScale)
	 { Preferences.FScale = checkFScale.getState(); }
	else if (object == checkEd)
         { Preferences.EditorAss = checkEd.getState(); }
	else if (object == checkWrap)
         { Preferences.wordWrap = checkEd.getState(); }
	else if (object == checkZipSort)
         {
           boolean res = checkZipSort.getState();
           Preferences.ArcSort = res;
           sourceActionEvent(ARCSORT);
         }
	else if (object == checkArcRestore)
         { Preferences.ArcRestore = checkArcRestore.getState();}
	else if (object == checkArcReplace)
         { Preferences.ArcReplace = checkArcReplace.getState();}
        else if (object == checkDeleteDir)
	 { Preferences.AskDeleteDir = checkDeleteDir.getState(); }
        else if (object == checkDeleteFile)
	 {  Preferences.AskDeleteFile = checkDeleteFile.getState(); }
        else if (object == checkReplace)
	 {  Preferences.AskReplace = checkReplace.getState(); }
        else if (object == checkHtml)
	 {  Preferences.AskHtml = checkHtml.getState(); }
        else if (object == checkFloppies)
	 {
	    Preferences.FLOPPIES = checkFloppies.getState();
	    sourceActionEvent(REBUILD);
	 }
        else if (object == checkOpen)
	 {  Preferences.OpenDir = checkOpen.getState(); }
 	else if(object == choiceTab)
 	 {
 	    Preferences.tabStyle = choiceTab.getSelectedIndex();
 	    setTabs();
 	    return;
 	 }
 	else if(object == choiceLang)
 	 {  Preferences.Language = choiceLang.getSelectedIndex(); }
	else if (object == checkFirst)
	 { Preferences.AssFirst = checkFirst.getState(); }
	else if (object == checkEnable)
	 { enableAss[comboExt.getSelectedIndex()] = checkEnable.getState(); }
        else if(object == choiceShort)
         {
          shortnum = choiceShort.getSelectedIndex();
          fieldShort.setText(Preferences.shortcut[shortnum]);
          fieldPath.setText(Preferences.longpath[shortnum]);
         }
        else if (object == panelList)
         {
          listNo = panelList.getSelectedIndex();
          cards.select(listNo);
        }
    }

  public void actionPerformed(java.awt.event.ActionEvent event)
   {
    Object object = event.getSource();

    if (object == buttonDefault)   setupDefault();
    else if (object == buttonAutoSetup) autoSetup();
    else if (object == buttonSave)	save();
    else if (object == buttonEdLocate)	locateEditor();
    else if (object == buttonBBrowse)	browserBrowse();

    else if (object == comboExt)	ExtensionAction();
    else if (object == comboAss)	AssocAction();
    else if (object == buttonAssCls) { comboAss.editBox.setText(""); return; }
    else if (object == buttonAssSearch) { assocSearch(); }
    else if (object == buttonAssBrowse) { assocBrowse(); }
    else if (object == buttonAssAdd) AssocAdd();
    else if (object == buttonAssDef) assocDef();
    else if (object == buttonAssClear) AssocDel();
    else if (object == buttonAssAll) assocAll();

    else if(object == spinnerMemory)
     {
       Preferences.MemorySize = spinnerMemory.getValue();
       resizeMemory = true;
     }
   else if(object == spinnerMemBase)
     {
       Preferences.MemBaseSize = spinnerMemBase.getValue();
       resizeMemory = true;
     }
    else if(object == spinnerMenu)
     {
       Preferences.menuSize = spinnerMenu.getValue();
       sourceActionEvent(RESIZE);
     }

   else if(object == tabStylePanel)
    {
        sourceActionEvent(STYLE);
    }


   else if (object == buttonShortSet)
    {
     String label = fieldShort.getText() ;
     Preferences.shortcut[shortnum] = label;
     Preferences.longpath[shortnum] = fieldPath.getText();
     sourceActionEvent(SHORTCUT);
    }


  }


  void general_componentShown()
  {
      dispTip("Desktop's look and feel, auto saving...");
  }

  void SetupDir_componentShown()
  {
      dispTip("Directory lists and path fields");
  }

  void SetupText_componentShown()
  {
      dispTip("Editor preferences");
  }

  void SetupStyle_componentShown()
  {
     dispTip("Fonts and colors");
     tabStylePanel.setVisible(true);
  }

  public void componentShown(java.awt.event.ComponentEvent event)
   {
	Object object = event.getSource();

	if (object == tabGeneral) general_componentShown();
	else if (object == tabStylePanel) SetupStyle_componentShown();
	else if (object == tabFiles) SetupDir_componentShown();
	else if (object == tabText) SetupText_componentShown();
	panelList.select(listNo);
  }


  public void componentHidden(java.awt.event.ComponentEvent event) { };
  public void componentResized(java.awt.event.ComponentEvent event) { };
  public void componentMoved(java.awt.event.ComponentEvent event) { };

  public void update(Graphics g) { paint(g); }

}
