/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package ae;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.awt.event.*;
import java.net.*;
import java.util.zip.*;
import common.*;
import comgr.*;
import ae.*;

public class ae extends Frame implements Messages, WindowListener
{
   final static String VERSION = "2.6";
   final static String RELEASE = "(c) 1999-2006 D.G. Sureau";
   final static String SITE = "www.scriptol.org";


   final static boolean LIBINCLUDED = false;
   final static boolean DEBUG = false;

   // Panels du Card Panel de droite
   final int TARGET = 0;
   final int THUMBNAIL = 1;
   final int LIST = 2;
   final int OUTLINE = 3;
   final int ARCHIVER = 4;

    // Objects
   //Icons ic;
   Memory mem = new Memory();
   Font AEFont;
   Font AEBold;
   History history = new History();
   AESetup aesetup;
   Archiver archiver = null;
   Temporary tempo = new Temporary(System.getProperty("user.dir"));
   DirTools dirtools = new DirTools();
   FileCopy filecopy = new FileCopy(this);

   // General vars
   String AEDir = System.getProperty("user.dir");
   String version = System.getProperty("java.version");
   String LocatePrevious = "";

   String m_dirName;
   String m_fileName;
   String m_pathName;


    // Flags
   boolean WINDOWS = true;
   boolean OrigineIsSrc = true; // A partir de quel rpertoire

   boolean statuscreated = false;


   boolean dirmask = false;
   boolean editmask = false;
   boolean imagemask = false;
   boolean setupmask = false;

    //boolean palmask = false;

   boolean displayFlag = true;         // Pour prendre message en History

    // Constants

   final int CANCEL = 0;
   final int YES    = 1;
   final int NO     = 2;

   final int tabDirNo = 0;
   final int tabTextNo = 1;
   final int tabSetupNo = 2;

   final int noTarget = 0;
   final int noTree = 1;
   final int noViewer = 2;

    // File
   String ZipName;       // Name of current displayed zip file
   String TreeDisk;      // Tree of Disk
   int SrcIndex;


   //-------------- GUI COMPOSANTES ------------------


    // Desktop Tab
    TabPanel tabbedAE;
    Panel tabDir;

    CPanel panelSrc;
    CPanel panelRight;
    TabPanel tabDst;
    PanelThumbnail panelThumbnail;
    PanelList panelList;
    PanelOutline panelOutline;
    PanelArchive panelArchive;

    // Desktop toolbar
    CPanel panelTool;
    DToolBar toolDir;
    DToolBar toolText;

    // Toolbar Dir
    DButton buttonSwap;
    DButton buttonLR;
    DButton buttonLocate;
    DButton buttonDirCompare;
    DButton buttonFileCopy;
    DButton buttonUnarc;
    DButton buttonExplorer;
    DButton buttonDirNew;
    DButton buttonDirOpen;

    // Toolbar Text
    DButton buttonTextNew;
    DButton buttonTextOpen;
    DButton buttonTextSave;
    //DButton buttonTextCut;
    //DButton buttonTextCopy;
    //DButton buttonTextPaste;
    DButton buttonTextFind;
    DButton buttonTextReplace;

    // Directory
    DirManager source;
    DirManager target;
    TreeManager treemanager;

    DButton buttonA;
    DButton buttonC;
    DButton buttonD;
    DButton buttonE;
    DButton buttonF;
    DButton buttonG;
    DButton buttonH;
    DButton buttonI;


    // Desktop Status bar
    DMessageBar statusbar;

    // Text viewer
    TextEditor editor;

    // Setup

    Panel tabSetup;
    String EdPrevious;

    // Image
    ImageViewer imageViewer;


    // Menu file
    MenuBar mainMenuBar;
    DMenu menuFile;
//	MenuItem miInfo;
    MenuItem miFileLocate;
//	MenuItem miRename;
    MenuItem miFileCopy;
    MenuItem miFileComp;
    MenuItem miFileSelectAll;
    MenuItem miFileSelectAny;
    MenuItem miCopyRen;
    MenuItem miCopyInDir;
    MenuItem miFile;
    MenuItem miExit;

    // menu dir
    DMenu menuDir;
    MenuItem miMake;
    MenuItem miDirCompare;
    MenuItem miCmpVersions;
    MenuItem miCmpContent;
    MenuItem miCmpFull;
    MenuItem miUpdate;
    MenuItem miSwap;
    MenuItem miDirExtend;

    DMenu menuZip;
    MenuItem miView;
    MenuItem miExtract;
    MenuItem miZip;

    // menu editor
    DMenu menuEdit;
    MenuItem miUndo;
    MenuItem miFind;
    MenuItem miFindAgain;
    MenuItem miReplace;
    MenuItem miSelectAll;
    MenuItem miNew;
    MenuItem miOpenText;
    //MenuItem miWrap;
    MenuItem miClose;
    MenuItem miInsert;
    MenuItem miSave;
    MenuItem miSaveAs;
    MenuItem miSaveBlock;


    DMenu menuWeb;
    MenuItem miThumbnail;
    MenuItem miListe;
    MenuItem miOutline;

    MenuDynamic tools;
    MenuItem miProgSearch;
    MenuItem miProgClear;
    MenuItem miFree;
    MenuItem miDOS;
    MenuItem miHistory;
    MenuItem miCalc;
    MenuItem miScan;
    MenuItem miExplorer;


    MenuDynamic references;
    MenuItem miTextClear;

    MenuDynamic recents;
    MenuItem miRecentClear;

    DMenu menuHelp;
    MenuItem miHelp;
    MenuItem miAbout;


     //  constructeur

    public ae()
    {
      int i;

      /*
        AboutDialog ad = new AboutDialog(this, "AE.Gif");
        ad.setString(VERSION + " " + RELEASE + " -  Free Program");
        ad.show();
        */

      Disp.it("Advanced Explorer - Scriptol.com");
      Disp.it("Java 1.3 / 1.4 version required, found: " + version);
      Disp.it("Loading user preferences");

      WINDOWS = OS.isWindows();

      boolean iniLoad = Preferences.Load();
      //Preferences.Disp();

      //PrgBackground = Preferences.PrgBg;
      PrgBackground = SystemColor.control;
      PrgForeground = Preferences.PrgFg;

      ColorList.changeColor("User", Preferences.UserColor);

      setBackground(PrgBackground);
      setForeground(PrgForeground);

      EdPrevious = Path.splitFile(Preferences.edName);
      Tool.setBeep(Preferences.Sound);

      //debug("listeners");

      //java.util.Properties.setProperty("user.dir", "\\");

      Action action         = new Action();
      DButtonAction dbAction = new DButtonAction();
      AEMainKeys AEKey = new AEMainKeys();
      SymComponent comlisten = new SymComponent();

      archiver = new Archiver();
      archiver.addActionListener(action);

      Disp.it("Building the user interface");

      Icons ic = new Icons();
      setIconImage(Icons.Save);

      setLayout(new BorderLayout());
      setVisible(false);

      dirtools.addActionListener(action);

      // Font & Button a taille optimise
      Dimension screen = getToolkit().getScreenSize();
      //System.out.println("Screen "  + screen.width + " x " + screen.height);

      int w = 800;
      int h = 559;
      int fSize = 18;
      int dWidth = 56, dHeight = 48;
      setLocation(50, 50);
      if(screen.width <= 1024)
      {
         fSize = 16; dWidth = 48; dHeight = 40;
      }
      if(screen.width <= 800)
      {
          fSize = 14; dWidth = 42; dHeight = 35;
          setLocation(0,0);
      }
      if(screen.width < 800)
      {
          w = 640; h = 439;
          dWidth = 36; dHeight = 30;  fSize = 12;
          setLocation(0,0);
      }

      //System.out.println("screen " +w + " x " + h);
      //System.out.println("insets l=" + getInsets().left + " r=" + getInsets().right + " t=" + getInsets().top + " b=" + getInsets().bottom );
       setSize(getInsets().left + getInsets().right + w, getInsets().top + getInsets().bottom + h);
      //System.out.println("set=" + (getInsets().left + getInsets().right + w) + " " + ( getInsets().top + getInsets().bottom + h));
      //Dimension d = getSize();
      //System.out.println("dim="+ d.width + " " + d.height);
      //System.out.println("but="+ dWidth + " " + dHeight);

      AEFont = new Font("Dialog", Font.PLAIN, fSize);
      AEBold = new Font("Dialog", Font.BOLD, fSize);
      Font tabFont = new Font("SansSerif", Font.PLAIN, fSize - 1);
      setFont(AEFont);

      DButton.setDefaultSize(dWidth, dHeight);
      DButton.setDefaultFont(AEFont);

      Tip.setParent(this);

      Font menuFont = AEFont;

      //debug("menus");

       mainMenuBar = new MenuBar();
       mainMenuBar.setFont(menuFont);

       menuFile = new DMenu("File");
       menuFile.setFont(menuFont);


       miFileLocate = new MenuItem("Find a file", new MenuShortcut(KeyEvent.VK_L));
       //miFileLocate = new MenuItem(menuLabel("Find a file", "Ctrl+L"));
       miFileLocate.addActionListener(action);
       miFileLocate.setFont(menuFont);
       menuFile.add(miFileLocate);

       menuFile.addSeparator();

       miFileCopy = new MenuItem("Copy", new MenuShortcut(KeyEvent.VK_C));
       miFileCopy.addActionListener(action);
       miFileCopy.setFont(menuFont);
       menuFile.add(miFileCopy);

       miCopyInDir = new MenuItem( "Copy inside dir", new MenuShortcut(KeyEvent.VK_D));
       miCopyInDir.addActionListener(action);
       miCopyInDir.setFont(menuFont);
       menuFile.add(miCopyInDir);

       miCopyRen = new MenuItem( "Copy and rename");
       miCopyRen.addActionListener(action);
       miCopyRen.setFont(menuFont);
       menuFile.add(miCopyRen);

       menuFile.addSeparator();

       miFileSelectAll = new MenuItem("Select all files");
       miFileSelectAll.addActionListener(action);
       miFileSelectAll.setFont(menuFont);
       menuFile.add(miFileSelectAll);

       miFileSelectAny = new MenuItem("Select all entries");
       miFileSelectAny.addActionListener(action);
       miFileSelectAny.setFont(menuFont);
       menuFile.add(miFileSelectAny);


       menuFile.addSeparator();

       miExit = new MenuItem(menuLabel("Exit", "         Alt+F4"));
       miExit.addActionListener(action);
       miExit.setFont(menuFont);
       menuFile.add(miExit);

       mainMenuBar.add(menuFile);
       menuDir = new DMenu("Dir");
       menuDir.setFont(menuFont);

       miSwap = new MenuItem("Swap dirs", new MenuShortcut(KeyEvent.VK_S));
       miSwap.addActionListener(action);
       miSwap.setFont(menuFont);
       menuDir.add(miSwap);

       miDirExtend = new MenuItem( "Use source for target");
       miDirExtend.addActionListener(action);
       miDirExtend.setFont(menuFont);
       menuDir.add(miDirExtend);

       menuDir.addSeparator();

       miDirCompare = new MenuItem("Compare names", new MenuShortcut(KeyEvent.VK_E));
       miDirCompare.addActionListener(action);
       miDirCompare.setFont(menuFont);
       menuDir.add(miDirCompare);

       miCmpVersions = new MenuItem("Compare versions");
       miCmpVersions.addActionListener(action);
       miCmpVersions.setFont(menuFont);
       menuDir.add(miCmpVersions);

       miCmpContent = new MenuItem("Compare data");
       miCmpContent.addActionListener(action);
       miCmpContent.setFont(menuFont);
       menuDir.add(miCmpContent);

       miCmpFull = new MenuItem("Compare any");
       miCmpFull.addActionListener(action);
       miCmpFull.setFont(menuFont);
       menuDir.add(miCmpFull);

       menuDir.addSeparator();

       miFileComp = new MenuItem("Tagged compare", new MenuShortcut(KeyEvent.VK_P));
       miFileComp.addActionListener(action);
       miFileComp.setFont(menuFont);
       menuDir.add(miFileComp);

       miUpdate = new MenuItem("Tagged update");
       miUpdate.addActionListener(action);
       miUpdate.setFont(menuFont);
       menuDir.add(miUpdate);


       menuDir.addSeparator();

       miMake = new MenuItem("Make dir", new MenuShortcut(KeyEvent.VK_K));
       miMake.addActionListener(action);
       miMake.setFont(menuFont);
       menuDir.add(miMake);

       mainMenuBar.add(menuDir);


       menuZip = new DMenu("Archive");
       menuZip.setFont(menuFont);
       menuZip.setFont(menuFont);

       miView = new MenuItem("View");
       miView.addActionListener(action);
       miView.setFont(menuFont);
       menuZip.add(miView);

       miExtract = new MenuItem( "Unarchive", new MenuShortcut(KeyEvent.VK_U));
       miExtract.addActionListener(action);
       miExtract.setFont(menuFont);
       menuZip.add(miExtract);

       miZip = new MenuItem( "Archive", new MenuShortcut(KeyEvent.VK_Z));
       miZip.addActionListener(action);
       miZip.setFont(menuFont);
       menuZip.add(miZip);


       mainMenuBar.add(menuZip);


        // Menu Edit
       menuEdit = new DMenu("Editor");
       menuEdit.setFont(menuFont);
       miUndo = new MenuItem(menuLabel("Undo", "Ctrl+Z"));
       miUndo.addActionListener(action);
       miUndo.setEnabled(false);
       miUndo.setFont(menuFont);
       menuEdit.add(miUndo);

       menuEdit.addSeparator();

       miFind = new MenuItem(menuLabel("Find", "Ctrl+F"));
       miFind.addActionListener(action);
       miFind.setEnabled(false);
       miFind.setFont(menuFont);
       menuEdit.add(miFind);

       miFindAgain = new MenuItem(menuLabel("Find again","F3"));
       miFindAgain.addActionListener(action);
       miFindAgain.setEnabled(false);
       miFindAgain.setFont(menuFont);
       menuEdit.add(miFindAgain);

       miReplace = new MenuItem( menuLabel( "Replace", "Ctrl+R"));
       miReplace.addActionListener(action);
       miReplace.setEnabled(false);
       miReplace.setFont(menuFont);
       menuEdit.add(miReplace);

       menuEdit.addSeparator();
	//miCut = new MenuItem("Cut");
	//miCut.addActionListener(dbAction);
        //miCut.setFont(menuFont);
	//menuEdit.add(miCut);

	//miCopy = new MenuItem("Copy");
	//miCopy.addActionListener(dbAction);
        //miCopy.setFont(menuFont);
	//menuEdit.add(miCopy);

	//miPaste = new MenuItem("Paste");
	//miPaste.addActionListener(dbAction);
	//miPaste.setFont(menuFont);
	//menuEdit.add(miPaste);
	//menuEdit.addSeparator();


	miSelectAll = new MenuItem("Select all");
	miSelectAll.addActionListener(action);
        miSelectAll.setEnabled(false);
        miSelectAll.setFont(menuFont);
	menuEdit.add(miSelectAll);

	menuEdit.addSeparator();

	miNew = new MenuItem("Create a blank text");
	miNew.addActionListener(action);
	miNew.setFont(menuFont);
	menuEdit.add(miNew);

	miOpenText = new MenuItem("Edit a text");
	miOpenText.addActionListener(action);
	miOpenText.setFont(menuFont);
	menuEdit.add(miOpenText);

        /*
	miWrap = new MenuItem(menuLabel("Wrap-around", "Ctrl+W"));
	miWrap.addActionListener(action);
	miWrap.setFont(menuFont);
	menuEdit.add(miWrap);
	*/

	miClose = new MenuItem("Close the text");
	miClose.addActionListener(action);
	miClose.setFont(menuFont);
	menuEdit.add(miClose);
	menuEdit.addSeparator();


	miInsert = new MenuItem( menuLabel("Insert a file", "Alt+I"));
	miInsert.addActionListener(action);
        miInsert.setEnabled(false);
	miInsert.setFont(menuFont);
	menuEdit.add(miInsert);

	menuEdit.addSeparator();

	miSave = new MenuItem(  menuLabel("Save", "Ctrl+S"));
	miSave.addActionListener(action);
        miSave.setEnabled(false);
	miSave.setFont(menuFont);
	menuEdit.add(miSave);

	miSaveAs = new MenuItem(   "Save as");
	miSaveAs.addActionListener(action);
        miSaveAs.setEnabled(false);
	miSaveAs.setFont(menuFont);
	menuEdit.add(miSaveAs);

	miSaveBlock = new MenuItem(menuLabel( "Save selection", "Alt+W"));
	miSaveBlock.addActionListener(action);
        miSaveBlock.setEnabled(false);
	miSaveBlock.setFont(menuFont);
	menuEdit.add(miSaveBlock);

	mainMenuBar.add(menuEdit);


        // Menu Tools
	menuWeb = new DMenu("Web pages");
	menuWeb.setFont(menuFont);

	miThumbnail = new MenuItem("Thumbnail");
        miThumbnail.addActionListener(action);
	miThumbnail.setFont(menuFont);
	menuWeb.add(miThumbnail);

	miListe = new MenuItem("File list");
        miListe.addActionListener(action);
	miListe.setFont(menuFont);
	menuWeb.add(miListe);

	miOutline = new MenuItem("Outlined text");
        miOutline.addActionListener(action);
	miOutline.setFont(menuFont);
	menuWeb.add(miOutline);

	mainMenuBar.add(menuWeb);

    	tools = new MenuDynamic("Tools", menuFont, Preferences.menuSize);
    	tools.addActionListener(action);
	mainMenuBar.add(tools);

	miProgSearch = new MenuItem("Search and add");
        miProgSearch.addActionListener(action);
        tools.add(miProgSearch);

	miProgClear = new MenuItem("Clear all");
        miProgClear.addActionListener(action);
        tools.add(miProgClear);

        tools.addSeparator();

        String temp;
        if(WINDOWS)
        {
          temp = "DOS window";
          Directory.root = "\\";
        }
        else
        {
          Directory.root = "/";
          temp = "Console";
        }
	miDOS = new MenuItem(temp);
        miDOS.addActionListener(action);
	miDOS.setFont(menuFont);
	tools.add(miDOS);

	miHistory = new MenuItem("Last messages", new MenuShortcut(KeyEvent.VK_H));
        miHistory.addActionListener(action);
	miHistory.setFont(menuFont);
	tools.add(miHistory);

        miFree = new MenuItem("Free memory");
	miFree.setFont(menuFont);
        if(DEBUG)
        {
          miFree.addActionListener(action);
	  tools.add(miFree);
	}

	miCalc = new MenuItem("Calculator");
	miCalc.setFont(menuFont);
        miCalc.addActionListener(action);
	if(WINDOWS) tools.add(miCalc);

	miScan = new MenuItem("Disk Scan");
        miScan.addActionListener(action);
	miScan.setFont(menuFont);
	if(WINDOWS) tools.add(miScan);

	miExplorer = new MenuItem("Explorer");
        miExplorer.addActionListener(action);
	miExplorer.setFont(menuFont);
	if(WINDOWS) tools.add(miExplorer);

        tools.addSeparator();
        //tools.add(new MenuItem("------ Associated programs ------"));

    	references = new MenuDynamic("References", menuFont, Preferences.menuSize);
    	references.addActionListener(action);
	mainMenuBar.add(references);

	miTextClear = new MenuItem("Clear all");
        miTextClear.addActionListener(action);
        references.add(miTextClear);

        references.addSeparator();

        //debug("recents");
    	recents = new MenuDynamic("Recents", menuFont, Preferences.menuSize);
    	recents.addActionListener(action);
	mainMenuBar.add(recents);

        //debug("clear");
        miRecentClear = new MenuItem("Clear all");
        miRecentClear.addActionListener(action);
        recents.add(miRecentClear);

        recents.addSeparator();

	menuHelp = new DMenu("   Help");
	menuHelp.setFont(menuFont);
	mainMenuBar.setHelpMenu(menuHelp);

	miHelp = new MenuItem("Manual       F1");
	miHelp.addActionListener(action);
	miHelp.setFont(menuFont);
	menuHelp.add(miHelp);

	miAbout = new MenuItem("About...");
	miAbout.addActionListener(action);
	miAbout.setFont(menuFont);
	menuHelp.add(miAbout);

	mainMenuBar.add(menuHelp);
	setMenuBar(mainMenuBar);

        //debug("menu passed");

        panelTool = new CPanel();
	panelTool.setBounds(getInsets().left + 0, getInsets().top + 0, 640, 38);
        add(panelTool, BorderLayout.NORTH);

	toolDir = new DToolBar();
    	toolDir.setBackground(PrgBackground);
	panelTool.add(toolDir, "");

	toolText = new DToolBar();
    	toolText.setBackground(PrgBackground);
	panelTool.add(toolText, "");

        panelTool.validate();

        // Message bar

        statusbar = new DMessageBar();
	statusbar.setBounds(getInsets().left + 0, getInsets().top + 446, 636, 16);
	add(statusbar, "South");
	statuscreated = true;


	tabbedAE = new TabPanel(TabPanel.TOP, Preferences.tabStyle);
	//tabbedAE.setBounds(getInsets().left + 0,getInsets().top + 40, 640, 415);
        tabbedAE.setBackground(PrgBackground);
	add(tabbedAE, "Center");

        // Panel de tab panel
        //debug("tabdir");

	tabDir = new Panel(new GridLayout(1,2));
        tabDir.addKeyListener(AEKey);
        tabDir.addComponentListener(comlisten);
        tabbedAE.addTabPanel("+File Manager", true, tabDir);

	editor = new TextEditor(this);
	editor.setVisible(false);
	//editor.setBackground(PrgBackground);
	editor.addActionListener(action);
	editor.addKeyListener(AEKey);
	editor.addComponentListener(comlisten);
	tabbedAE.addTabPanel(TextEditor.NoName, true, editor);

	tabSetup = new Panel(new GridLayout());
	tabSetup.setVisible(false);
	//tabSetup.setBackground(PrgBackground);
	tabSetup.addComponentListener(comlisten);
	tabbedAE.addTabPanel("+Options", true, tabSetup);


        // Panel source

        EmptyPanel panelLeft = new EmptyPanel(new BorderLayout());
        tabDir.add(panelLeft);

        DToolBar favopanel = new DToolBar(DBar.NONE);
        panelLeft.add(favopanel, BorderLayout.NORTH);

        panelSrc = new CPanel();
	panelSrc.setBackground(PrgBackground);
        panelLeft.add(panelSrc, BorderLayout.CENTER);

        panelRight = new CPanel();
        tabDir.add(panelRight);

	tabDst = new TabPanel(TabPanel.TOP, Preferences.tabStyle);
	tabDst.setBevel(TabPanel.NONE);
        tabDst.setBackground(PrgBackground);
        tabDst.setMargins(1,2,2,0);
        tabDst.addComponentListener(comlisten);
	panelRight.add(tabDst);

        panelThumbnail = new PanelThumbnail(this);
        panelThumbnail.addActionListener(action);
        panelRight.add(panelThumbnail);

        panelList = new PanelList(this);
        panelList.addActionListener(action);
        panelRight.add(panelList);

        panelOutline = new PanelOutline(this);
        panelOutline.addActionListener(action);
        panelRight.add(panelOutline);

        panelArchive = new PanelArchive(this);
        panelArchive.addActionListener(action);
        panelRight.add(panelArchive);

        panelRight.select(0);

        source = new DirManager(this, statusbar);
        source.addActionListener(action);
        source.addKeyListener(AEKey);
        source.addComponentListener(comlisten);
        source.setHistory(history);
        source.setArchiver(archiver);
        source.setUsage(DirManager.SOURCE);
        source.setTemporary(tempo);
        panelSrc.add(source);

        target = new DirManager(this, statusbar);
        target.addActionListener(action);
        target.addKeyListener(AEKey);
        target.addComponentListener(comlisten);
        target.setHistory(history);
        target.setUsage(DirManager.TARGET);
        target.setTemporary(tempo);
        tabDst.addTabPanel("Target", true, target);

        treemanager = new TreeManager(this, statusbar);
        treemanager.addActionListener(action);
        treemanager.addComponentListener(comlisten);
        tabDst.addTabPanel("Tree", true, treemanager);

	imageViewer = new ImageViewer();
        imageViewer.addActionListener(action);
	imageViewer.addComponentListener(comlisten);
	tabDst.addTabPanel("Image", true, imageViewer);

        aesetup = new AESetup(this,
        PrgBackground, AEFont, AEBold );
        aesetup.addActionListener(action);
        tabSetup.add(aesetup);
        aesetup.setMemory(mem);

	setTitle(" Advanced Explorer  " + VERSION + " - " + SITE);

        // Tool bar

	buttonSwap = new DButton(Icons.Swap, Icons.SwapGray);
	buttonSwap.setTip("Swap source and target");
	buttonSwap.addActionListener(dbAction);
	toolDir.add(buttonSwap);

	buttonLR = new DButton(Icons.LR, Icons.LRGray);
	buttonLR.setTip("Make source directory the target");
	buttonLR.addActionListener(dbAction);
	toolDir.add(buttonLR);

	buttonFileCopy = new DButton(Icons.FileCopy, Icons.CopyGray);
	buttonFileCopy.setTip("Copy the selection into target");
	buttonFileCopy.addActionListener(dbAction);
	toolDir.add(buttonFileCopy);

	buttonUnarc = new DButton(Icons.Unzip, Icons.UnzipGray);
	buttonUnarc.setTip("Extract tagged archive or selection inside");
	buttonUnarc.addActionListener(dbAction);
	toolDir.add(buttonUnarc);

	buttonLocate = new DButton(Icons.Locate);
	buttonLocate.setTip("Find a file or a directory");
        buttonLocate.addActionListener(dbAction);
	toolDir.add(buttonLocate);

	buttonDirCompare = new DButton(Icons.Dcomp, Icons.DCompGray);
	buttonDirCompare.setTip("Compare source and target lists");
	buttonDirCompare.addActionListener(dbAction);
	toolDir.add(buttonDirCompare);

	buttonExplorer = new DButton(Icons.Microsoft);
	buttonExplorer.setTip("Windows' Explorer");
        buttonExplorer.addActionListener(dbAction);
	if (WINDOWS) toolDir.add(buttonExplorer);


        toolDir.addSeparator(30, 36);
        //toolDir.add(new DSeparator(30, 36));

	buttonDirNew = new DButton(Icons.New);
	buttonDirNew.setTip("Create a blank text");
	buttonDirNew.addActionListener(dbAction);
	toolDir.add(buttonDirNew);

	buttonDirOpen = new DButton(Icons.Open);
	buttonDirOpen.setTip("Open a document");
	buttonDirOpen.addActionListener(dbAction);
	toolDir.add(buttonDirOpen);


	buttonTextNew = new DButton(Icons.New);
	buttonTextNew.setTip("Create a blank text");
	buttonTextNew.addActionListener(dbAction);
	toolText.add(buttonTextNew);

	buttonTextOpen = new DButton(Icons.Open);
	buttonTextOpen.setTip("Open a document");
	buttonTextOpen.addActionListener(dbAction);
	toolText.add(buttonTextOpen);

	buttonTextSave = new DButton(Icons.Save);
	buttonTextSave.setTip("Save the current document");
	buttonTextSave.addActionListener(dbAction);
	toolText.add(buttonTextSave);

        //toolText.addSeparator(30, 36);
        toolText.addSpacer(30, 36);

	//buttonTextCut = new DButton(Icons.Cut);
	//buttonTextCut.addActionListener(dbAction);
	//buttonTextCopy = new DButton(Icons.Copy);
	//buttonTextCopy.addActionListener(dbAction);
	//buttonTextPaste = new DButton(Icons.Paste);
	//buttonTextPaste.addActionListener(dbAction);

	buttonTextFind = new DButton(Icons.Search);
	buttonTextFind.addActionListener(dbAction);
	buttonTextFind.setTip("Find a string");
	toolText.add(buttonTextFind);

	buttonTextReplace = new DButton(Icons.Replace);
	buttonTextReplace.addActionListener(dbAction);
	buttonTextReplace.setTip("Replace a string");
	toolText.add(buttonTextReplace);


	buttonA = new DButton(true);
	buttonA.setLabel(Preferences.shortcut[0], true);
	buttonA.setTip("Shortcut for path");
        buttonA.addActionListener(dbAction);
	//source.addButton(buttonA);
	favopanel.add(buttonA);

	buttonC = new DButton(true);
	buttonC.setLabel(Preferences.shortcut[1], true);
	buttonC.setTip("Shortcut for path");
        buttonC.addActionListener(dbAction);
	favopanel.add(buttonC);

	buttonD = new DButton(true);
        buttonD.setLabel(Preferences.shortcut[2], true);
	buttonD.setTip("Shortcut for path");
        buttonD.addActionListener(dbAction);
	favopanel.add(buttonD);

	buttonE = new DButton(true);
	buttonE.setLabel(Preferences.shortcut[3], true);
	buttonE.setTip("Shortcut for path");
        buttonE.addActionListener(dbAction);
	favopanel.add(buttonE);

	buttonF = new DButton(true);
	buttonF.setLabel(Preferences.shortcut[4], true);
	buttonF.setTip("Shortcut for path");
        buttonF.addActionListener(dbAction);
	favopanel.add(buttonF);

	buttonG = new DButton(true);
	buttonG.setLabel(Preferences.shortcut[5], true);
	buttonG.setTip("Shortcut for path");
        buttonG.addActionListener(dbAction);
	favopanel.add(buttonG);

	buttonH = new DButton(true);
	buttonH.setLabel(Preferences.shortcut[6], true);
	buttonH.setTip("Shortcut for path");
        buttonH.addActionListener(dbAction);
	favopanel.add(buttonH);

 	buttonI = new DButton(true);
	buttonI.setLabel(Preferences.shortcut[7], true);
	buttonI.setTip("Shortcut for path");
        buttonI.addActionListener(dbAction);
	favopanel.add(buttonI);

        setTextStyle();
        setDirStyle();
        setTreeStyle();
        setMessageStyle();


	this.addWindowListener(this);

        filecopy.addActionListener(action);

        // Chargement des mmoires
        // Affecte Src/Dst Path
        Disp.it("Loading lists to fill memories");

        mem.srcPath = AEDir;
        mem.dstPath = AEDir;
        mem.setComponents(source.combo, target.combo,
                          tools.dynList,
                          references.dynList,
                          recents.dynList,
                          aesetup.cards,
                          aesetup.comboExt,
                          aesetup.comboAss);

        if(!iniLoad)
        {
          tabbedAE.select(tabTextNo);
          editor.setPath(AEDir, "install.txt");
          editor.open();
        }
        else
        {
          tabbedAE.select(0);
        }

        mem.load(AEDir);


        source.setArcSort(Preferences.ArcSort);
        target.setArcSort(Preferences.ArcSort);
        String s;
        s = mem.srcPath;
        if(s.startsWith("a:")) s = "c:\\";
        setSrcPath(s);
        s = mem.dstPath;
        if(s.startsWith("a:")) s = "c:\\";
        setDstPath(s);

         //source.dir.setImageMask(Preferences.Multimedia);

        //debug("restore");
        tools.restore();
        references.restore();
        recents.restore();

       	// Champs

        editor.setMessage(statusbar);
        editor.setHistory(history);
// MENU
// Preferences et composants dpendants

       System.out.println("Reading directories");

       maskAll();
       dirmask = true;
       unmaskSome();


       source.setSelected(0);
       source.requestFocus();

       panelSrc.first();
       tabDst.select(Preferences.panelTarget);
       aesetup.setTab(new Integer(mem.SetupPanel).intValue());

       panelTool.showPanel(toolDir);


       source.setPopupParent(tabDir, AEFont);
       target.setPopupParent(tabDst, AEFont);
       source.combo.setPopupParent(AEFont);
       target.combo.setPopupParent(AEFont);

       target.miCopy.setEnabled(false);
       target.miUnarc.setEnabled(false);
       //debug("constructor passed");

  } // fin constructor


	public ae(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		super.show();
		SrcFocus();
	}

   // Colors

   static Color PrgBackground;
   static Color PrgForeground;



   static public void main(String args[])
   {
     Frame aemain = new ae();
     aemain.setVisible(true);
   }

   public void addNotify()
    {
      // Record the size of the window prior to calling parents addNotify.
       Dimension d = getSize();

       super.addNotify();

       if (fComponentsAdjusted) return;

	// Adjust components according to the insets
	setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
	Component components[] = getComponents();
	for (int i = 0; i < components.length; i++)
	{
		Point p = components[i].getLocation();
		p.translate(getInsets().left, getInsets().top);
		components[i].setLocation(p);
	}
	fComponentsAdjusted = true;

   }

    // Used for addNotify check.
    boolean fComponentsAdjusted = false;

    void addNotify(boolean state)
    {
      fComponentsAdjusted = state;
      addNotify();
    }



  void Exit_Action()
  {
   if(editor.saveBefore() == CANCEL ) return;
   if(source.dir.zipMode) source.parent();
   if (tempo != null)
   {
     tempo.kill();
     tempo = null;
   }

   System.gc();

   if(Preferences.SaveMemory)
   {
     mem.srcPath = source.getPath();
     mem.dstPath = target.getPath();
     mem.save(AEDir);
   }

  if(Preferences.AutoSave) Preferences.Save();

    //source.requestFocus();
    //source.
     setVisible(false);		     // hide the Frame
     dispose();	     // free the system resources
     System.exit(0);   // close the application
  }


  void About()
  {
    AboutDialog ad = new AboutDialog(this);
    ad.setRelease(RELEASE, VERSION);
    ad.setVisible(true);
  }



   void Explorer()
   {
     String dir;
     DirManager dirman;

     if(tabDst.getTab() == 1) // A partir de tree
     {
	    dir = treemanager.getSelected();
     }
     else
     {
       if (srcSelected()) dirman = source;
       else dirman = target;

       dir = dirman.getSelected();
       if(dir == null || (dirman.getSelectedIndex() >= dirman.firstFile()))
       dir =  "";
       dir = Path.merge(dirman.getDir(), dir);
     }

     dirtools.Run("explorer.exe ", dir, false);
     return;
   }

//------------------------------------ Web


  // Demande avant de remplacer le fichier temporaire

  boolean webPrompt(String name)
  {
   if(Preferences.AskHtml == false) return true;

   String path = Path.merge(target.getDir(), name);
   File dst = new File(path);

   if(dst.exists())
   {
      DialogCYN ask = new DialogCYN(this, path + " exists, replace?");
      ask.show();
      return(ask.answer == DialogCYN.YES);
   }

   return true ;
  }

  void indexAction()
  {
   String dir = source.getDir();
   HtmlList t;
   t = new HtmlList(dir, source.getTaggedItems());

   if (!webPrompt(panelList.htmlName)) return;
   String dest = panelList.htmlDir;
   t.setFile(dest, panelList.htmlName);

   int num = t.createHtml();
   Message(num + " names found");
   if(num > 0)
   {
     associate(t.htmlFile, t.htmlName, false);
     if(srcis(dest)) SrcDisp();
     if(dstis(dest)) DstDisp();
   }
  }


  void outlineAction()
  {
   String srcdir = source.getDir();
   String srcname;

   if(srcSelected()) srcname = source.getSelected();
   else if(source.isTagged()) srcname = source.getTagged();
   else
   {
     beep();
     Message("Select a text to convert, please.");
     return;
   }

   Outline t = new Outline(srcdir, srcname);

   String dstName = panelOutline.htmlName;
   String dstDir = panelOutline.htmlDir;
   if (!webPrompt(dstName)) return;
   t.setFile(dstDir, dstName);

   int size = t.createHtml();

   if(size > 0)
   {
     associate(t.htmlFile, t.htmlName, false);
     if(srcis(dstDir)) SrcDisp();
     if(dstis(dstDir)) DstDisp();
   }
   Message("Generated " + t.htmlFile + " " + size + " lines");
  }


  void thumbnailAction()
  {
   String dir = source.getDir();
   int start  = source.dir.MAXINDIRS;

   Dimension screen = getToolkit().getScreenSize();
   Thumbnail t = new Thumbnail(screen, source.dirList, start, dir);

   if (!webPrompt(panelThumbnail.htmlName)) return;

   String gendir = panelThumbnail.getDir(source.getDir());
   t.setFile(gendir, panelThumbnail.htmlName);

   int num = t.createHtml();
   if(num > 0)
   {
     associate(t.htmlFile, t.htmlName, false);
     if(srcis(gendir)) SrcDisp();
     if(dstis(gendir)) DstDisp();
   }
   Message(t.getFile() + " created with " + num + " images");
  }



//--------------------------------- Fonctions des listeners

   void MakeSrc(boolean mode)
     {
       source.setPath(treemanager.getSelected());
       source.dirDisp(true);
     }



   void setPath(String dir, String fic)
   {
     m_dirName = dir;
     m_fileName = fic;
     m_pathName = Path.merge(m_dirName, m_fileName);
   }

   void setPath(String dir)
   {
     m_dirName = dir;
     m_fileName = "";
     m_pathName = dir;
   }


    // Manuel
  void manual()
  {
     String extension;

     if (aesetup.hasHtml())
       extension = ".html";
     else
     {
       extension = ".txt";
       if(editor.savePrevious()) return;
     }

     String name = Preferences.LangFile[Preferences.Language] + extension;
     Message("Loading manual: " + AEDir + name);
     source.openPath(Path.merge(AEDir, name), name, false, false);
   }




//---------------------------------------- TEXT FILES

    void newText()
    {
      //setPath(srcdir.getDir(), "Untitled");
      editor.setPath(source.getDir(), TextEditor.NoName);

      if(editor.newText())
        {
         changeTextTab();   // Change tab
         displayText();
         Message("New empty document created");
        }
      else
         dispTip("Cancelled");
   }

   /** Fermeture du texte en mmoire */
   void closeText()
    {
       if(editor.close())
       {
        editor.setPath(null, TextEditor.NoName);
        changeTextTab();   // Change tab
        setPath(null, null);
        Message("Document closed");
       }
    }

    /** Charge avec la boite de dialogue */
   void openTextDialog(boolean editflag)
   {
      if(editor.savePrevious()) return;

      FileDialog openDialog = new FileDialog(this, "Open", FileDialog.LOAD);
      openDialog.show();
      setPath(openDialog.getDirectory(), openDialog.getFile());

      if (editflag == false)
      if(associate(m_pathName, m_fileName, true)) return;

      openText(m_pathName, m_fileName, true);
   }


  void setModified()
   {
     String origin = editor.getDir();
     if (dstis(origin)) target.modified = true;
     if (srcis(origin)) source.modified = true;
   }


   void saveAs()
    {
     if(editor.saveAs())
      {
        changeTextTab();    // change TextName
        displayText();
        updateConditional(editor.UpdateDir);
      }
    }



   /** lecture texte avec choix de programme (wordpad, etc....) */

   void openText(String path, String name, boolean addit)
   {
    //path = path.toLowerCase();

    if(Preferences.EditorAss) { openWordpad(path, addit); return; }
    if(editor.savePrevious()) return;

    m_pathName = path;
    m_fileName = name;
    m_dirName  = Path.getPath(path);
    //debug("open " + path);

    File f = new File(m_pathName);
    if (!f.exists())
    {
     dispTip("File not found " + m_pathName);
     return;
    }
    long len = f.length();
    if (len == 0)
    {
      dispTip("Size is " + len + " character...");
      return;
    }
    if(!openViewer(addit))
     {
      openWordpad(path, addit);
      return;
     }
 }


   boolean openViewer(boolean addit)
   {
    Message("Reading " + m_pathName);
    editor.setPath(m_dirName, m_fileName);

    if(!editor.open())
     {
       setPath(null, null);
       editor.setPath("", TextEditor.NoName);
       changeTextTab();
       return false;
     }

    changeTextTab();
    //debug("open viewer " + addit);
    if(addit) addRecents(m_dirName, m_fileName);
    tabbedAE.select(tabTextNo);

    return true;
   }


 void openWordpad(String path, boolean addit)
 {
   if(dirtools.LaunchPrgFile(Preferences.edName, path))
   {
      if(addit) addRecents(m_dirName, m_fileName);
   }
 }





  String extGraphic = ".gif.jpg.jpe.png.";
  String extUnsupported = ".ico.tga.pic.tiff.bmp.wmf.";
  String extSound = ".wav.au.";

  void processAny(DirManager dirman, String command, boolean addit)
  {
   String path = dirman.m_pathName;
   String name = dirman.m_fileName;
   String ext = Path.getExtension(name);

   if (command.equals("assoc"))
    {
     if(associate(path, name, addit))
      {
       dirman.associated = true;
       return;
      }
    }

   if (command.equals("graph"))
   {
     //debug("main graph");
     if (DirManager.inside(extGraphic, ext))
      {
        display(path, name, true);
       //debug("open viewer " + addit);
        return;
      }
     if (DirManager.inside(extUnsupported, ext))
      {
        dispTip(ext + " format not supported");
        return;
      }

   }

   if (command.equals("sound"))
    {
      if (DirManager.inside(extSound, ext))
       {
        dirtools.sound(path, name);
        return;
       }
    }

   /*
   if (command.equals("run"))
    {
      source.executable(path, name);
    }
   */
   if (command.equals("addprg")) { addPrograms(); return; }
   if (command.equals("adddoc")) { addReferences(); return; }

   if (command.equals("text"))
   {
     openText(path, name, addit);
     return;
   }

   dispTip("Command not processed");
  }


  /*
      Process dynamic menu: tools, references.
  */

  void actionDynamic(FileList fl, String com)
  {
    int numero = (new Integer(com)).intValue();
    String dir = fl.getDir(numero);
    String name = fl.getName(numero);
    setPath(dir, name);
    String extension = Path.getExtension(name);

    //debug("path " + m_pathName);
    //System.out.println("ext=" + extension);

    if(DirManager.inside(DirManager.graflist, extension))
    {
     tabbedAE.setPanel(0);
     display(m_pathName, name, false);
     return;
    }

    if (DirManager.inside(DirManager.soundlist, extension))
    {
      dirtools.sound(m_pathName, name);
      return;
    }

    if(associate(m_pathName, name, false))  return;

    //debug("text");
    openText(m_pathName, name, false);
    return;
  }




   /** Lance un fichier avec le prog associe  son extension */

   boolean associate(String path, String name, boolean addit)
   {
     //int size = comboExt.countItems();
     String ext = Path.getExtension(name);
     //debug(ext);

     int index = aesetup.comboExt.search(ext);
     if(index == -1) return false;
     if(aesetup.enableAss[index] == false) return false;

     String prog = aesetup.comboAss.getListText(index);

     //debug("launch prog file " + prog + " " + path);

     if(dirtools.LaunchPrgFile(prog, path))
     {
       //debug("ass addit " + addit);
       if(addit) addRecents(path, name);
     }

     return true;
   }


 void swapDirs()
 {
   String left  = source.getDir();
   String right = target.getDir();

   int dsel = target.getSelectedIndex();
   int ssel = source.getSelectedIndex();
   setSrcPath(right);
   setDstPath(left);
   SrcDisp();
   DstDisp();

   dispTip("Source and destination swapped");
   source.showIt(dsel);
   target.showIt(ssel);
   source.requestFocus();
 }


   /** Compare noms/versions/donnes */

   final int CMPLIST = 0;
   final int CMPANY  = 1;
   final int CMPVERSION = 2;
   final int CMPCONTENT = 3;


   public void compare(int MODE)
    {
     int found = 0;
     int nofound;
     int diff = 0;

     String[] mode = { "lists, " , "any, ", "versions, ", "data, " };

     String src[] = source.getListItems();
     String dst[] = target.getListItems();
     boolean select;

     dispTip("Comparing source and target lists...");
     source.setPainting(false);
     source.deselectAll();

     setCursor(new Cursor(Cursor.WAIT_CURSOR));

     int srcSize = source.countItems();

     for(int s = 0; s < srcSize; s++) // pour chaque source
     {
      select = (MODE <= CMPANY);

      for(int d = 0; d < target.countItems(); d++) // compare chaque dest
       {
        if(Path.equals(src[s], dst[d])) // mme nom
        {
          // test sur nom, select false
          if (MODE != CMPLIST)
           {
            select = true;
            String sf = Path.merge(source.getDir(), src[s]);
            String df = Path.merge(target.getDir(), dst[d]);

            if (MODE == CMPVERSION) // passe si date plus rcente
            {
              if (Path.newVersion(sf, df)) break; // nouveau, passe
            }
            else // taille ou contenu
            {
              if (!DirTools.compare(sf, df)) break;  // diffrents, passe
            }
           }

          found++;
          select = false; // identiques, annule slection
          break;
        }
      } // for

      if(select)
      {
       source.selectMultiple(s);
       if (MODE > CMPANY) diff++;
      }
     }

     String cmessage = "";
     nofound = srcSize - found;
     switch(MODE)
     {
      case CMPLIST:
      case CMPANY:
                   cmessage = "Comparing " + mode[MODE] + found +"/" + srcSize + " matches and " + nofound + " no found or different";
                   if (nofound > 0) cmessage = cmessage + " and tagged";
                   break;
      case CMPVERSION:
      case CMPCONTENT:
                   int all = found + diff;
                   cmessage = "Comparing " + mode[MODE] + found + "/" + all + " identical, " + diff + " different";
                   if (diff > 0) cmessage = cmessage + " and tagged";
                   break;
     }

    Message(cmessage);
    source.setPainting(true);
    source.update(false);
    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

   }


    boolean srcSelected() { return source.isSelected(); }
    boolean dstSelected() { return target.isSelected(); }
    boolean dstTagged() { return target.isTagged(); };

    int whatWindow()
    {
     boolean src = source.isSelected();
     boolean dst = target.isSelected();

     if (src && !dst) return 0;
     if (!src && dst) return 1;
     return -1;
    }

    int whichWindow()
    {
     int i = whatWindow();
     if (i == -1)
     {
      dispTip("Select files ever in source or target window");
      beep();
     }
     return i;
    }




    void processEdit(DirManager dirman)
    {
      String  dir  = dirman.getDir();
      String  name = dirman.getSelected();
      openText(Path.merge(dir, name), name, true);
    }



 /** Creation de sous-rpertoire */
 void Make()
 {
  int win = whichWindow();
  if (win == -1) return;

  String mode[] = new String[2];
  mode[0] = "source";
  mode[1] = "target";
  String title = "Creating a sub-directory in " + mode[win];

  if (win == 1) target.make(title);
  else          source.make(title);
 }


  /** Lancer un outil, avec ou sans fichier */

  void actionProgram(int numero)
  {
    int w = whatWindow();

    String prog = tools.get(numero);
    String progname = tools.getName(numero);

    if(w == -1)
    {
     dirtools.Launch(prog, progname);
     return;
    }

   String name = null;
   String dir = null;
   if (w == 0)
   {
    dir = source.getDir();
    name = source.getSelected();
   }
   if (w == 1)
   {
    dir = target.getDir();
    name = target.getSelected();
   }
   Message("Launching " + prog + " with " + name);
   dirtools.LaunchPrgFile(prog, Path.merge(dir, name));

  }


  void shortcut(int number)
  {
    setSrcPath(Preferences.longpath[number]);
    SrcDisp();
  }

    // FILE


    /** Trouve et ouvre un fichier */

    void Locate()
    {
       LocateDialog ld = new LocateDialog(this, LocatePrevious);
       ld.setCurDrive(source.getDrive());
       ld.setVisible(true);

       //debug("result=" + ld.result);

       LocatePrevious = Path.splitFile(ld.getInput());

       if(ld.result == LocateDialog.GO)
       {
        setSrcPath(ld.dirfound);
        source.dirDisp(true);
        source.setSelected(ld.filefound, true);
        source.requestFocus(); // ne pas slecter le 0
        return;
       }

       if(ld.result == LocateDialog.OPEN)
       {
         //debug(ld.dirfound + " " + ld.filefound);
         OrigineIsSrc = true;
         setPath(ld.dirfound, ld.filefound);

         tabbedAE.select(tabDirNo);

         source.makePath(ld.dirfound, ld.filefound);
         source.openCommon(true);
         source.requestFocus();
       }

    }




    /** Copie de fichier */

    void messageInDir()
     {
      dispTip("Select a directory in target to copy into");
      beep();
      return;
     }

    /**
        inside = copie dans un rpertoire non ouvert
    */
   void fileCopy(boolean inside)
   {
      boolean success = true;
      String destdir = null;
      String lastname = "";

     // il faut eviter le double
      if (editor.isVisible()) return;
      if (!source.testSelected(0)) return;

      if (inside)
       {
         if(dstTagged() && target.isDir())
          {
            destdir = target.getTagged() ;
          }
         else
         {
            messageInDir();
            return;
         }
      }

      String fics[] = source.getSelectedItems();
      int i = 0;
      boolean test = true;
      String origine = Path.noSuffixed(source.getDir());
      String destination = Path.noSuffixed(target.getDir()); // Format target != format list
      String child = "";

      if (destdir != null)
      {
         destination = Path.merge(destination, destdir);
      }

      int copied = 0;

      if(fics.length == 0)  { source.noSelected(); return; }

      if (Path.isDrive(destination)) child = Directory.root;
      File fdest = new File(destination, child);
      //FileCopy fc = new FileCopy(this);

      setCursor(new Cursor(Cursor.WAIT_CURSOR));

      while(test == true)
        {
         String fic = null;
         try { fic = fics[i]; }
         catch(ArrayIndexOutOfBoundsException e) { test = false; }

         if(test == true)
         {
          File forig = new File(origine, fic);
          try
          {
           lastname = forig.getName();

           copied += filecopy.copy(forig, fdest);
           if(filecopy.cancel) test = false;
           if(filecopy.success())
           {
             if (destdir == null) DstDisp();
             SrcFocus();
           }
           else success = false;
          } catch(java.io.IOException e) {  e.printStackTrace();  };

          i++;
         } // fin if test
        } // fin while


     setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

     String name = null;
     if (copied > 1)
       name = copied + " files";
     else
       name = lastname;

     Message(name + " copied    into " + destination);

     if(!success)
      {
       (new DialogMessage(this, "Error, copy failed!")).show();
      }
      setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
   }



   void CopyRename()
   {
        String fic = source.getSelected();
        String newName;
        String oldName;
		int fnum[] = source.getSelectedIndexes();
        int first = source.getSelectedIndex();

        if(fnum.length == 0) { source.noSelected(); return;  }

	if(fnum.length > 1)
	{
	  dispTip("Select a single file or dir, please");
	  beep(); return;
	}

	//int i = 0;
	//boolean test = true;
	String origine = Path.noSuffixed(source.getDir());
        String destination = Path.noSuffixed(target.getDir()); // Format target != format list

        Input ren = new Input(this);
        ren.setTitle("New name");
        ren.setLabel("Type the new name:");
        ren.setInput(fic);
        ren.show();

        if(!ren.ok())
        {
          Message("Cancelled");
          return;
        }

        File forig = new File(origine, fic);
        File fdest = new File(destination);
        newName = ren.getInput();
        oldName = forig.getName();

        try
        {
         dispTip(oldName + " copied as " + newName + " into " + destination + ", waiting...");
         //FileCopy fc = new FileCopy(this);
         int copied = filecopy.copyRename(forig, fdest, newName);
         if(filecopy.success())
         {
           DstDisp();
           if(synchro())
           {
             source.dirDisp(false);
             source.setSelected(first);
           }
           Message(oldName + " copied as " + newName + " into " + destination);
           SrcFocus();
         }
         else
           Message("Enable to copy " + oldName + " as " + newName);
        }
        catch(java.io.IOException e) { e.printStackTrace(); };
	}


    /** Comparing tagged files/dirs */

    void compareTagged()
    {
      String fics[] = source.getSelectedItems();
      if(fics.length == 0) { source.noSelected(); return;}

      String origine = Path.noSuffixed(source.getDir());
      String destination = Path.noSuffixed(target.getDir()); // Format target != format list

      DialogCompare cd = new DialogCompare(this, false);
      cd.source = origine;
      cd.target = destination;
      cd.theList = fics;
      cd.setSource(origine+"[Tagged entries]");
      cd.setTarget(destination);
      cd.statusBar = this.statusbar;
      cd.result = "Comparing tagged entries";
      cd.show();

      DirTools.occupation(origine, fics, DirTools.SELECT);
      cd.setResult(DirTools.fileNumber + " files to verify, " + DirTools.fileSize + " "+
        DirTools.base);
      cd.labelComp.setText("Press START");

      Message(cd.result);
//      Message(DirTools.treeComp(this, origine, destination, fics));
    }

    void updateTagged()
    {
      String fics[] = source.getSelectedItems();
      if(fics.length == 0) { source.noSelected(); return;}

      String origine = Path.noSuffixed(source.getDir());
      String destination = Path.noSuffixed(target.getDir()); // Format target != format list

      DialogUpdate cd = new DialogUpdate(this, false);
      cd.source = origine;
      cd.target = destination;
      cd.theList = fics;
      cd.setSource(origine+"[Tagged entries]");
      cd.setTarget(destination);
      cd.statusBar = this.statusbar;
      cd.result = "Updating tagged directories and files";
      cd.show();

      DirTools.occupation(origine, fics, DirTools.SELECT);
      cd.setResult(DirTools.fileNumber + " files to update, " + DirTools.fileSize + " "+
        DirTools.base);
      cd.labelComp.setText("Press the Update button");

      Message(cd.result);
//      Message(DirTools.treeComp(this, origine, destination, fics));
    }




     void console()
     {
       if (WINDOWS)
       {
         dirtools.console(source.getDir());
         return;
       }

       dirtools.Run("", null, false);
     }


  //---------------------------------------- Rpertoires

  public boolean synchro()
  {
    return srcis(target.getDir());
  }
  public boolean srcis(String path)
  {
    if (OS.isWindows()) return source.getDir().equalsIgnoreCase(path);
    return source.getDir().equals(path);
  }
  public boolean dstis(String path)
  {
    if (OS.isWindows()) return target.getDir().equalsIgnoreCase(path);
    return target.getDir().equals(path);
  }

  //  Affiche rpertoire source
  public void SrcDisp()
  {
    //debug("AE SrcDisp() ");
    source.dirDisp(false);
  }
  public void DstDisp()
   {
    if (target.isVisible()) target.dirDisp(false);
    else target.modified = true;
   }

  //  Affiche le Src et aussi le Dst si identique
  void SrcRedisp() { SrcDisp(); if(synchro())  DstDisp(); }
  void DstRedisp() { DstDisp(); if(synchro())  SrcDisp(); }

  // Changer de rpertoire
  void SrcFocus()
  {
    target.deselectAll();
    source.requestFocus();
  }
  void DstFocus()
  {
    target.requestFocus();
  }

  void setSrcPath(String str)
   {
     if(str == null) str = AEDir;
     source.setPath(str);
   }

  void setDstPath(String str)
   {
     if(str == null) str = AEDir;
     target.setPath(str);
   }

  // Mise  jour demande aprs sauvegarde
  void updateConditional(String path)
  {
    path = Path.getPath(path);
    if(srcis(path)) source.modified = true;
    if(dstis(path)) target.modified = true;
  }

  public void changeTextTab()
  {
   editor.changeName();
   tabbedAE.setTab(editor.TextName, true, tabTextNo);
  }

  public void displayText()
  {
    tabbedAE.select(tabTextNo);
  }



 /** Entre slectionne dans un des deux rpertoires */
  boolean getSelection(boolean mflag)
   {
	String path = null;
	String name = null;

    if (srcSelected())
      {
	    path = source.getDir();
	    name = source.getSelected();
      }

	if(name == null)
	  {
	   if (dstSelected())
	   {
	    path = target.getDir();
	    name = target.getSelected();
	   }
	  }

     if(name == null)
	  {
	   if (mflag) dispTip("Select a file");
	   debug("name " + name + " return false");
	   return false;
	  }

	 m_dirName = path;
	 m_fileName = name;
	 return true;
    }


//----------------------------------------------  Archives



 /** Unzip */

 void unArchive()
 {
   if(source.unArchive(target.getDir())) target.dirDisp(true);
   if (synchro()) { source.refresh(true); }
   SrcFocus();
 }


//---------------------------------------------------- Desktop / Bureau


   void setTextStyle()
   {
     Preferences.TextStyle.makeColors();
     Preferences.TextStyle.makeFont();
     editor.setStyle(Preferences.TextStyle);
   }

   void setDirStyle()
   {
     Preferences.DirStyle.makeColors();
     Preferences.DirStyle.makeFont();
     Style s = Preferences.DirStyle;
     source.setStyle(s);
     target.setStyle(s);
   }


  void setTreeStyle()
  {
     Preferences.TreeStyle.makeColors();
     Preferences.TreeStyle.makeFont();
     treemanager.setStyle(Preferences.TreeStyle);
  }


  void setMessageStyle()
  {
     Preferences.MessageStyle.makeColors();
     Preferences.MessageStyle.makeFont();
     statusbar.setStyle(Preferences.MessageStyle);
  }




  //----------------------------------------------------- Image

  public void display(String path, String name, boolean addit)
   {
       dispTip("Loading " + name + "...");
       if(addit) addRecents(path, name);

       System.gc();

       if (Preferences.Direct)
       {
        Image img = getToolkit().getImage(path);

        MediaTracker tracker = new MediaTracker(this);
        tracker.addImage(img, 0);
        try { tracker.waitForAll(); }
         catch(InterruptedException e) { }

        Splash ad = new Splash(this, img);
        ad.show();
        ad.requestFocus();
       }
       else
       {
       tabDst.select(noViewer);
       if(Preferences.Scale)
         imageViewer.setImage(path, ImageViewer.SCALED);
       else
       {
         imageViewer.setImage(path);
         imageViewer.setStyle(ImageViewer.CENTERED);
       }

       imageViewer.name = name;

       if (name.length() > 20)
       {
        int stt = Math.max(0, name.length() - 17);
        name = "..." + name.substring(stt);
       }
       //debug("dst " + name);
       tabDst.setLabel(name, noViewer);
       displayFlag = true;
      }
    }

   void actionFull()
   {
      Image img = imageViewer.getImage();
      Splash ad = new Splash(this, img);
      ad.show();
   }

   void imageMessage()
   {
     if(imageViewer.name != null)
     {
     int OW = imageViewer.originW;
     int OH = imageViewer.originH;
     int W  = imageViewer.imageW;
     int H  = imageViewer.imageH;
     String mess;

     if((OW != W) || (OH != H))
       mess = imageViewer.name + " originally was " + OW + "x" + OH +", scaled to " + W + "x"+ H;
     else
       mess = imageViewer.name + ", width " + W + ", height " + H;
      if(displayFlag) Message(mess);
      else dispTip(mess);
      displayFlag = false;
      return;
    }


     dispTip("Image viewer");
   }


 //------------------------------------------------ Menus dynamiques



  void progAddDyn(String m_dirName, String m_fileName)
  {
    if(tools.addDynamic(m_dirName, m_fileName))
     Message("Added " + m_fileName + " to the list of programs");
    else beep();
  }

  void addPrograms()
   {
    if(!dirmask) return;
    if(!getSelection(true)) return;
    if(m_fileName == null || m_fileName == "") { source.noSelected(); return; }
    progAddDyn(m_dirName, m_fileName);
  }


  void progSearch()
   {
    if(!dirmask) return;

    LocateDialog ld = new LocateDialog(this);
    ld.setCurDrive(source.getDrive());
    ld.show();

    //LocatePrevious = Path.splitFile(ld.getInput());
    if(ld.result > 0)
      progAddDyn(ld.dirfound, ld.filefound);
  }



  void addReferences()
   {

    if(dirmask)
    {
       if(!getSelection(true)) return;
    }
    else
    if(editmask)
    {
     m_dirName  = editor.TextDir;
     m_fileName = editor.TextName;
    }

    if(m_fileName == null || m_fileName == "") { source.noSelected(); return; }

    recents.remove(m_dirName, m_fileName);   // enlve de la liste des rcents

    if(references.addDynamic(m_dirName, m_fileName))
     Message("Added " + m_fileName + " to the list of documents");
    else
     beep();
  }

  /** Ajoute menu */
  void addRecents(String dir, String name)
  {
    dir = Path.getPath(dir);
    if(recents.already(dir, name)) return;
    recents.addDynamic(dir, name);
  }

  /* Id avec noms en param */
  void addRecents()
  {
   addRecents(editor.TextDir, editor.TextName);
  }



 //------------------- JEUX DE MASQUES et AFFICHAGE

 void maskAll()
 {
   dirmask = false;
   editmask = false;
   imagemask = false;
   setupmask = false;
 }

 void unmaskSome()
 {
    buttonSwap.setEnabled(dirmask);
    buttonLR.setEnabled(dirmask);
    buttonFileCopy.setEnabled(dirmask);
    buttonUnarc.setEnabled(dirmask);
	buttonLocate.setEnabled(true);
    buttonDirCompare.setEnabled(dirmask);

    buttonTextSave.setEnabled(editmask);
    buttonTextFind.setEnabled(editmask);
    buttonTextReplace.setEnabled(editmask && editor.Editable);

    menuFile.setEnabled(dirmask);
    menuDir.setEnabled(dirmask);
    menuZip.setEnabled(dirmask);
    menuWeb.setEnabled(dirmask);

    miFileCopy.setEnabled(dirmask);

  }

  void tabDir_componentHidden(java.awt.event.ComponentEvent event)
  {
    miProgSearch.setEnabled(false);
    miFileLocate.setEnabled(false);
//  miFileSize.setEnabled(false);
    miSwap.setEnabled(false);
   }

 void tabDir_componentShown(java.awt.event.ComponentEvent event)
 {
      dispTip("Directory");

      maskAll();
      dirmask = true;
      unmaskSome();

      miProgSearch.setEnabled(true);
      miFileLocate.setEnabled(true);
//      miFileSize.setEnabled(true);

      if(AESetup.resizeMemory)
      {
       source.comboResize(Preferences.MemorySize);
       target.comboResize(Preferences.MemorySize);
       AESetup.resizeMemory = false;
      }

      //String dirname = source.getDir();
      //System.out.println("shown");
      //if (dirname.equalsIgnoreCase(m_dirName) == false) source.modified = true;
      if (source.modified) source.refresh(false);
      if (target.modified) target.refresh(false);
      source.requestFocus();
 }



 void source_componentShown(java.awt.event.ComponentEvent event)
 {

      if(source.getPath() == null)  setSrcPath(AEDir);
      if(source.modified) SrcDisp();
      if (synchro()) DstDisp();
      SrcFocus();
 }

 void source_componentHidden(java.awt.event.ComponentEvent event)
  {
  }



 void targetEnable(boolean mode)
 {
      miSwap.setEnabled(mode);
      miDirExtend.setEnabled(mode);
      buttonSwap.setEnabled(mode);
      buttonLR.setEnabled(mode);
      miFileCopy.setEnabled(mode);
      miFileComp.setEnabled(mode);
      miUpdate.setEnabled(mode);
      miCopyRen.setEnabled(mode);
      miCopyInDir.setEnabled(mode);

      miDirCompare.setEnabled(mode);
      miCmpVersions.setEnabled(mode);
      miCmpContent.setEnabled(mode);
      miCmpFull.setEnabled(mode);
      miExtract.setEnabled(mode);
      miZip.setEnabled(mode);

      buttonDirCompare.setEnabled(mode);
      buttonUnarc.setEnabled(mode);
      buttonFileCopy.setEnabled(mode);

 }

 void target_componentShown(java.awt.event.ComponentEvent event)
 {
      targetEnable(true);
      if(target.modified) target.refresh(true);
 }

 void target_componentHidden(java.awt.event.ComponentEvent event)
 {
      targetEnable(false);
 }


 void tabDst_componentShown()
 {
  if (target != null)
  {
       targetEnable(true);
       if(target.modified) target.refresh(true);
  }
  dispTip("");
 }

 void tabDst_componentHidden()
	{
	  if (target != null) targetEnable(false);
	}


  void editorEnable(boolean mode)
  {
       miUndo.setEnabled(mode);
       miFind.setEnabled(mode);
       miFindAgain.setEnabled(mode);
       miReplace.setEnabled(mode);
       miSelectAll.setEnabled(mode);
       miSave.setEnabled(mode);
       miSaveAs.setEnabled(mode);
       miSaveBlock.setEnabled(mode);
       //miWrap.setEnabled(mode);
  }

  void editor_componentShown(ComponentEvent event)
  {
       maskAll();
       editmask = true;
       unmaskSome();

       editorEnable(true);

       editor.setTextInfo();
       panelTool.showPanel(toolText);
       editor.setFocusable(true);
       editor.requestFocus();
   }


void editor_componentHidden(java.awt.event.ComponentEvent event)
 {
       editor.setFocusable(false);
       editorEnable(false);
       panelTool.showPanel(toolDir);
 }


    /** Afficher l'arborescence des rpertoires */




  void tabSetup_componentShown()
  {
      maskAll();
      setupmask = true;
      unmaskSome();
  }


    // Gestion d'vnement d'affichage des paneaux

	class SymComponent extends java.awt.event.ComponentAdapter
	{
	  /*
	  public void componentResized(java.awt.event.ComponentEvent event)
	  {
	   Object object = event.getSource();
	   if (object == tabImage) imageMessage();
	  }
	  */
      public void componentShown(java.awt.event.ComponentEvent event)
	   {
		Object object = event.getSource();

		if (object == tabDir) tabDir_componentShown(event);
		else if (object == source)	source_componentShown(event);
		else if (object == target)	target_componentShown(event);
		else if (object == editor)	editor_componentShown(event);
		else if (object == tabSetup) tabSetup_componentShown();
		else if (object == imageViewer) imageMessage();
		else if (object == tabDst)	tabDst_componentShown();
		else if (object == treemanager) treemanager.init();
       }


      public void componentHidden(java.awt.event.ComponentEvent event)
	   {
		Object object = event.getSource();
		if (object == tabDir)	tabDir_componentHidden(event);
		else
		if (object == source)	source_componentHidden(event);
		else
		if (object == target)	target_componentHidden(event);
		else
		if (object == editor)	editor_componentHidden(event);
		else
		if (object == tabDst)	tabDst_componentHidden();
	   }

  }



//---------------------------------------------------- Messages




  void debug(String s) { Disp.it(s); }
  void ErrorMessage(String s) { Disp.it(s); }

  void beep()
  {
    if(Preferences.Sound) Tool.beep();
  }



   /** Message et enregistrement */
   public boolean Message(String message)
   {
     if(statuscreated)
       statusbar.setText(" " + message);
     history.tell(message);
     return false;
   }

   public boolean dispTip(String message)
   {
     if(statuscreated)
       statusbar.setText(" " + message);

     return false;
   }

   String blank = "                                                              ";

   String menuLabel(String lab, String sc)
   {
    int l = lab.length() + sc.length();

    FontMetrics fm = getFontMetrics(getFont());
    int bw = fm.charWidth(' ');
    int w = fm.stringWidth(lab + sc);
    int tt = 184;
    int diff = Math.max(0,  (tt -  w) / bw);
//    debug("tt=" + tt + " bw="+ bw + " diff=" + diff);

    return lab + blank.substring(0, diff) + sc;
   }


//--------------------------------------------- Inner Classes


// TOUCHES du CLAVIER
// AEKey  KeyListener

class AEMainKeys extends java.awt.event.KeyAdapter
{
  public void keyPressed(java.awt.event.KeyEvent event)
  {
    Object object = event.getSource();

    if (event.isAltDown())
    {
      int keypressed = event.getKeyCode();
      int panel = -1;
      switch (keypressed)
      {
      case KeyEvent.VK_F:
           panel = 0;
           break;
      case KeyEvent.VK_X:
           panel = 0;
           break;
      case KeyEvent.VK_E:
           panel = 1;
           break;
      case KeyEvent.VK_O:
           panel = 2;
           break;
      case KeyEvent.VK_F4:
           Exit_Action();
      default:
           break;
      }
      if (panel > -1)   tabbedAE.select(panel);
    }
  }
}


   // test si panel retourne message
   boolean panelMessage(PanelGenerator panel)
   {
     switch(panel.action)
      {
 	    case TIP: dispTip(panel.message);
 	         return true;
 	    case MESSAGE: Message(panel.message);
 	         return true;
        default: break;
      }
     return false;
   }

    // Menu & Setup

  class Action implements java.awt.event.ActionListener
   {
      public void actionPerformed(java.awt.event.ActionEvent event)
      {
	 Object object = event.getSource();

      // TOOLS

      if (object == miFree)  	{ dirtools.free(); return; }
      else if( object == filecopy)
      {
        Message(filecopy.actionCommand); return;
      }
      else if( object == miFileLocate) { Locate(); return; }
      else if (object == miHistory)  { history.show(); return; }
      else if (object == miDOS)	    { console(); return; }
      else if (object == miCalc)     { dirtools.Run("calc.exe", null, false); return; }
      else if (object == miScan)     { dirtools.Run("scandskw.exe", null, false); return; }
      else if (object == miExplorer) { Explorer(); return; }
      else if (object == miThumbnail)
      {
	    panelThumbnail.select(source);
	    panelRight.select(THUMBNAIL);
	    panelThumbnail.init(source, target, false);
	    return;
       }
       else if (object == miListe)
       {
         panelRight.select(LIST);
	 panelList.init(source, target, true);
	 return;
       }
       else if (object == miOutline)
       {
	 if(panelOutline.select(source))
	 {
	     panelRight.select(OUTLINE);
	     panelOutline.init(source, target, false);
	 }
	 return;
       }
       else if (object == miZip)
       {
	 panelRight.select(ARCHIVER);
	 panelArchive.setFilename("");
	 panelArchive.init(source, target, true);
         panelArchive.setDir(target.getDir()); // the exception
         panelArchive.makeFile();
       }
        else if (object == archiver)
        {
           char c = event.getActionCommand().charAt(0);
           String mess = archiver.getMessage();
           if(c == 'm') Message(mess); else dispTip(mess);
           return;
        }

        // PROGRS

        else if (object == miProgSearch) { progSearch(); return; }
        else if (object == miProgClear)
        {
          tools.clear();
          tools.restore();
          return;
        }
        else if (object == tools)
        {
          String com = event.getActionCommand();
          actionProgram((new Integer(com)).intValue());
          return;
        }

        // USUELS

        else if (object == miTextClear)
        {
          references.clear();
          references.restore();
          return;
        }
        else if (object == references)
        {
          actionDynamic(references.dynList, event.getActionCommand());
          return;
        }

        // RECENTS

        else if(object == miRecentClear)
        {
           recents.clear(); recents.restore();
           return;
        }
        else if(object == recents)
        {
           actionDynamic(recents.dynList, event.getActionCommand());
           return;
        }

         // HELP

        else if (object == miHelp)     { manual(); return; }
	else if (object == miAbout)    { About(); return; }

        // EDITOR

	if  (object == miNew)
	   { tabbedAE.select(tabTextNo); newText(); }
       //else if (object == miWrap) { editor.setWrap();}
        else if (object == miOpenText)   openTextDialog(true);
        else if (object == miSave)       editor.save();
	else if (object == miSelectAll)  editor.selectAll();
	else if (object == miClose)	 closeText();
	//else if (object == miPaste)    Paste_Action();
	//else if (object == miCopy)     Copy_Action();
	//else if (object == miCut)	 Cut_Action();
	else if (object == miSaveAs)	 saveAs();
	else if (object == miSaveBlock)  editor.saveBlock();
	else if (object == miUndo)	 editor.undo();
	else if (object == miFind)	 editor.find();
	else if (object == miFindAgain)  editor.findAgain();
	else if (object == miReplace)	 editor.replace();
        else if (object == miInsert)	 editor.insert();

        // FILE

        // else if (object == miInfo)		Info();
	else if (object == miExit)     Exit_Action();
	//else if (object == miLock)	Lock_Action();
	//else if (object == miUnlock)	Unlock_Action();
        //else if (object == miRename)	Rename();

	else if (object == miFileSelectAll)
	  {
	    if (whichWindow() == 0)
	    {
	     source.deselectAll();
	     source.selectAll();
	     return;
	    }
	    if (whichWindow() == 1)
	    {
	     target.deselectAll();
	     target.selectAll();
	    }
	    return;
	  }
	else if (object == miFileSelectAny)
	  {
	    if (whichWindow() == 0)
	    {
	     source.deselectAll();
	     source.selectAny();
	     return;
	    }
	    if (whichWindow() == 1)
	    {
	     target.deselectAll();
	     target.selectAny();
	    }
	    return;
	  }

	else if (object == miFileComp)	compareTagged();
	else if (object == miUpdate)	updateTagged();
	else if (object == miFileCopy)	fileCopy(false);
	else if (object == miCopyRen)	CopyRename();
	else if (object == miCopyInDir) fileCopy(true);

        // DIR

	else if (object == miDirCompare)	compare(CMPLIST);
	else if (object == miCmpVersions)	compare(CMPVERSION);
	else if (object == miCmpContent)	compare(CMPCONTENT);
	else if (object == miCmpFull)	    compare(CMPANY);
//	else if (object == miFileSize)     Occupation();
	else if (object == miSwap)	 	    swapDirs();
	else if (object == miDirExtend)
	{
          setDstPath(source.getDir());
          DstDisp();
	 }
	else if (object == miMake)		Make();

         // ARCHIVE

	else if (object == miView)     source.viewZip();
	else if (object == miExtract)	unArchive();

         // AUTRES PANNEAUX

        else if(object == imageViewer)
        {
          String command = event.getActionCommand();
          if (command.equals("full"))
          {
            actionFull();
            return;
          }
          displayFlag = true; imageMessage();
       }

       else if(object == aesetup)
       {
          int messnum = new Integer(event.getActionCommand()).intValue();
                 //Disp.it("mess " + messnum);
          switch(messnum)
          {
           case MESSAGE:    Message(aesetup.message); break;
           case TIP:        dispTip(aesetup.message); break;
           case UPDATE:     updateConditional(AEDir); break;
           case BEEP:       beep(); break;
           case EXIT:       Exit_Action(); break;
           case TABS:
                tabbedAE.setTabsInfo(TabPanel.TOP, Preferences.tabStyle);
	        tabDst.setTabsInfo(TabPanel.TOP, Preferences.tabStyle);
	        break;
           case STYLE:
                setTextStyle();
                setDirStyle();
                setTreeStyle();
                setMessageStyle();
                break;

	   case SHORTCUT:
	        {
	 	 String label = Preferences.shortcut[aesetup.shortnum];
	 	 switch(aesetup.shortnum)
                 {
                      case 0: buttonA.setLabel(label, true); break;
                      case 1: buttonC.setLabel(label, true); break;
                      case 2: buttonD.setLabel(label, true); break;
                      case 3: buttonE.setLabel(label, true); break;
                      case 4: buttonF.setLabel(label, true); break;
                      case 5: buttonG.setLabel(label, true); break;
                      case 6: buttonH.setLabel(label, true); break;
                      case 7: buttonI.setLabel(label, true); break;
                     }
	 	 }
	    case REBUILD: treemanager.rebuild(); break;
	    case ARCSORT:
	         source.setArcSort(Preferences.ArcSort);
	         target.setArcSort(Preferences.ArcSort);
	         break;
	    case RESIZE:
	         int s = Preferences.menuSize;
	         recents.setSize(s);
	         references.setSize(s);
	         tools.setSize(s);
           default:
                 break;
          }
         }

         else if (object == dirtools)
         {
          if (dirtools.messnum == dirtools.MESSAGE)
           Message(dirtools.message);
          else
           dispTip(dirtools.message);
         }

         else if (object == source)
         {
           String command = event.getActionCommand();

           if (command.equals("md"))
           {
             if( synchro()) DstDisp();
             source.requestFocus();
             return;
           }
           if (command.equals("modified"))
           {
             //debug("cd - avant " + source.dirList.getSelectedIndex());
             if(synchro()) target.dirDisp(false);
             source.requestFocus();
             //debug("apres " + source.dirList.getSelectedIndex());
             return;
           }
           if (command.equals("focus")) { SrcFocus(); return; }
           if (command.equals("copy"))  { fileCopy(false); return;}
           if (command.equals("unarc")) { unArchive(); return; }
           if (command.equals("edit"))  { processEdit(source); return; }
           processAny(source, command, source.addit);
           return;
         }
         else if (object == target)
         {
           String command = event.getActionCommand();
           if (command.equals("md"))
            {
             // avant car on change de dir en target
             // mais source peut tre chang...
             if (synchro()) source.dirDisp(false);
             if (Preferences.OpenDir)
              {
               target.setPath(Path.merge(target.getDir(), target.dirmade));
              }
             DstDisp();
             return;
            }

           if (command.equals("modified"))
           {
             target.modified = true;
             if(synchro()) source.dirDisp(false);
             target.requestFocus();
             return;
           }
           if (command.equals("focus")) { DstFocus(); return; }
           if (command.equals("edit"))  { processEdit(target); return; }
           processAny(target, command, target.addit);
         }

         else if (object == treemanager)
         {
          String command = event.getActionCommand();
          if(command.equals("src")) { MakeSrc(true); return; }
          if(command.equals("dst"))
           {
             target.setPath(treemanager.getSelected());
             tabDst.select(0);
             return;
           }
         }

         else if (object == editor)
         {
          String com = event.getActionCommand();
          if(com.equals("modified"))
          {
            changeTextTab();    // change TextName
            updateConditional(editor.UpdateDir);
            displayText();
          }
          if(com.equals("tip"))     dispTip(editor.TextMessage);
          if(com.equals("message")) Message(editor.TextMessage);
         }

        else if (object == panelThumbnail)
        {
          if (panelMessage(panelThumbnail)) return;
          if (panelThumbnail.action == panelThumbnail.MAKE)
              thumbnailAction();
          panelRight.select(TARGET);
          return;
        }
    	else if (object == panelList)
    	{
          if (panelMessage(panelList)) return;
          if (panelList.action == panelList.MAKE)
    	       indexAction();
          panelRight.select(TARGET);
    	  return;
    	}
    	else if (object == panelOutline)
    	{
          if (panelMessage(panelOutline)) return;
          if (panelOutline.action == panelOutline.MAKE)
   		 	     outlineAction();
          panelRight.select(TARGET);
    	  return;
    	}
    	else if (object == panelArchive)
    	{
          if (panelMessage(panelArchive)) return;
 	      if (panelArchive.action == panelArchive.MAKE)
 	       {
 	        if(!panelArchive.archive(source)) return; // reprendre
 	        updateConditional(panelArchive.getDir());
 	        if (synchro()) source.refresh(false);
 	       }
          panelRight.select(TARGET);
    	  return;
    	}
    }
 }


    // Tool Bar Files

  class DButtonAction implements java.awt.event.ActionListener
  {
     public void actionPerformed(java.awt.event.ActionEvent event)
     {
        Object object = event.getSource();

	if (object == buttonSwap)         swapDirs();
	else if (object == buttonLR)
	{
          setDstPath(source.getDir());
          DstDisp();
        }

	else if( object == buttonLocate)     Locate();
	else if (object == buttonDirCompare) compareTagged();
	else if (object == buttonUnarc)      unArchive();
	else if (object == buttonFileCopy)   fileCopy(false);
	else if (object == buttonExplorer)   Explorer();

        // File Manager

	else if (object == buttonA) shortcut(0);
	else if (object == buttonC) shortcut(1);
	else if (object == buttonD) shortcut(2);
	else if (object == buttonE) shortcut(3);
	else if (object == buttonF) shortcut(4);
	else if (object == buttonG) shortcut(5);
	else if (object == buttonH) shortcut(6);
	else if (object == buttonI) shortcut(7);

 		// Text
        else if (object == buttonDirOpen)  openTextDialog(false);
	else if ((object == buttonTextNew) || (object == buttonDirNew))
		   { tabbedAE.select(tabTextNo);  newText(); }
	else if (object == buttonTextOpen) openTextDialog(false);
	else if (object == buttonTextSave) editor.save();
	//else if (object == buttonTextPaste)	Paste_Action();
	//else if (object == buttonTextCopy)	Copy_Action();
	//else if (object == buttonTextCut)	    Cut_Action();
	else if (object == buttonTextFind)    editor.find();
	else if (object == buttonTextReplace) editor.replace();

	  }
    } // classe


    public void windowIconified(WindowEvent e) {; }
    public void windowDeiconified(WindowEvent e) {; }
    public void windowDeactivated(WindowEvent e) {; }
    public void windowOpened(WindowEvent e) {; }
    public void windowActivated(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {; }
    public void windowClosing(WindowEvent e)
    {
	  if (e.getSource() == ae.this) Exit_Action();
    }

 }


