/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;

public class Dialog3D extends DDialog implements ActionListener
{
	Panel panelScroll;
    Canvas3d canvas;
 
	Panel panelControl;
	Button buttonOk;
	Button buttonCancel;
	Label labelX;
	Label labelY;
	Label labelZ;
    TSpinner fieldX;
    TSpinner fieldY;
    TSpinner fieldZ;    

    int width, height;
	int iX = 0;
	int iY = 0;
	int iZ = 0;	
	Image image = null;
	Image model = null;
	boolean accept = false;
	
	public Dialog3D(Frame parent, boolean modal)
	{
		super(parent, modal);

		setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(insets().left + insets().right + 450,insets().top + insets().bottom + 320);
		setFont(new Font("Dialog", Font.PLAIN, 14));

        panelScroll = new java.awt.Panel(new BorderLayout());
		add(panelScroll, BorderLayout.CENTER);

        // la taille de l'image dpend de Z
        // le normal est proche de 50
        // le pas de rotation aussi
        canvas = new Canvas3d(new Viewpoint(new Vertex(0, 0, -25)));
        canvas.setBackground(Color.blue);
        panelScroll.add(canvas, BorderLayout.CENTER);
        
		panelControl = new java.awt.Panel(null);
		panelControl.setBounds(insets().left + 334,insets().top + 0, 116, 320);
		add(panelControl, BorderLayout.EAST);

		buttonOk = new java.awt.Button("OK");
		buttonOk.setBounds(8,204,100,30);
		buttonOk.addActionListener(this);
		panelControl.add(buttonOk);

		buttonCancel = new java.awt.Button("Cancel");
		buttonCancel.setBounds(8,264,100,30);
		buttonCancel.addActionListener(this);		
		panelControl.add(buttonCancel);

		labelX = new java.awt.Label("X");
		labelX.setBounds(16, 16, 16, 24);
		panelControl.add(labelX);
		
		fieldX = new TSpinner(0, 0, 359 );
		fieldX.setBounds(48, 16, 72, 24);
		fieldX.addActionListener(this);		
		panelControl.add(fieldX);

		labelY = new java.awt.Label("Y");
		labelY.setBounds(16, 48, 16, 24);
		panelControl.add(labelY);
		fieldY = new TSpinner(0, 0, 359 );
		fieldY.setBounds(48, 48, 72, 24);
		fieldY.addActionListener(this);		
		panelControl.add(fieldY);


		labelZ = new java.awt.Label("Z");
		labelZ.setBounds(16, 80, 16, 24);
		panelControl.add(labelZ);
		
		fieldZ = new TSpinner(0, 0, 359 );
		fieldZ.setBounds(48, 80, 72, 24);
		fieldZ.addActionListener(this);		
		panelControl.add(fieldZ);


		setTitle("3D transformations");

			//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		setSize(0,0);
		setVisible(false);
		//}}
}

	
	public Dialog3D(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	
    public Dialog3D(Frame parent)
    {
      this(parent, true);   
    }    
	
	public Dialog3D(Frame parent, Image img)
	{
     this(parent, true);
     setImage(img);
	}    

	
	void setX()	{ fieldX.setCurrent(iX);}  
	void setY()	{ fieldY.setCurrent(iY);}  
	void setZ()	{ fieldZ.setCurrent(iZ);}  


	/**
	   Transforme une image en texture
	   cre un Compoment3d de type Poster
	   ajoute le poster  la vue3d
	*/   
	public void setImage(Image image)
	{
	 this.image = image;
	 this.model = image;
	 
     MediaTracker tracker = new MediaTracker(this);
     tracker.addImage(image, 0);
     try { tracker.waitForAll(); } catch(InterruptedException e) { }

/*
	 int iw = image.getWidth(null);
	 int ih = image.getHeight(null);
	 image = image.getScaledInstance(iw * 2, ih * 2, Image.SCALE_DEFAULT);
*/
     // Les multiplicateurs servent  tiler
 	 Texture texture = new Texture(image, 1, 1);

//     Box box = new Box(new Vertex(3, 3, 3), new Vertex(-3, -3, -3), texture);
     Box box = new Box(new Vertex(5, 5, 5), new Vertex(-1, -1, -1), texture);
     canvas.clearWorld();
     canvas.add(box);
	}    
	
   public Image getImage()
   {
    return canvas.getImage();
   } 
   

    public void update(Graphics g) { paint(g); }
	
	public void paint(Graphics g)
	{
	 super.paint(g);   

     width = image.getWidth(null);
     height = image.getHeight(null);
	 
     System.out.println("Dialog3d - paint  w " + width + " h " + height);	 
	 setX();
	 setY();
	 setZ();

     canvas.setX(iX);
     canvas.setY(iY);
     canvas.setZ(iZ);
	 
	 
	 System.out.println("Dialog3d appel canvas3d.draw");
//     if(canvas.world != null) canvas.draw();
	}    
	
	
   /**
       Mise  jour
   */    
   

   public void transform()
   {
    setX();
    setY();
    setZ();

    canvas.setX(iX);
    canvas.setY(iY);
    canvas.setZ(iZ);
    
    setImage(model);
    canvas.rotate();
    
    canvas.repaint();
    
    try { Thread.sleep(50); } 
    catch ( InterruptedException i) {}

   } 
   
  int get(TSpinner field)
  {
   int  i = field.current;
   if(i < 0) i = 0;
   if(i > 359) i = 359;
   field.setCurrent(i);
   return i;
  } 
   
  public void actionPerformed(ActionEvent event)
  {
    Object object = event.getSource();
    
    if(object == buttonCancel)
    {
      image = model;
      accept = false;
      setVisible(false);
    }  
    else
    if(object == buttonOk)
    {
      accept = true;  
      setVisible(false);  
    }
    else
    if(object == fieldX)
    {
      iX = get(fieldX);  
      transform();
    }    
    else
    if(object == fieldY)
    {
      iY = get(fieldY);        
      transform();
    }    
    else
    if(object == fieldZ)
    {
      iZ = get(fieldZ);  
      transform();
    }    
    
  }  

   
   
	//{{DECLARE_CONTROLS
	//}}
}
