/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import comgr.*;
import common.*;

public class AboutPlasma extends Plasma
{

  Image imageOffScreen;
  Image imageAuthor;
  String version = "";

  int width = 460;
  int height = 240;



  public AboutPlasma()
  {
     setBackground(new Color(128,228, 255));
  }

  void debug(String s) { System.out.println(s); }

  public void setRelease(String s) { version = s; }

  /** Initialisation section */

  boolean initOk = false;


  public void init(int w, int h)
  {
	width  = w;
	height = h;
  }

  /** Dessin de l'image */

  public void update(Graphics g) { paint(g);}

  public void paint(Graphics g)
    {
      makeScreen();
      if (imageOffScreen == null) return;
      g.drawImage(imageOffScreen, 0, 0, this);
    }

  /**
     Ecrit sur le contexte graphic
  */

  public void makeText(Graphics g)
  {
     Dimension d = getSize();
     int w = d.width;
     int h = d.height;


     int sx = 54;
     int sy = 78;

     Font sfont = new Font("Dialog", Font.PLAIN, 40);
     FontMetrics fm = getFontMetrics(sfont);

     String ae = "Advanced Explorer";
     g.setFont(sfont);
     g.setColor(Color.black);
     g.drawString(ae, 46, 72);
     g.setColor(Color.green.darker());
     g.drawString(ae, 44, 70);


     String scriptol = "www.scriptol.com";
     sfont = new Font("Dialog", Font.BOLD, 22);
     fm = getFontMetrics(sfont);
     g.setFont(sfont);
     g.setColor(Color.black);
     g.drawString(scriptol, 116, 130);

     g.setFont(new Font("Dialog", Font.BOLD, 14));
     int x = (w  - version.length() * 8 + 16) / 2;
     g.drawString(version, x + 8, h - 64);

     String free = "Free - Sources available on Scriptol's CD";
     x = (w  - (free.length() * 8)) / 2 ;
     g.drawString(free, x + 20, h - 34);



     g.setColor(Color.black);
     g.drawRect(0, 0, w - 1, h - 1);
   }


  public void loadTitle()
  {
   try
    {
     String user = System.getProperty("user.dir");
     String ipath = user + File.separator + "aexplorer.gif";
     imageAuthor = Toolkit.getDefaultToolkit().getImage(ipath);
     imageAuthor = imageAuthor.getScaledInstance(320, 50, Image.SCALE_DEFAULT);
   /*
     MediaTracker o = new MediaTracker(this);
     try
     {
       o.addImage(imageAuthor, 0);
       o.waitForAll();
     }
     catch(Exception e) {};
    */
    }
    catch (Exception e)
     {
	System.out.println(e);
     }

   }

  /**
     Cre le buffer off screen
     Place une image source dessus
     Place le texte dessus
  */

  public void makeScreen()
  {
    try
     {

     imageOffScreen = this.createImage(width, height);
     Graphics g = imageOffScreen.getGraphics();

     loadTitle();        // load an image, disabled
     Dimension d = getSize();
     int w = d.width;
     int iw = imageAuthor.getWidth(this);
     g.drawImage(imageAuthor, (w - iw) / 2, 50,this);
     makeText(g);
     }
    catch (Exception e)
     {
       System.out.println(e);
     }
   }

}

