/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.event.*;

public class DialogRotate extends DDialog implements ActionListener
{
    Panel panelScroll;

    static ImageViewer viewer;
    static Rotate rotate;

    Panel panelControl;
    Button buttonOk;
    Button buttonCancel;
    Label labelAngle;
    TSpinner fieldAngle;

    int angle = 0;
    Image image = null;
    boolean accept = false;

	public DialogRotate(Frame parent, boolean modal)
	{
		super(parent, modal);

		setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(insets().left + insets().right + 450,insets().top + insets().bottom + 320);
		setFont(new Font("Dialog", Font.PLAIN, 14));

        panelScroll = new java.awt.Panel(new BorderLayout());
		add(panelScroll, BorderLayout.CENTER);

        // la taille de l'image dpend de Z
        // le normal est proche de 50
        // le pas de rotation aussi
        viewer = new ImageViewer();
        viewer.setBackground(Color.blue);
//        viewer.setStyle(ImageViewer.IMAGE_NORMAL);
        panelScroll.add(viewer, BorderLayout.CENTER);

		panelControl = new Panel(null);
		panelControl.setBounds(334, 0, 132, 320);
		add(panelControl, BorderLayout.EAST);

		buttonOk = new java.awt.Button("OK");
		buttonOk.setBounds(16,204,100,30);
		buttonOk.addActionListener(this);
		panelControl.add(buttonOk);

		buttonCancel = new java.awt.Button("Cancel");
		buttonCancel.setBounds(16,264,100,30);
		buttonCancel.addActionListener(this);
		panelControl.add(buttonCancel);

		labelAngle = new java.awt.Label("Angle");
		labelAngle.setBounds(48, 48, 60, 24);
		panelControl.add(labelAngle);

		fieldAngle = new TSpinner(0, 0, 359 );
		fieldAngle.setBounds(48, 76, 72, 24);
		fieldAngle.addActionListener(this);
		panelControl.add(fieldAngle);

		setTitle(" Rotate");
}


	public DialogRotate(Frame parent, String title, boolean modal)
	{
     this(parent, modal);
	 setTitle(title);
	}


    public DialogRotate(Frame parent)
    {
      this(parent, true);
    }

	public DialogRotate(Frame parent, Image img)
	{
     this(parent, true);
     setImage(img);
	}


//---------------------------------------- Tranformation

    /** Angle */

	void setAngle()	{ fieldAngle.setCurrent(angle);}

	/**
	   Transforme une image en texture
	*/

	public void setImage(Image img)
	{
/*
     MediaTracker tracker = new MediaTracker(this);
     tracker.addImage(img, 0);
     try { tracker.waitForAll(); } catch(InterruptedException e) { }

     width = img.getWidth(null);
     height = img.getHeight(null);
*/
 	 VirtualImage vi = new VirtualImage();
 	 vi.load(img);

 	 image = vi.image;
 	 rotate = new Rotate(vi.getPixels(), vi.width, vi.height);

	}

    /** Retourne l'image */
    public Image getImage()  { return image; }

    /**
        Affichage
    */
    public void update(Graphics g) { paint(g); }

	public void paint(Graphics g)
	{
	 super.paint(g);

	 setAngle();
	 viewer.setBackground(Color.black);
	 viewer.clear();
     viewer.setImage(image);
     viewer.repaint();
	}


   /**
       Rotate selon un angle, repaint
   */

   public void transform()
   {
    setAngle();


    switch(angle)
    {
      case 90:
      case 180:
      case 270:
               rotate.clear();
               rotate.rotate(angle);
               break;
      default: rotate.clear();
               rotate.rotate(angle);
               break;
    }

    image = rotate.getImage();
    repaint();
   }


  /**
      Contrle l'entre
  */
  int get(TSpinner field)
  {
   int  i = field.current;
   if(i < 0) i = 0;
   if(i > 359) i = 359;
   field.setCurrent(i);
   return i;
  }

  /**
      Action
  */
  public void actionPerformed(ActionEvent event)
  {
    Object object = event.getSource();

    if(object == buttonCancel)
    {
      accept = false;
      setVisible(false);
    }
    else
    if(object == buttonOk)
    {
      accept = true;
      setVisible(false);
    }
    else
    if(object == fieldAngle)
    {
      angle = get(fieldAngle);
      transform();
    }

  }



	//{{DECLARE_CONTROLS
	//}}
}
