/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;



public class PlasmaPrg extends Frame
{
 Panel panel;
 Plasma plasma;

 MenuBar menuBar = new MenuBar();
 Menu menuFile = new Menu();
 MenuItem menuRun = new MenuItem();
 MenuItem menuFileExit = new MenuItem();
 Menu menuHelp = new Menu();
 MenuItem menuHelpAbout = new MenuItem();

 public PlasmaPrg()
  {
   setSize(400, 300);
   setResizable(true);
   setLayout(new BorderLayout());
   setTitle(" Plasma");

  Font mf = new Font("Dialog", Font.PLAIN, 14);
	Action aListener = new Action();

  menuFile.setLabel("File");
  menuFile.setFont(mf);
  menuBar.add(menuFile);

  menuRun.setLabel("Run");
  menuRun.addActionListener(aListener);
  menuRun.setFont(mf);
  menuFile.add(menuRun);

  menuFileExit.setLabel("Exit");
  menuFileExit.addActionListener(aListener);
  menuFileExit.setFont(mf);
  menuFile.add(menuFileExit);

  menuHelp.setLabel("Help");
  menuHelp.setFont(mf);
  menuHelp.add(menuHelp);
  menuBar.add(menuHelp);

  menuHelpAbout.setLabel("About");
  menuHelpAbout.addActionListener(aListener);
  menuHelpAbout.setFont(mf);
  menuHelp.add(menuHelpAbout);

  this.setMenuBar(menuBar);


   panel = new Panel(new GridLayout());
   add(panel, BorderLayout.CENTER);

   this.addWindowListener(new SymWindow());

   plasma = new Plasma();
   plasma.setBounds(0, 0, 400, 300);
   plasma.setBackground(Color.green.darker());
   panel.add(plasma);


   plasma.init(400, 300);

//   plasma.start();
 }



  public static void main(String args[])
  {
   (new PlasmaPrg()).show();
  }


 
 class SymWindow extends  java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PlasmaPrg.this)
      {
       plasma.stop();
       System.exit(0);
      }
		}
	}

 class Action implements java.awt.event.ActionListener
	{
	  public void actionPerformed(java.awt.event.ActionEvent event)
	   {
		 Object object = event.getSource();

		 if (object == menuFileExit) 		       { System.exit(0); }
  	 else if (object == menuHelpAbout)		 { System.out.println("Help");}
     else if (object == menuRun)
       {
        //plasma.init();
        plasma.start();
       }
     }
  } // action

 }
