/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.image.*;


/**
    Affiche une image en temps/taille rels

    La taille est limite
*/

public class RealView extends Canvas
{
 VirtualDirect offScreen = null;
 Color transparent;


 void RealView(VirtualDirect vd)
 {
   offScreen = vd;
 }

 void setVirtualScreen(VirtualDirect vd)
 {
   offScreen = vd;
 }

 void setTransparent(Color t) { transparent = t; }

 public void clear()
 {

  Graphics g = getGraphics();
  try {
   Rectangle r = getBounds();
   g.setColor(getBackground());
   g.fillRect(r.x, r.y, r.width, r.height);
  }
  catch(NullPointerException n) { }

 }

 /**
    Paint
 */

 public void update(Graphics g) { paint(g); }

 public void paint(Graphics g)
  {
   if(offScreen == null) return;

   //System.out.println("realview paint");

   Image img = offScreen.getImage();

   MediaTracker mt = new MediaTracker(this);
   mt.addImage(img, 0);
   try { mt.waitForAll(); } catch(InterruptedException e) { }

   try
   {
    g.drawImage(img, 0, 0, transparent, this);
   }
   catch(Exception e)
   {
    System.out.println("RealView - " + e.toString());
    System.out.println("Image size: " + img.getWidth(null) + " " + img.getHeight(null));
   }

  }

}
