/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.image.*;

/**
   Sous-classe de VirtualScreen
   Utilise les mmes fonctions avec une palette directe RGB

   Seule change getImage
   et quelques surcharges
*/


public class VirtualDirect extends VirtualScreen
{

 VirtualDirect() { super(); 		//{{INIT_CONTROLS
		//}}
}

 VirtualDirect(int w, int h) { super(w, h); }

 VirtualDirect(int[] iArray, int w, int h) { super(iArray, w, h); }


 /** Surcharge */
 public void copy(VirtualDirect vd) { super.copy((VirtualScreen) vd); }   

 /**
     Cre la couleur du pixel
 */
 Color getColor(int index)
  {
    int pixel = screen[index];
    int red   = (pixel >> 16) & 255;
    int green = (pixel >> 8) & 255;
    int blue  = pixel & 255;
    return new Color(red, green, blue);
 }

 /**
    Efface dans le modle de couleur direct
 */   
 public void clear(Color color)
 {
   int i = getSize() - 1;
 
   while(i >= 0) screen[i--] = color.getRGB();
 }

 /**
    Superpose deux images (deux crans)
 */   
 public void merge(int pix[], int w, int h, int transp)
 {
  int c = 0;
  
  for(int j = h-1; j >= 0; j--)
  for(int i = 0; i < w; i++)
  {
   if(pix[c] != transp)
   {
     pixel(i, j, pix[c]);
   } 
   c++;  
  }  
 }   


 public void merge(int pix[], int w, int h, int xoff, int yoff, int transp)
 {
  int c = 0;
  
  for(int j = h - 1; j >= 0; j--)
  for(int i = 0; i < w; i++)
  {
   if(pix[c] != transp) pixel(i + xoff, j + yoff, pix[c]);
   c++;  
  }  
 }   


 /**
    Cre l'image avec le modle de couleur par dfaut
    soit le modle direct RGB
 */    
 public Image getImage()
 {
  return toolkit.createImage(new MemoryImageSource(width, height, screen, 0, width));
 }




	//{{DECLARE_CONTROLS
	//}}
}
