/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;


import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.net.*;
import java.awt.image.*;
import comgr.*;

public class AboutDialog extends DWindow
{
//    ImagePanel imageAbout;
    AboutPlasma imageAbout;
    Label labelTitre;
    Label labelAuteur;
    Label labelC;
    DPanel panelInner;

    public AboutDialog(Frame parent)
    {
	super(parent);
        setBounds(160, 160, getInsets().left + getInsets().right + 420,getInsets().top + getInsets().bottom + 240);
	setLayout(new GridLayout());
	withImage();
     }

     public AboutDialog(Frame parent, Image i)
     {
       this(parent);
       withImage();
//      imageAbout.setImage(i);
     }




    public void withText()
    {
        Font bigfont = new Font("Courrier", Font.BOLD, 24);

        panelInner = new DPanel(null, DPanel.BEVEL_LINE);
        panelInner.setBounds(0, 0, 420, 300);
        panelInner.setBackground(getBackground());
        add(panelInner);

        labelTitre = new Label("Advanced Explorer", Label.CENTER);
        labelTitre.setBounds(16, 56, 384, 48);
        labelTitre.setFont(bigfont);
        panelInner.add(labelTitre);

        labelAuteur = new Label("D.G. Sureau", Label.CENTER);
        labelAuteur.setBounds(16, 112, 384, 48);
        labelAuteur.setFont(bigfont);
        panelInner.add(labelAuteur);

        labelC = new Label("(c) 1999 -  Free Program", Label.CENTER);
        labelC.setBounds(16, 184, 384, 20);
        labelC.setFont(new Font("Courrier", Font.BOLD, 14));
        panelInner.add(labelC);

        imageAbout = null;

        Mouse ADMouse = new Mouse();
        panelInner.addMouseListener(ADMouse);

    }


    public void withImage()
    {
        /*
	imageAbout = new ImagePanel(ImagePanel.BORDER_LINE, ImagePanel.IMAGE_MAPPED);
	imageAbout.setBounds(getInsets().left + 0,getInsets().top, 402, 258);
	imageAbout.setBackground(Color.orange);
	*/

	imageAbout = new AboutPlasma();
	add(imageAbout);

        imageAbout.init(420, 240);
        //imageAbout.start();

        Mouse ADMouse = new Mouse();
        imageAbout.addMouseListener(ADMouse);

    }



    public void update(Graphics g)
    {
      paint(g);
    }



    class Mouse extends java.awt.event.MouseAdapter
    {
   	  public void mouseReleased(MouseEvent e) { dispose(); }
    }


   public void setRelease(String r, String v)
   {
     if(imageAbout == null) return;
     imageAbout.setRelease(r + "  Version " + v);
   }


}
