/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.image.*;
import common.*;

// Liste des couleurs  choisir

public class ColorList
{

  static ColorModel colorModel = null;
  static final int MAXCOL = 40;

  static String nom[] = {
    "control",
    "controlText",
    "window",
    "windowText",
    "black",
    "blue",
    "green",
    "cyan",
    "red",
    "magenta",
    "brown",
    "lightGray",
    "gray",
    "lightBlue",
    "lightGreen",
    "lightCyan",
    "lightRed",
    "lightMagenta",
    "yellow",
    "white",
    "orange",
    "pink",
    "sepia",
    "slate",
    "slateLight",
    "aubergine",
    "pumpkin",
    "sand",
    "sandLight",
    "picea",
    "piceaLight",
    "lilac",
    "user"
  };


   static byte r[] = new byte[MAXCOL];
   static byte g[] = new byte[MAXCOL];
   static byte b[] = new byte[MAXCOL];


   static Color couleur[] = {
    (Color) SystemColor.control,
    (Color) SystemColor.controlText,
    (Color) SystemColor.window,
    (Color) SystemColor.windowText,
    Color.black,
    new Color(0, 0, 164),   // bleu
    new Color(0, 164, 0),   // green
    Color.cyan.darker(),
    new Color(164, 0, 0),   // red
    new Color(164, 0, 164), // magenta
    new Color(160, 128, 64), // brown
    Color.lightGray,
    Color.gray,
    Color.blue,
    Color.green,
    Color.cyan,
    Color.red,      // light red
    Color.magenta,  // light magenta
    Color.yellow,
    Color.white,
    Color.orange,
    Color.pink,
    new Color(192,192,128),  // sepia
    new Color(160, 184, 200), // slate
    new Color(168, 200, 224), // slateLight
    new Color(144, 176, 168), // aubergine
    new Color(240, 216, 160), // pumpkin
    new Color( 216, 208, 184), // sand
    new Color( 224, 224, 208), // sandLight
    new Color( 160, 200, 168), // picea
    new Color( 168, 224, 184), // picealight
    new Color( 176, 168, 216),  // lilac
    new Color(195, 195, 195) // user
   };
/*
   static boolean AreaFlag[] = {
    false,
    false,
    true,   // window bg est change dans les composants area
    false,
    false,   // noir
    true,   // bleu
    true,   // green
    true,//    "Cyan",
    true, //    "Red",
    true, //    "Magenta",
    true, //    "Brown",
    true, //    "LightGray",
    true, //    "Gray",
    false,//    "LightBlue",
    false,//    "LightGreen",
    false,//    "LightCyan",
    false,//    "LightRed",
    false,//    "LightMagenta",
    false, //    "Yellow",
    false, //    "White",

    true, //    "Orange",
    true, //    "Pink",
    true, //    "Sepia",
    true, //    "Slate",
    true, //     slateLight
    true, //    "Aubergine",
    true, //    "Pumpkin",
    true, //    "sand"
    true, //    "sandLight"
    true, //    "Picea",
    true, //     picea light
    true, //    "Lilac",
    true, //    "User"
  };
*/


   public ColorList()
   {
     for(int i = 0; i < couleur.length; i++)
      setComponents(i);

     setModel();
   		//{{INIT_CONTROLS
		//}}
}

   static void setModel()
   {
	colorModel = new IndexColorModel(8, r.length, r, g, b);
   }

   static void setComponents(int i)
   {
     int rgb = couleur[i].getRGB();

     r[i] = (byte) ((rgb >> 16) & 255);
     g[i] = (byte) ((rgb >> 8) & 255);
     b[i] = (byte) (rgb & 255);

   }

   static public int Size() { return( nom.length);  }

   static public String GetString(int index) { return( nom[ index ]); }

   /** Liste des mots cls */

   public static String[] ChoiceList() { return nom;}


  static Color getColor(int index)
   {
    if(colorModel == null) setModel();

    int red   = colorModel.getRed(index);
    int green = colorModel.getGreen(index);
    int blue  = colorModel.getBlue(index);
    return new Color(red, green, blue);
   }

   /** Retourne une couleur choisie au format Color */
   public static Color getColor(String key)
   {
     for(int i = 0; i < nom.length; i++)
     {
      if( nom[i].equalsIgnoreCase(key)) return getColor(i);
     }

     return(Color.lightGray);
   }

   /** Voir si on utilise colorModel */
   /*
   public static int getRed(int i)   { return Math.abs((int) r[i]); }
   public static int getGreen(int i) { return Math.abs((int) r[i]); }
   public static int getBlue(int i)  { return Math.abs((int) r[i]); }
   */

   /** Retourne une couleur pour TextArea */

   /*
    public static Color getAreaColor(String key)
   {
     for(int i = 0; i < nom.length; i++)
     {
      if( nom[i].equalsIgnoreCase(key))
       {
        Color c = getColor(i);
        if(AreaFlag[i]) c = c.darker();
        return c;
       }
     }

     return((Color) null);
   }
  */


   // Remplit une "choice" list
   public static void fillChoice(java.awt.Choice box)
   {
     for(int i = 0; i < nom.length; i++)
      {
        box.add(nom[i]);
      }
   }

   // Numro d'une couleur pour initialiser

   static public int getIndex(String key)
   {
     for(int i = 0; i < nom.length; i++)
     {
      if( nom[i].equalsIgnoreCase(key)) return i;
     }
     return -1;
   }


   /** Dfinit les composantes d'une couleur */
   static public void changeColor(int index, Color color)
   {
    /*
     Disp.it("index " + index);
     Disp.it("old color " + getColor("User").toString());
     Disp.it("new color " + color.toString());
     Disp.it("previous r " + r[index] + " g " + g[index] + " b " + b[index]);
     */
     if((index >= 0) && (index < couleur.length))
     {
      couleur[index] = color;
      setComponents(index);
      setModel();
     }
     else
      System.out.println("Bad color index " + index);
   }

   static public void changeColor(String color, Color col)
   {
     changeColor(getIndex(color), col);
   }

   /**
     Donne le nom d'une couleur
   */
   static public String getName(Color c)
   {
    int rgb = c.getRGB();

    for(int i = 0; i < couleur.length; i++)
    {
     if(i < nom.length)
      if(rgb == couleur[i].getRGB())
       return nom[i];
    }
    return "LightGray";

   }

	//{{DECLARE_CONTROLS
	//}}
}
