/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;


public class ComboDir extends DComboBox
{
  MenuItem miClear;
  MenuItem miAdd;
  MenuItem miRemove;
  
  PopupMenu popup = null;


  public ComboDir() { this(true, false, 0); }
  public ComboDir(int columns) { this(true, false, columns); }
  public ComboDir(boolean editable, boolean searchable, int columns)
  {
      super(editable, searchable, columns); 
  }



  public void setPopupParent(Font font)
  {
    
    popup = new PopupMenu();
    this.add(popup);
	

    miClear = new MenuItem("Clear field");
    miClear.addActionListener(this);
    miClear.setFont(font);
    popup.add(miClear);

    miAdd = new MenuItem("Add to list");
    miAdd.addActionListener(this);
    miAdd.setFont(font);
    popup.add(miAdd);

    miRemove = new MenuItem("Remove from list");
    miRemove.addActionListener(this);
    miRemove.setFont(font);
    popup.add(miRemove);
     
  }
    
    

  public void actionPerformed(ActionEvent e)
   {
	   Object source = e.getSource();
		   
	   if (source == miClear)
           {
		   editBox.setText("");
		   return;
           }
	   else
	   if (source == miAdd)
		 {
 		   addUnicItem(editBox.getText());
 	       separeDrives(); 
 	       return;
 	     } 
	   else
	   if (source == miRemove)
	    {
		   sourceActionEvent("del"); 
		   return;
	    } 
       else
        super.actionPerformed(e);
	}


    
    
	public void mousePressed(MouseEvent e)
	{

 	   if (e.isPopupTrigger())  // right button sur PC
		{
           popup.show(this, e.getX(), e.getY());
           e.consume();
	       return;
        }
       else super.mousePressed(e);
	}

	public void mouseReleased(MouseEvent e)
	{
 	   if (e.isPopupTrigger())  // right button sur PC
		{
           popup.show(this, e.getX(), e.getY());
           e.consume();
	       return;
        }
       else super.mouseReleased(e); 
	}


}
