/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;


public class ConfirmDialog extends DDialog implements ActionListener
{
    final static int CANCEL = 0;
    final static int YES = 1;
    final static int NO = 2;
    int response = CANCEL;

	java.awt.Button buttonCancel;
	java.awt.Button buttonYes;
	java.awt.Button buttonNo;
	java.awt.Label labelConfirm;

	public ConfirmDialog(java.awt.Frame parent)
	{
		super(parent);
		//setSize(insets().left + insets().right + 384,insets().top + insets().bottom + 108);
        setSize(384,108);
        //setResizable(true);

		buttonCancel = new java.awt.Button("Cancel");
		buttonCancel.setBounds(16, 66, 96, 26);
		buttonCancel.setBackground(getBackground());
		buttonCancel.addActionListener(this);
		panel.add(buttonCancel);

		buttonNo = new java.awt.Button("No");
		buttonNo.setBounds(144, 66, 96, 26);
		buttonNo.setBackground(getBackground());
		buttonNo.addActionListener(this);
		panel.add(buttonNo);

		buttonYes = new java.awt.Button("Yes");
		buttonYes.setBounds(272, 66, 96, 26);
		buttonYes.setBackground(getBackground());
		buttonYes.addActionListener(this);
		panel.add(buttonYes);

		labelConfirm = new java.awt.Label();
		labelConfirm.setBounds(22, 20, 378,30);
		labelConfirm.setFont(new Font("Dialog", Font.PLAIN, 16));
		panel.add(labelConfirm);

		setTitle("Warning");

			//{{INIT_CONTROLS
		//}}
}

	public ConfirmDialog(Frame parent, String message)
	{
	  this(parent);
      labelConfirm.setText(message);
	}

	public void actionPerformed(java.awt.event.ActionEvent event)
	{
	 Object object = event.getSource();
	 if (object == buttonYes)
	  {
	   choice = true;
       response = YES;
//       hide();
	   setVisible(false);
	  }
	 else if (object == buttonNo)
	  {
	   choice = false;
       response = NO;
	   setVisible(false);
	  }
	 else if (object == buttonCancel)
      {
       choice = false;
       response = CANCEL;
	   setVisible(false);
	  }
	}

   public int answered() { return response; }

   public void setLabel(String txt)
   {
     labelConfirm.setText(txt);
   }

	//{{DECLARE_CONTROLS
	//}}
}
