/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.LayoutManager;
import common.*;

public class DMessageBar extends DBar
{
    /** The text to display */
    Label text;
    Panel dPanel; // pour la couleur

    /**
     * Constructs a default DMessageBar.
     */

    public DMessageBar()
    {
       super(DBar.LOWERED);
       super.setLayout(new java.awt.BorderLayout(0,0));

       dPanel = new Panel();
       dPanel.setSize(2, 20);
       add(dPanel, BorderLayout.WEST);

       Panel tPanel = new Panel();
       tPanel.setLayout(new GridLayout());
       add(tPanel, BorderLayout.CENTER);

       tPanel.add(text = new Label());
    		//{{INIT_CONTROLS
		//}}
}


    /** Sets the text that is displayed */

    public void setText(String s)
    {
      text.setText(s);
      repaint();
    }

    /** Gets the text currently displayed  */
    public String getText() { return text.getText(); }

    /**
       Le style s'applique au texte et non au bord du composant
      */
    public void setStyle(Style s)
    {
      text.setBackground(s.background);
      text.setForeground(s.foreground);
      text.setFont(s.font);
      dPanel.setBackground(s.background);
      dPanel.setFont(s.font);
    }

    /** Sets the color of the text that is displayed  */
    public void setTextForeground(Color c) { text.setForeground(c); }
    public void setTextBackground(Color c) { text.setBackground(c); }

	/** Clears the text that gets displayed */
    public void clear() { setText(""); }

/*
	public void paint(Graphics g)
	{
		Dimension cr = getSize();

		int w = cr.width - (insets.left + insets.right);
		int h = cr.height - (insets.top + insets.bottom);

        text.setBounds(insets.left, insets.top, w, h);

		super.paint(g); // Place les composants  l'intrieur de DBar
	}
*/

	//{{DECLARE_CONTROLS
	//}}
}

