/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;


public class DSign extends Canvas
{

    // Style
    public static final int NONE = 0;
    public static final int RAISED = 1;
    public static final int LOWERED = 2;
    public static final int LINE = 3;
    protected int bevel;

    // Couleurs
    protected Color background;
    protected Color foreground;
    protected Color dark;
    protected Color light;
    protected int width;
    protected int height;

    protected Insets insets = new Insets(1,1,1,1);

    /** Constructs a default DSign */

    public DSign() { this(LINE); }

    public DSign(int bevel)
    {
       super();
       this.bevel = bevel;
    }


    // Dfinir le style

    public void setBevel(int s) { bevel = s; }

    public void SetInsets(Insets in) { insets = in; }
    public Insets GetInsets() { return insets; }


    public void setBackground(Color b)
    {
     background = b;
     light = b.brighter();
     dark  = b.darker();
     repaint();
    }

    public void setForeground(Color f)
    {
     foreground = f;
     repaint();
    }


    public void update(Graphics g) { paint(g); }

	public void paint(Graphics g)
	{
		Dimension dim = getSize();
		width  = dim.width;
		height = dim.height;

        g.setColor(background);
        g.fillRect(1, 1, this.width - 2, this.height - 2);
        drawBorder(g, 0, 0, this.width - 1, this.height - 1);
	}


	protected void drawBorder(Graphics g, int x, int y, int w, int h)
	{
	  switch(bevel)
	    {
	     case RAISED :
	       g.setColor(light);
	       g.drawLine(x, y, x + w, y);
	       g.drawLine(x, y, x, y + h);
	       g.setColor(dark);
	       g.drawLine(x, y + h, x + w, y + h);
	       g.drawLine(x + w, y, x + w, y + h);
	       break;
         case LOWERED :
	       g.setColor(dark);
	       g.drawLine(x, y, x + w, y);
	       g.drawLine(x, y, x, y + h);
	       g.setColor(light);
	       g.drawLine(x, y + h, x + w, y + h);
	       g.drawLine(x + w, y, x + w, y + h);
	       break;
         case LINE :
	       g.setColor(foreground);
	       g.drawRect(x, y, w, h);
	       break;
         case NONE : break;
	     default:    break;
	    }
	}

}

