/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;

/**
    DWindow
    Classe de base des fentre de dialogue sans barre de titre
*/

public class DWindow extends Window implements WindowListener
{

	public DWindow(Frame parent)
	{
	 super(parent);
         setLayout(null);
	 setVisible(false);

	 this.addWindowListener(this);
	}


	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.

		super.addNotify();

	    // Only do this once.
		if (fComponentsAdjusted) return;

		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + getSize().width, getInsets().top + getInsets().bottom + getSize().height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}

        // Used for addNotify check.
		fComponentsAdjusted = true;
	}

	public synchronized void setVisible(boolean b)
	{
          if(b)
          {
		Rectangle bounds = getParent().getBounds();
		Rectangle abounds = getBounds();

		setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);
          }
  	  super.setVisible(b);
	}


    // Used for addNotify redundency check.
    boolean fComponentsAdjusted = false;

    public void windowOpened(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}
    public void windowClosing(java.awt.event.WindowEvent event)
	 {
       if (event.getSource() == DWindow.this) dispose();
	 }

}
