/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class DialogCompare extends DDialog implements ActionListener
{
    java.awt.Panel panelControl;
    java.awt.Button buttonStart;
    java.awt.Button buttonCancel;
    public java.awt.Label labelComp;

    java.awt.Label labT;
    java.awt.Label labG;
    java.awt.Label labS;
    java.awt.Label labB;

    java.awt.Label labTotal;
    java.awt.Label labGood;
    java.awt.Label labSkip;
    java.awt.Label labBad;
    Label labSource;
    public Label labTarget;
    java.awt.TextArea textArea1;

    public String[] theList;
    public String source;
    public String target;
    public String result;

    Frame parent;
    public DMessageBar statusBar;

   public DialogCompare(Frame parent, boolean modal)
     {
        super(parent, modal);
        this.parent = parent;

        panel.setLayout(new BorderLayout(0,0));

        setVisible(false);
        setSize(getInsets().left + getInsets().right + 533,getInsets().top + getInsets().bottom + 381);

        panelControl = new java.awt.Panel();
        panelControl.setLayout(null);
        panelControl.setBounds(getInsets().left + 0,getInsets().top + 0,533,152);
        panel.add("North", panelControl);

        buttonStart = new java.awt.Button();
        buttonStart.setLabel(" Start ");
        buttonStart.setBounds(372,80,144,26);
        buttonStart.addActionListener(this);
        panelControl.add(buttonStart);

        buttonCancel = new java.awt.Button();
        buttonCancel.setLabel(" Close ");
        buttonCancel.setBounds(372,112,144,26);
        buttonCancel.addActionListener(this);
        panelControl.add(buttonCancel);

        labelComp = new java.awt.Label("Analyzing...Wait");
        labelComp.setBounds(16,12,108,24);
        panelControl.add(labelComp);

        labSource = new Label(source);
        labSource.setBounds(16,36,500,20);
        panelControl.add(labSource);

        labTarget = new Label(target);
        labTarget.setBounds(16,60,500,20);
        panelControl.add(labTarget);

        labT = new java.awt.Label("Files total");
        labT.setAlignment(Label.CENTER);
        labT.setBounds(20,92,80,20);
        panelControl.add(labT);

        labG = new java.awt.Label("Good");
        labG.setAlignment(Label.CENTER);
        labG.setBounds(100,92,80,20);
        panelControl.add(labG);

        labS = new java.awt.Label("Skipped");
        labS.setAlignment(Label.CENTER);
        labS.setBounds(180,92,80,20);
        panelControl.add(labS);

        labB = new java.awt.Label("Bad");
        labB.setAlignment(Label.CENTER);
        labB.setBounds(260,92,80,20);
        panelControl.add(labB);


        labTotal = new java.awt.Label("");
        labTotal.setBounds(20,114,76,20);
        labTotal.setBackground(Color.black);
        labTotal.setForeground(Color.green);
        labTotal.setAlignment(Label.RIGHT);
        panelControl.add(labTotal);

        labGood = new java.awt.Label("");
        labGood.setBackground(Color.black);
        labGood.setForeground(Color.green);
        labGood.setAlignment(Label.RIGHT);
        labGood.setBounds(100,114,76,20);
     	panelControl.add(labGood);

        labSkip = new java.awt.Label("");
        labSkip.setBounds(180,114,76,20);
        labSkip.setBackground(Color.black);
        labSkip.setForeground(Color.green);
        labSkip.setAlignment(Label.RIGHT);
        panelControl.add(labSkip);

        labBad = new java.awt.Label("");
        labBad.setBounds(260,114,76,20);
        labBad.setBackground(Color.black);
        labBad.setForeground(Color.green);
        labBad.setAlignment(Label.RIGHT);
        panelControl.add(labBad);

        textArea1 = new java.awt.TextArea();
        textArea1.setBounds(getInsets().left + 0,getInsets().top + 152,533,229);
        panel.add("Center", textArea1);

        setTitle(" Files Compare");
   }


 public DialogCompare(Frame parent, String title, boolean modal)
  {
       this(parent, modal);
       setTitle(title);
  }

  public void go()
  {
   DirTools.cd = this;
   labelComp.setText("Comparing...");
   panelControl.setCursor(new Cursor(Cursor.WAIT_CURSOR));
   result = DirTools.treeComp(parent, source, target, theList);
   panelControl.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
   if(statusBar != null)
     statusBar.setText(" " + result);
  }


 static boolean alreadyFlag;
 public void exiting()
 {
  setVisible(false);
  dispose();
 }

 public void actionPerformed(java.awt.event.ActionEvent event)
  {
    Object object = event.getSource();

	if (object == buttonCancel)	exiting();
    else if(object == buttonStart) go();
  }


 public void keyPressed(java.awt.event.KeyEvent event)
   {
    if(event.isControlDown() || event.isAltDown()) return;
    if(event.getKeyCode() == KeyEvent.VK_ESCAPE)
     {
      choice = ESCAPE;
      exiting();
   	 }
   }

 public void windowClosing(WindowEvent event)
  {
    if(thread != null)
     {
          if(thread.isAlive()) thread.destroy();
          thread = null;
     }
    exiting();
  }

 public void setSource(String s) { labSource.setText(s);}
 public void setTarget(String s) { labTarget.setText(s);}

 public void setTotal(int i) { labTotal.setText(Integer.toString(i)); }
 public void setGood(int i) { labGood.setText(Integer.toString(i)); }
 public void setSkip(int i) { labSkip.setText(Integer.toString(i)); }
 public void setBad(int i) { labBad.setText(Integer.toString(i)); }

 public void setResult(String s) { textArea1.append(s + "\n"); }

}
