/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class DialogUpdate extends DDialog implements ActionListener, ItemListener
{
    java.awt.Panel panelControl;
    java.awt.Button buttonStart;
    java.awt.Button buttonCancel;
    public java.awt.Label labelComp;

    DCheckbox checkAdd;
    DCheckbox checkReplace;
    DCheckbox checkAddPrompt;
    DCheckbox checkReplacePrompt;

    DLabel labT;
    DLabel labG;
    DLabel labS;
    DLabel labA;
    DLabel labR;

    Label labTotal;
    Label labGood;
    Label labSkip;
    Label labAdded;
    Label labReplaced;

    Label labSource;
    public Label labTarget;
    java.awt.TextArea textArea1;

    public String[] theList;
    public String source;
    public String target;
    public String result;

    Frame parent;
    public DMessageBar statusBar;

    boolean addFlag;
    boolean addPrompt;
    boolean replaceFlag;
    boolean replacePrompt;

   public DialogUpdate(Frame parent, boolean modal)
     {
        super(parent, modal);
        this.parent = parent;

        panel.setLayout(new BorderLayout(0,0));

        setVisible(false);
        setSize(getInsets().left + getInsets().right + 533,getInsets().top + getInsets().bottom + 381);

        panelControl = new java.awt.Panel();
        panelControl.setLayout(null);
        panelControl.setBounds(getInsets().left + 0,getInsets().top + 0,533,172);
        panel.add("North", panelControl);

        buttonStart = new java.awt.Button();
        buttonStart.setLabel(" Update ");
        buttonStart.setBounds(16,10,112,26);
        buttonStart.addActionListener(this);
        panelControl.add(buttonStart);

        buttonCancel = new java.awt.Button();
        buttonCancel.setLabel(" Close ");
        buttonCancel.setBounds(16,40,112,26);
        buttonCancel.addActionListener(this);
        panelControl.add(buttonCancel);

        labelComp = new java.awt.Label("Analyzing...Wait");
        labelComp.setBounds(212,8,250,22);
        panelControl.add(labelComp);

        checkAdd = new DCheckbox("Add new files", true);
        checkAdd.setBounds(212, 32, 132, 22);
        checkAdd.addItemListener(this);
        panelControl.add(checkAdd);

        checkAddPrompt = new DCheckbox("Prompt to add", false);
        checkAddPrompt.setBounds(360, 32, 132, 22);
        checkAddPrompt.addItemListener(this);
        panelControl.add(checkAddPrompt);

        checkReplace = new DCheckbox("Replace existing", true);
        checkReplace.setBounds(212, 50, 132, 22);
        checkReplace.addItemListener(this);
        panelControl.add(checkReplace);

        checkReplacePrompt = new DCheckbox("Prompt to replace", false);
        checkReplacePrompt.setBounds(360, 50, 132, 22);
        checkReplacePrompt.addItemListener(this);
        panelControl.add(checkReplacePrompt);


        labSource = new Label(source);
        labSource.setBounds(16,74,500,20);
        panelControl.add(labSource);

        labTarget = new Label(target);
        labTarget.setBounds(16,96,500,20);
        panelControl.add(labTarget);

        Color tcol = new Color(100, 100, 100);
        labT = new DLabel("Files total", DLabel.BEVEL_RAISED);
        labT.setAlignment(Label.CENTER);
        labT.setBounds(20,122,77,20);
        labT.setTextColor(tcol);
        panelControl.add(labT);

        labG = new DLabel("Same", DLabel.BEVEL_RAISED);
        labG.setAlignment(Label.CENTER);
        labG.setBounds(100,122,77,20);
        labG.setTextColor(tcol);
        panelControl.add(labG);

        labS = new DLabel("Skipped", DLabel.BEVEL_RAISED);
        labS.setAlignment(Label.CENTER);
        labS.setBounds(180,122,77,20);
        labS.setTextColor(tcol);
        panelControl.add(labS);

        labA = new DLabel("Added", DLabel.BEVEL_RAISED);
        labA.setAlignment(Label.CENTER);
        labA.setBounds(260,122,77,20);
        labA.setTextColor(tcol);
        panelControl.add(labA);

        labR = new DLabel("Replaced", DLabel.BEVEL_RAISED);
        labR.setAlignment(Label.CENTER);
        labR.setBounds(340,122,77,20);
        labR.setTextColor(tcol);
        panelControl.add(labR);


        labTotal = new Label("");
        labTotal.setBounds(20,144,76,20);
        labTotal.setBackground(Color.black);
        labTotal.setForeground(Color.green);
        labTotal.setAlignment(Label.RIGHT);
        panelControl.add(labTotal);

        labGood = new Label("");
        labGood.setBackground(Color.black);
        labGood.setForeground(Color.green);
        labGood.setAlignment(Label.RIGHT);
        labGood.setBounds(100,144,76,20);
     	panelControl.add(labGood);

        labSkip = new Label("");
        labSkip.setBounds(180,144,76,20);
        labSkip.setBackground(Color.black);
        labSkip.setForeground(Color.green);
        labSkip.setAlignment(Label.RIGHT);
        panelControl.add(labSkip);

        labAdded = new Label("");
        labAdded.setBounds(260,144,76,20);
        labAdded.setBackground(Color.black);
        labAdded.setForeground(Color.green);
        labAdded.setAlignment(Label.RIGHT);
        panelControl.add(labAdded);

        labReplaced = new Label("");
        labReplaced.setBounds(340,144,76,20);
        labReplaced.setBackground(Color.black);
        labReplaced.setForeground(Color.green);
        labReplaced.setAlignment(Label.RIGHT);
        panelControl.add(labReplaced);


        textArea1 = new java.awt.TextArea();
        textArea1.setBounds(getInsets().left + 0,getInsets().top + 152,533,229);
        panel.add("Center", textArea1);

        setTitle(" Update tagged directories and files");
   }


 public DialogUpdate(Frame parent, String title, boolean modal)
  {
       this(parent, modal);
       setTitle(title);
  }

  public void go()
  {
   DirTools.setDialog((Object) this);
   labelComp.setText("Comparing...");
   panelControl.setCursor(new Cursor(Cursor.WAIT_CURSOR));
   result = DirTools.treeComp(parent, source, target, theList);
   panelControl.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
   if(statusBar != null)
     statusBar.setText(" " + result);
  }


 static boolean alreadyFlag;
 public void exiting()
 {
  setVisible(false);
  dispose();
 }

 public void actionPerformed(java.awt.event.ActionEvent event)
  {
    Object object = event.getSource();

	if (object == buttonCancel)	exiting();
    else if(object == buttonStart) go();
  }


 public void keyPressed(java.awt.event.KeyEvent event)
   {
    if(event.isControlDown() || event.isAltDown()) return;
    if(event.getKeyCode() == KeyEvent.VK_ESCAPE)
     {
      choice = ESCAPE;
      exiting();
   	 }
   }

 public void windowClosing(WindowEvent event)
  {
    if(thread != null)
     {
          if(thread.isAlive()) thread.destroy();
          thread = null;
     }
    exiting();
  }

 public void setSource(String s) { labSource.setText(s);}
 public void setTarget(String s) { labTarget.setText(s);}

 public void setTotal(int i) { labTotal.setText(Integer.toString(i)); }
 public void setGood(int i) { labGood.setText(Integer.toString(i)); }
 public void setSkip(int i) { labSkip.setText(Integer.toString(i)); }
 public void setAdded(int i) { labAdded.setText(Integer.toString(i)); }
 public void setReplaced(int i) { labReplaced.setText(Integer.toString(i)); }

 public void setResult(String s) { textArea1.append(s + "\n"); }

 public void itemStateChanged(java.awt.event.ItemEvent event)
  {
     Object object = event.getSource();

     if (object == checkAdd)
         addFlag = checkAdd.getState();
     else if (object == checkReplace)
         replaceFlag = checkReplace.getState();
     else if (object == checkAddPrompt)
         addPrompt = checkAddPrompt.getState();
     else if (object == checkReplacePrompt)
         replacePrompt = checkReplacePrompt.getState();
   }

}
