/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

/**
    Etends DListBox
    Rajoute les noms barrs avant effacement
*/


public class DirSimple extends DListBox
{


 public DirSimple(boolean mselect)
 {
  super(mselect);
  //{{INIT_CONTROLS
		setLayout(null);
		setSize(0,0);
		//}}
}

 public DirSimple()
 {
  this(true);
 }


    /** Barrer l'item */

 public void crossOff(int index)
  {
   if (validIndex(index))
     {
         ListItem tempItem = ((ListItem)items.elementAt(index));
         tempItem.deleted = true;
         tempItem.bDirty = true;
     }
  }

 public void crossOff(int index, boolean val)
  {
    if (validIndex(index))
     {
      ListItem tempItem = ((ListItem)items.elementAt(index));
      tempItem.deleted = val;
      tempItem.bDirty = true;
     }
  }


 /** Fichier barr? */
 public boolean isCrossedOff(int index)
  {
   if (validIndex(index))
     {
       ListItem tempItem = ((ListItem)items.elementAt(index));
       return(tempItem.deleted);
     }
   return false;
 }


/** S'il existe au moins un fichier barr  */

public boolean isCrossedOff()
 {
  int l = items.size();

  for(int index = 0; index < l; index++)
   {
     ListItem tempItem = ((ListItem)items.elementAt(index));
     if(tempItem.deleted) return true;
   }
  return false;
}


/**
  * Selects all the items in the list.
  */
public synchronized void selectAllFiles(int MAXINDIRS)
  {
    if (!bMultipleSelections)  return;

    int s = items.size();
    ListItem li;
    for (int i = MAXINDIRS; i < s; i++)
     {
      li = (ListItem)items.elementAt(i);
      if (li.bEnabled) li.bSelected = true;
     }

    countSelected = s;
    lastSelected = s - 1;
    repaint();
 }

}
