/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.util.*;
import common.*;

/**
    Outils sur rpertoire
    voir: Path
*/

public class DirTools
{

 public static long fileSize;
 public static int fileNumber;
 public static String message = "";


 // tailles des fichiers cumules

 public static void scanDir(String dir)
  {
   String[] list = (new File(dir)).list();
   int l = list.length;

   for(int i = 0; i < l; i++)
    {
      String fic = list[i];

      File file = new File(dir, fic);
      if(file.isDirectory()) scanDir(Path.merge(dir, fic));
      else
      {
       fileSize += file.length();
       fileNumber++;
      }
   }

   return;
 }


 /** Taille d'un rpertoire */

 public static void folderSize(String path, String name)
 {
   File file = new File(path, name);
   if(file.isDirectory()) scanDir(Path.merge(path, name));
   else
    {
     fileSize += file.length();
     fileNumber++;
    }
   return;
 }

 public static final int SELECT = 0;
 public static final int FULL = 1;
 public static String base;

 static public void occupation(String dir, String[] l, int mode)
 {
   String name = null;
   fileNumber = 0;
   fileSize = 0;

   if (l.length == 0)
    {
      message = "No files";
      return;
    }

   if (mode == SELECT)
   {
     if (l.length == 1)  name = l[0];
     else                name = "tagged list";
   }
   else name = "";

   for (int i = 0; i < l.length; i++)
    {
     folderSize(dir,  l[i]);
    }

   base = " bytes";
   if(fileSize > 10240) { fileSize /= 1024; base = " k. bytes"; }
   if(fileSize > 10240) { fileSize /= 1024; base = " mega bytes";}
   name = Path.merge(dir, name);
   String plur = "";
   if (fileNumber > 1) plur ="s";
   message = name + ", disk occupation is " + fileSize + base + "   " + fileNumber + " file" + plur;

 }


 public static int intConvert(int origin)
 {
  int un = (origin >> 24) & 255;
  int deux = (origin >> 16) & 255;
  int trois = (origin >> 8) & 255;
  int quatre = origin & 255;

  return (quatre << 24) + (trois << 16) + (deux << 8) + un;
 }

 public static short shortConvert(short origin)
 {
  int high = ((int) origin >> 8) & 255;
  int low  = (int) origin & 255;

  return (short) ((low << 8) + high);
 }

 static public boolean EXECUTABLE = false;
 static public boolean MSDOS = false;
 static public boolean COMMANDLINE = false;
 static public boolean WIN31 = false;
 static public boolean WIN95 = false;


 /* Test si fichier DOS */

 public static void exeTest(String path)
  {
    int i;
    EXECUTABLE = false;
    MSDOS = false;
    WIN31 = false;
    COMMANDLINE = false;
    WIN95 = false;

    try
    {
	 DataInputStream fiS = new DataInputStream(new FileInputStream(path));

     int available = fiS.available();


     if(available >= 28)
     try
     {
      byte high = fiS.readByte();
      byte low  = fiS.readByte();

      EXECUTABLE = ((high == 0x4d) && (low == 0x5a));
      //System.out.println("high=" + high + " low=" + low);

      fiS.readInt();   // lit en octet 2

      short items = shortConvert(fiS.readShort()); // en 6
      short para  = shortConvert(fiS.readShort()); // en 8
      MSDOS = ((para < 3) || (items > 0));

      //System.out.println("items " + items + " para " + para);
      //System.out.println("exe " + EXECUTABLE + " dos " + MSDOS);
      fiS.readInt();  // skip extra segments en 10
      fiS.readInt();  // skip stack en 14
      fiS.readInt();  // skip checksum etc... en 18
      fiS.readShort(); // en 22

      short relocOffset = shortConvert(fiS.readShort()); // en 24
      MSDOS = MSDOS | (relocOffset < 0x40);
      MSDOS = MSDOS | ((items == 0) && (relocOffset != 0x40));

      fiS.readShort(); // en 26

      if(MSDOS == false)
      {

       for(i = 0; i < 8; i++)
        fiS.readInt();  // skip reserved de 28  59

       int offset = intConvert(fiS.readInt()); // offset new header en 60
       //Disp.it("offset = " + offset);

       for(i = 64; i < offset; i++)     // de 64  fin d'offset
         fiS.readByte(); // move to new header

       high = fiS.readByte();
       low  = fiS.readByte();

       //System.out.println("high=" + high + " low=" + low);

       if((high == 0x4E) && (low == 0x45))
       {
        WIN31 = true;
       }
       else
       {
         if((high == 0x50) && (low == 0x45)) WIN95 = true;

         for(i = 2; i < 20; i++)
         fiS.readByte();  // pass new header

         int optsize = shortConvert(fiS.readShort());

         fiS.readShort(); // skip

         high = fiS.readByte();
         low  = fiS.readByte();

         if((high != 0x0B) || (low != 0x01))
          System.out.println("Magic number not found " + high + " " + low);

         if(optsize > 68)
         {
          for(i = 2; i < 68; i++)
           fiS.readByte();  // move to GUI/COMMAND

          int mode = fiS.readByte();

          //Disp.it("mode=" + mode);
          if(mode == 3) COMMANDLINE = true;
         }


       } // win95

      } // pas MSDOS

     } catch(IOException e) { e.printStackTrace(); }

     fiS.close();
   } catch (IOException e) { e.printStackTrace(); }

     return;
   }



 /**
     Teste si le fichier est un excutable DOS
 */

 static public boolean isMSDOS(String path, String name)
 {
  return isMSDOS(Path.merge(path, name));
 }

 static public boolean isMSDOS(String path)
 {
  if(!OS.isWindows()) return false;
  exeTest(path);

  return EXECUTABLE & MSDOS;
 }

 static public boolean isCOMMAND() { return COMMANDLINE; }
 static public boolean isWIN31() { return WIN31; }


 /** Test si c'est un executable */

 static public boolean isExecutable(String path)
 {
  path = path.toLowerCase();

  if (OS.isWindows())
  {
     if (path.endsWith(".exe")) return true;
     if (path.endsWith(".pif")) return true;
     if (path.endsWith(".com")) return true;
     return false;
  }

  return false;
 }

  /** Comparaison */

 public static boolean compareBytes(byte[] buf1, byte[] buf2, int count)
  {
    for (int i = 0; i < count; i++)
      if (buf1[i] != buf2[i]) return false;
    return true;
  }

  /**
     Compare deux fichiers
     retourne TRUE si identique
  */


  static public boolean compare(String path1, String path2)
  {
    if(stopFlag) return false;
    File f1 = new File(path1);
    File f2 = new File(path2);
    long total = f1.length();
    if (total != f2.length()) return false;
    long totalRead = 0;

    try
    {
     FileInputStream fis1 = new FileInputStream(f1);
     FileInputStream fis2 = new FileInputStream(f2);

     byte[] buffer1 = new byte[32*1024];
     byte[] buffer2 = new byte[32*1024];

     int  bytesRead;
     while ((bytesRead = fis1.read(buffer1, 0, buffer1.length)) > 0)
     {
      if (fis2.read(buffer2, 0, buffer2.length) != bytesRead) return false;
      if (!compareBytes(buffer1, buffer2, bytesRead)) return false;
      totalRead += bytesRead;
     }
     fis1.close();
     fis2.close();
    }
    catch(FileNotFoundException f) { f.printStackTrace(); }
    catch(IOException i) { i.printStackTrace(); }

    return total == totalRead;
  }


  static int countnf;
  static int countok;
  static int countbad;
  static int count;
  static int dirNoFound;
  static DialogCompare cd;

  static boolean stopFlag;

 public static void dirComp(String origine, String destination, String[] fics)
  {
   if(stopFlag) return;
   for(int i = 0; i < fics.length; i++)
    {
     try
      {
       String fic = fics[i];
       File fSource = new File(origine, fic);
       File fTarget = new File(destination, fic);

       String source = Path.merge(origine, fic);
       cd.setSource(source);

       if(!fTarget.exists())
         {
           cd.setTarget("");
           cd.setResult(source + " skipped, no found in target");
           if(fSource.isDirectory()) dirNoFound++;
           else
           {
            countnf++;
            count++;
           }
         }
       else
         {
           String target = Path.merge(destination, fic);
           cd.setTarget(target);
           if (fSource.isDirectory())
           {
            dirComp(source, target, fSource.list());
           }
           else
           {
            count++;
            boolean compared = compare(source, target);
            if( compared) countok++;
            else
            {
              cd.setResult(source + " and " + target + " *** differ");
              countbad++;
            }
           } //else directory
         } //else exists
       } catch(ArrayIndexOutOfBoundsException e) { e.printStackTrace(); }

      cd.setTotal(count);
      cd.setGood(countok);
      cd.setSkip(countnf);
      cd.setBad(countbad);

     } // fin for
   }


 public static void setDialog(Object o)
 {
   cd = (DialogCompare) o;
 }

  /** Compare dans deux arbos */

 public static String treeComp(Frame f, String origine, String destination, String[] fics)
  {
   countnf = 0;
   countok = 0;
   countbad = 0;
   count = 0;
   dirNoFound = 0;
   stopFlag = false;

   cd.setSource(origine);
   cd.setTarget(destination);
   cd.alreadyFlag = false;

   dirComp(origine, destination, fics);

   String res;
   cd.alreadyFlag = false;
   if(stopFlag)
   {
    res = "Interrupted by user...";
    cd.setResult(res);
    return res;
   }

   res = "Files identical: " + countok + " / " + count;
   cd.setResult(res);
   cd.setResult("Files not found: " + countnf);
   cd.setResult("Files different: " + countbad);
   cd.setResult("Directories not found: " + dirNoFound);

   int err = countnf + countbad + dirNoFound;
   if(err == 0) cd.setResult("PERFECT COPY or BURNING");
   else
   {
     cd.setResult("There are errors");
   }

   return res;
  }


 //---------------------------------- EXEC

  static public int messnum = 0;

  static public final int MESSAGE = 0;
  static public final int TIP = 1;

 public void Message(String s) { message = s; messnum = MESSAGE; sourceActionEvent(); };
 public void dispTip(String s) { message = s; messnum = TIP; sourceActionEvent(); };

 ActionListener actionListener = null;

  protected void sourceActionEvent()
   {
	 if (actionListener == null) return;
	 actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, ""));
   }

  /** Adds a to receive action events  */
  public void addActionListener(ActionListener l)
   {
	 actionListener = AWTEventMulticaster.add(actionListener, l);
   }




 static   Process process;

 /**
      Lancement d'un utilitaire du systme
      prog: le nom
      path: un rpertoire en paramtre
      dispmess: message ou non
 */

 public void Run(String prog, String path, boolean dispmess)
  {
    String command = prog;

    if(path != null)
    {
     command = command + " " + path;
    }

    if(dispmess) dispTip("Launching " + prog);
    //Runtime rc = Runtime.getRuntime();
    try {
      process = Runtime.getRuntime().exec(command);
      try { process.waitFor(); }
      catch (InterruptedException i) {  }
    }
    catch (IOException ioe)
    {
      Message(prog + " not in PATH, update AUTOEXEC.BAT");
      return;
    };
  }

  /** Lancement d'un programme */

public void Launch(String fullpath, String name)
  {
    //debug("launch " + fullpath + " " + name);
    //Runtime rc = Runtime.getRuntime();
    boolean ok = false;

    String message = "Enable to run " + fullpath;

    try { process = Runtime.getRuntime().exec(fullpath);
    try { process.waitFor(); } catch (InterruptedException i) { }
     ok = true;
    }
    catch (IOException ioe) { ioe.printStackTrace(); };

    if(!ok) Message(message);
  }


 /** Run a java Program, class or jar */

 public void runJava(String prog, String path)
  {
   String ext = Path.getExtension(path).toLowerCase();

   if (ext.compareTo("jar") == 0) prog = prog = " -jar";
   else if (ext.compareTo("class") != 0) return;

   String node = Path.getNode(path);
   String dir  = Path.getPath(path);

   Message("Launching java program: " + node);

/*
   try {
    String command;
     command = "cd \"" + dir + "\"";
     System.out.println(command);
     process = Runtime.getRuntime().exec(command);
     try { process.waitFor(); } catch (InterruptedException i)
     {
       System.out.println("CD command not recognized");
     }
   }
   catch (IOException ioe) { ioe.printStackTrace(); };
*/

   path = "\"" + node + "\"";
   System.out.println("Process " + prog + " " + path);


   LaunchPrgFile(prog, path);
  }

 /** Lance un programme avec un fichier en paramtre */

public class ProgThread extends Thread implements Runnable
  {
   String path = null;
   String prog = null;
   boolean dispmess = true;
   boolean result = false;

   public void run()
   {
    result = ProgAction(prog, path, dispmess);
    //Disp.it("thread result=" + result);
   }
  }

  private String enclose(String prog, String path)
  {
   String name = Path.getFile(prog);
   String sep = "\"";
   if(name.equalsIgnoreCase("winhelp.exe")) sep = "";

   return prog + " " + sep + path + sep;
  }

  boolean actionresult = true;
  boolean ProgAction(String prog, String path, boolean dispmess)
  {
   //Runtime rc = Runtime.getRuntime();
   boolean result = true;
   //Disp.it("prog action " + prog + " " + path );
   String message = "Enable to run " + prog + " with " + path  ;

   try {
     process = Runtime.getRuntime().exec(enclose(prog, path));
     try { process.waitFor(); }
     catch (InterruptedException i) { }
     message = "Launched " + prog + " with " + path;
   }
   catch (IOException ioe) { ioe.printStackTrace(); result = false; };

   if(dispmess) Message(message);
   //Disp.it("progr action result " + result);
   actionresult = result; // a cause dlai
   return result;
 }

 public boolean LaunchPrgFile(String prog, String path)
  {
     //System.out.println("start launchprgfile");
     ProgThread p = new ProgThread();
     p.prog = prog;
     p.path = path;
     p.dispmess = true;
     p.start();

     return actionresult;
  }



  /** Sound */

  ProgThread tSound = null;

 public void sound(String path, String name)
   {
     dispTip("Playing " + name);

     if(process != null) process.destroy();
//     ProgThread p = new ProgThread();
     tSound = new ProgThread();
     tSound.prog = "sndrec32.Exe /play /embedding";
     tSound.path = path;
     tSound.dispmess = false;
     tSound.start();

     //if(!p.result) Message("Enable to run sndrec32.exe");
     return;
   }


 public void free()
  {
    Runtime rc = Runtime.getRuntime();
    long before = rc.freeMemory();
    long total  = rc.totalMemory();
    System.gc();
    dispTip("Free memory now increased from " + before + " to " + rc.freeMemory() + " bytes, out of " + total + " bytes.");
  }



 static public SimpleDateFormat fileDate =
  new SimpleDateFormat ("EEEE d MMMM yyyy   kk:mm:ss");

 static public String info(String fname)
 {
  File f = new File(fname);

  long l = f.length();
  long t = f.lastModified();

  String s = Tool.longToString(l);
  String d = fileDate.format(new Date(t));

  return Path.getFile(fname) + ",  " + s + " bytes,  " + d;
 }


 /**
    Ouvre fentre dos sur rpertoire donn
 */

 public void console(String dir)
 {
  String[] cmd = new String[3];

  cmd[1] = "/C" ;
  cmd[2] = "cd " + dir;

  if(OS.isWindowsNT())     cmd[0] = "cmd.exe" ;
  else if(OS.isWindows())  cmd[0] = "command.com" ;
  else return;


  Runtime rt = Runtime.getRuntime();
  try {
   Process proc = rt.exec(cmd);
  } catch (Exception e) { }
  Run("dosprmpt.pif", null, false);
 }

} // class
