/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import common.*;

/**
   Classe de gestion de double liste
   en mode premier entr premier sorti
  */ 

public class FileList
{
  Menu menu;

  String paths[];
  String names[];
  int index;
  int maxsize;

  public FileList(int size)
   {
    this.maxsize = size;
    paths = new String[size];
    names = new String[size];
    index = 0;
   		
	//{{INIT_CONTROLS
	//}}
};

  public FileList() { this(8); };

  public FileList(Menu m)
   {
    this();
    menu = m;
   };


  public void setSize(int size)
  {
    maxsize = size;
    while(index > maxsize) 
    {
     remove(0);   
    } 
  }  
  /**
     Ajoute inconditionellement un lment
    */
    
  public boolean add(String path, String fic)
  {
    // index vaut 8 si maxsize = 8
    // remove le ramne  7 et dcale la liste
    if(index >= maxsize) remove(0);    

    paths[index] = path;
    names[index] = fic;
    index++;
    
    //Disp.it("add passed");
    return true;
  }

  public boolean add(String fullpath)
  {
    Path.split(fullpath);
    return add(Path.ADir, Path.Filename);
  }

 /** Test si dja prsent */
 public boolean already(String path, String fic)
 {
   return (find(path, fic) != -1); 
 }

 /** Cherche un lment dans la liste */
 public int find(String path, String fic)
 {
   for(int i = 0; i < index; i++)
    {
      if(fic.equalsIgnoreCase(names[i]))
       if(path.equalsIgnoreCase(paths[i]))
        return i;
    } 
   return -1; 
 }


  public boolean addUnic(String path, String fic)
   {
     if(already(path, fic)) return false;
     return add(path, fic);
   }


  public void remove(int no)
  {
    if(no < 0) return;
    if(no >= index) return;
    
    int last = index - 1;
    
    for(int i = no; i < last; i++)
    {
     paths[i] = paths[i + 1];
     names[i] = names[i + 1];
    } 
    index--;    
  }  
  
  
  public void remove(String path, String fic)
  {
    remove(find(path, fic));
  }  
  /**
     Retourne l'lment sous forme concatne
    */
    
  public String get(int index)
  {
    return Path.merge(paths[index], names[index]); 
  }  

  public void clear() 
  { 
    index = 0; 
    for(int i = 0; i < maxsize; i++) names[i] = "";
  }

  public String getName(int no) { return names[no]; }
  public String getDir(int no) { return paths[no]; }
  public String getFullPath(int no) { return get(no); }
	
	//{{DECLARE_CONTROLS
	//}}
};

