/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

// Java Code

import java.awt.*;
import java.awt.image.*;
import comgr.GrayFilter;
import comgr.PaletteShaded;


public class Icons extends Component
{

 public static Image SwapGray;
 public static Image LR;
 public static Image LRGray;
// public static Image RunImg;
// public static Image RunGray;
// public static Image EditImg;
// public static Image EditGray;


 public static Image DCompGray;
// public static Image RenameGray;
 public static Image CopyGray;
 public static Image Unzip;
 public static Image UnzipGray;

// Constructor

   public Icons()
   {

//    Go = createImage(new MemoryImageSource(GoWidth, GoHeight, GoRGB, 0, GoWidth));

    Swap = createImage(new MemoryImageSource(SwapWidth, SwapHeight, SwapRGB, 0, SwapWidth));
    SwapGray = GrayFilter.createDisabledImage(Swap);

    LR = getImage(LRDesc, CopyLeft);
    LRGray = GrayFilter.createDisabledImage(LR);

/*
    RunImg = getImage(Run);
    RunGray = GrayFilter.createDisabledImage(RunImg);

    EditImg = getImage(Edit);
    EditGray = GrayFilter.createDisabledImage(EditImg);
  */

    Locate = createImage(new MemoryImageSource(LocateWidth, LocateHeight, LocateRGB, 0, LocateWidth));

    Dcomp = createImage(new MemoryImageSource(DcompWidth, DcompHeight, DcompRGB, 0, DcompWidth));
    DCompGray = GrayFilter.createDisabledImage(Dcomp);

    FileCopy = createImage(new MemoryImageSource(FileCopyWidth, FileCopyHeight, FileCopyRGB, 0, FileCopyWidth));
    CopyGray = GrayFilter.createDisabledImage(FileCopy);


    Unzip = getImage(Unarcdesc, Unarc);
    UnzipGray = GrayFilter.createDisabledImage(Unzip);

    Microsoft = createImage(new MemoryImageSource(MicrosoftWidth, MicrosoftHeight, MicrosoftRGB, 0, MicrosoftWidth));


    New  = createImage(new MemoryImageSource(NewWidth, NewHeight, NewRGB, 0, NewWidth));
    Open = createImage(new MemoryImageSource(OpenWidth, OpenHeight, OpenRGB, 0, OpenWidth));
    Save = createImage(new MemoryImageSource(SaveWidth, SaveHeight, SaveRGB, 0, SaveWidth));
    //Cut = createImage(new MemoryImageSource(CutWidth, CutHeight, CutRGB, 0, CutWidth));
    //Copy = createImage(new MemoryImageSource(CopyWidth, CopyHeight, CopyRGB, 0, CopyWidth));
    //Paste = createImage(new MemoryImageSource(PasteWidth, PasteHeight, PasteRGB, 0, PasteWidth));
    Search = createImage(new MemoryImageSource(SearchWidth, SearchHeight, SearchRGB, 0, SearchWidth));
    Replace = createImage(new MemoryImageSource(ReplaceWidth, ReplaceHeight, ReplaceRGB, 0, ReplaceWidth));

    DirOpen = createImage(new MemoryImageSource(DirOpenWidth, DirOpenHeight, DirOpenRGB, 0, DirOpenWidth));
    DirHome = createImage(new MemoryImageSource(DirHomeWidth, DirHomeHeight, DirHomeRGB, 0, DirHomeWidth));
    DirParent = createImage(new MemoryImageSource(DirParentWidth, DirParentHeight, DirParentRGB, 0, DirParentWidth));
    DirMake = createImage(new MemoryImageSource(DirMakeWidth, DirMakeHeight, DirMakeRGB, 0, DirMakeWidth));
    DirMkdir = createImage(new MemoryImageSource(DirMkdirWidth, DirMkdirHeight, DirMkdirRGB, 0, DirMkdirWidth));
    DirDel = createImage(new MemoryImageSource(DirDelWidth, DirDelHeight, DirDelRGB, 0, DirDelWidth));
    Cancel = createImage(new MemoryImageSource(CancelWidth, CancelHeight, CancelRGB, 0, CancelWidth));




   }



  public static Image getImage(byte[] desc, byte[] rawImage)
  {
   int width = (int) desc[0] + (int) desc[1] * 256;
   int height = (int) desc[2] + (int) desc[3] * 256;

   MemoryImageSource mis;

   PaletteShaded pal = new PaletteShaded();
   pal.setTransparent(unsigned(desc[8]));
   ColorModel cm = pal.getColorModel();
   mis = new MemoryImageSource(width, height, cm, rawImage, 0,  width, null);

   return Toolkit.getDefaultToolkit().createImage(mis);

  }

 static int unsigned(byte b)
 {
  if(b < 0) return (int) b + 256;
  else return (int) b;
 }



// Java Code


static int NewWidth = 20;
static int NewHeight = 20;
static int[] NewRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-2763520,-1,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-2763520,-16777216,-2763520,
-16777216,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,-2763520,
-2763520,-16777216,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,-2763520,
-2763520,-2763520,-16777216,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-2763520,
-1,-2763520,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-2763520,-1,-2763520,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-2763520,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-2763520,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-2763520,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-2763520,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };

public static Image New;


public static Image Open;
static int OpenWidth = 20;
static int OpenHeight = 20;
static int[] OpenRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,-16777216,-11008,-11008,
-11008,-11008,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-11008,
-11008,-11008,-11008,-11008,-11008,
-11008,-11008,-11008,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-11008,
-11008,-11008,-11008,-11008,-11008,
-11008,-11008,-11008,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-11008,
-11008,-11008,-11008,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,-16777216,-11008,-11008,
-11008,-11008,-16777216,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-16777216,12829635,12829635,
12829635,12829635,-16777216,-11008,-11008,
-11008,-16777216,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-16777216,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-11008,
-16777216,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-16777216,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };


// Java Code

public static Image Save;
static int SaveWidth = 20;
static int SaveHeight = 20;
static int[] SaveRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-9737365,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-9737365,-16777216,-16777216,12829635,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16755328,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16755328,-9737365,
-9737365,-1,-9737365,-1,-9737365,
-1,-9737365,-1,-9737365,-9737365,
-9737365,-16755328,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16755328,-16777216,
-1,-9737365,-9737365,-9737365,-1,
-9737365,-1,-9737365,-1,-16777216,
-9737365,-16755328,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16755328,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-1,-9737365,-1,-9737365,-9737365,
-9737365,-16755328,-16755328,-16777216,12829635,
-16777216,-16755328,-16755328,-16755328,-16777216,
-1,-9737365,-9737365,-9737365,-1,
-9737365,-1,-9737365,-1,-16777216,
-9737365,-16755328,-16755328,-16777216,12829635,
12829635,-16777216,-16755328,-16755328,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-1,-9737365,-1,-9737365,-9737365,
-9737365,-16755328,-16755328,-16777216,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };


// Java Code

// Java Code

public static Image DirOpen;
int DirOpenWidth = 32;
int DirOpenHeight = 16;
int[] DirOpenRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-256,-256,-256,
-256,-256,-256,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-256,
-256,-256,-256,-256,-256,
-256,-256,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-256,-256,-256,
-256,-256,-256,-16777216,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-256,-256,
-256,-256,-256,-256,-16777216,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-256,-256,-256,-256,-256,
-16777216,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-256,-256,-256,
-256,-16777216,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-256,
-256,-256,-16777216,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-256,-16777216,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-256,-16777216,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635, };






// Java Code

public static Image DirMake;
static int DirMakeWidth = 32;
static int DirMakeHeight = 16;
static int[] DirMakeRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,-16777216,12829635,12829635,
12829635,-16777216,-11008,-11008,-11008,
-11008,-11008,-11008,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,-16777216,
-16777216,12829635,12829635,-16777216,-11008,
-11008,-11008,-11008,-11008,-11008,
-11008,-11008,-11008,-11008,-11008,
-11008,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
-16777216,-11008,-11008,-11008,-11008,
-11008,-11008,-11008,-11008,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-11008,-11008,
-11008,-11008,-11008,-11008,-11008,
-16777216,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-16777216,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,-16777216,
-11008,-11008,-11008,-11008,-11008,
-11008,-16777216,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,-16777216,-16777216,12829635,
12829635,-16777216,-11008,-11008,-11008,
-11008,-11008,-16777216,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-16777216,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,-16777216,
12829635,12829635,12829635,-16777216,-11008,
-11008,-11008,-11008,-16777216,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11008,-11008,-11008,-16777216,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-11008,
-16777216,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-11008,-16777216,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635, };




// Java Code

public static Image DirMkdir;
static int DirMkdirWidth = 32;
static int DirMkdirHeight = 16;
static int[] DirMkdirRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-32768,-32768,-32768,-32768,-32768,
-32768,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,12829635,12829635,12829635,
12829635,-16777216,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-16777216,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,-16777216,-22016,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-16777216,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
-16777216,-22016,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-16777216,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,12829635,-16777216,-22016,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-16777216,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,-16777216,
-22016,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-16777216,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,-16777216,-22016,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-16777216,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,12829635,
12829635,12829635,12829635,-16777216,-22016,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-16777216,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-22016,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-16777216,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-22016,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-16777216,-16777216,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635, };


// Java Code

public static Image DirParent;
static int DirParentWidth = 32;
static int DirParentHeight = 16;
static int[] DirParentRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11008,-11008,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-11008,-22016,-22016,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11008,-22016,
-22016,-22016,-11008,-11008,-11008,
-11008,-11008,-11008,-11008,-11008,
-11008,-11008,-11008,-11008,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-11008,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-32768,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-11008,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-32768,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-32768,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-32768,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-32768,-22016,-22016,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-32768,
-22016,-32768,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-32768,-32768,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635, };


// Java Code
/*
public static Image Go;
static int GoWidth = 20;
static int GoHeight = 20;
static int[] GoRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,-16777216,
-2807040,-2807040,-16777216,12829635,12829635,
-16777216,12829635,12829635,-16777216,12829635,
-16777216,12829635,12829635,-16777216,12829635,
-16777216,-2807040,-2807040,-2807040,-2807040,
-8388608,-8388608,-8388608,-16777216,12829635,
-16777216,12829635,12829635,12829635,12829635,
-16777216,12829635,12829635,-16777216,12829635,
-16777216,-2807040,-8388608,-8388608,-8388608,
-8388608,-8388608,-8388608,-8388608,-16777216,
-16777216,12829635,-16777216,-16777216,12829635,
-16777216,12829635,12829635,-16777216,12829635,
-16777216,-2807040,-8388608,-8388608,-8388608,
-8388608,-8388608,-8388608,-8388608,-16777216,
-16777216,12829635,12829635,-16777216,12829635,
-16777216,12829635,12829635,-16777216,12829635,
-16777216,-2807040,-8388608,-8388608,-8388608,
-8388608,-8388608,-8388608,-16777216,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,-16777216,
-8388608,-8388608,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };
*/

// Java Code

public static Image Swap;
static int SwapWidth = 20;
static int SwapHeight = 20;
static int[] SwapRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-11152128,
-11152128,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-11152128,
-11152128,-16777216,12829635,12829635,12829635,
12829635,12829635,-16777216,-11152128,-16744448,
-16744448,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-11152128,
-16744448,-16744448,-16777216,12829635,12829635,
12829635,-16777216,-11152128,-16744448,-16744448,
-16744448,-11152128,-11152128,-11152128,-11152128,
-11152128,-11152128,-11152128,-11152128,-11152128,
-16744448,-16744448,-16744448,-16777216,12829635,
-16777216,-11152128,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16777216,
-16777216,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16755456,-16777216,
12829635,-16777216,-16744448,-16744448,-16744448,
-16755456,-16755456,-16755456,-16755456,-16755456,
-16755456,-16755456,-16755456,-16755456,-16744448,
-16744448,-16744448,-16755456,-16777216,12829635,
12829635,12829635,-16777216,-16744448,-16744448,
-16755456,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16744448,
-16744448,-16755456,-16777216,12829635,12829635,
12829635,12829635,12829635,-16777216,-16755456,
-16755456,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16755456,
-16755456,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };


// Java Code

public static Image Locate;
public static int LocateWidth = 20;
public static int LocateHeight = 20;
public static int[] LocateRGB = new int[]
{
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,12829635,12829635,12829635,
-1,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
-16777216,12829635,12829635,12829635,-1,
-1,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-1,
-1,-16777216,-16777216,12829635,12829635,
-16777216,12829635,12829635,-1,-1,
-1,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-1,
-1,-16777216,12829635,-16777216,12829635,
-16777216,12829635,12829635,-1,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-1,
-1,-16777216,12829635,12829635,-16777216,
-16777216,12829635,12829635,-1,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-1,
-1,-16777216,-16777216,-16777216,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-1,
-1,-1,-1,-1,-16777216,
12829635,-16777216,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-1,-1,
-1,-1,-1,-1,-16777216,
12829635,-16777216,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-16777216,-16777216,-43776,-16777216,-1,
-1,-1,-1,-1,-16777216,
12829635,12829635,-16777216,-16777216,12829635,
12829635,-16777216,-1,-16777216,-16777216,
-1,-1,-1,-43776,-16777216,
-1,-1,-1,-1,-16777216,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,12829635,-16777216,
-11195648,-1,-1,-1,-43776,
-16777216,-1,-1,-1,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-1,-1,-1,
-16777216,-11195648,-1,-1,-1,
-43776,-16777216,-1,-1,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-16777216,-11195648,-1,-1,
-1,-43776,-16777216,-1,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-11195648,-1,
-1,-1,-43776,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-11195648,
-1,-1,-1,-43776,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-16777216,
-11195648,-1,-11195648,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-16777216,-11195648,-16777216,-1,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,-16777216,12829635,-16777216,-16777216,
 };


// Java Code

public static Image Dcomp;
public static int DcompWidth = 20;
public static int DcompHeight = 20;
public static int[] DcompRGB = new int[]
{
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-22016,-22016,-22016,-22016,
-22016,-22016,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,-16777216,12829635,
-16777216,-16777216,-16777216,-16777216,12829635,
-16777216,-256,-22016,-22016,-22016,
-22016,-22016,-22016,-22016,-22016,
-22016,-22016,-22016,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,-16777216,
-16777216,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
 };


/*

public static Image Rename;
public static int RenameWidth = 20;
public static int RenameHeight = 20;
public static int[] RenameRGB = new int[]
{
-16766123,-16766123,12829635,12829635,12829635,
12829635,-16766123,-16766123,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16766123,-16766123,-16766123,12829635,12829635,
-16766123,-16766123,-16766123,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16766123,-16766123,-16766123,-16766123,
-16766123,-16766123,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16766123,-16766123,-16766123,
-16766123,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16766123,-16766123,-16766123,-16766123,
-16766123,-16766123,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16766123,-16766123,-16766123,12829635,12829635,
-16766123,-16766123,-16766123,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16766123,-16766123,12829635,12829635,12829635,
12829635,-16766123,-16766123,12829635,12829635,
12829635,12829635,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-65536,-8388608,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-65536,-65536,-65536,-65536,-65536,
-65536,-65536,-65536,-8388608,-8388608,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-8388608,-8388608,-8388608,-8388608,-8388608,
-8388608,-8388608,-8388608,-8388608,-8388608,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-8388608,-8388608,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16766123,-16777216,12829635,12829635,
12829635,12829635,-16766123,-16766123,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16766123,-16766123,-16766123,12829635,
12829635,-16766123,-16766123,-16766123,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16766123,-16766123,-16766123,
-16766123,-16766123,-16766123,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16766123,-16766123,
-16766123,-16766123,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16766123,
-16766123,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16766123,
-16766123,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16766123,
-16766123,12829635,12829635,12829635,12829635,
 };
*/


public static byte[] Unarcdesc = {
20,0,20,0,0,0,0,0,7,0 };

public static byte[] Unarc = {
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,12,12,12,12,12,12,12,7,12,
12,7,12,12,12,12,12,12,7,7,
7,12,91,91,91,91,91,4,7,12,
4,7,12,91,91,91,91,91,4,7,
7,7,7,7,7,91,91,4,7,12,
4,7,12,91,7,7,7,91,4,7,
7,7,12,91,91,91,4,7,7,12,
4,7,12,91,91,91,91,4,4,7,
7,12,91,91,7,7,7,7,7,12,
4,7,12,4,4,4,4,4,7,7,
7,12,91,91,91,91,91,4,7,12,
4,7,12,4,7,7,7,7,7,7,
7,12,4,4,4,4,4,4,7,12,
4,7,12,4,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,0,0,0,0,0,0,7,7,
7,7,7,7,7,7,7,7,7,7,
7,0,14,14,14,14,14,14,0,0,
0,0,0,0,0,7,7,7,7,7,
7,0,14,14,14,14,14,14,14,14,
14,14,14,14,14,0,7,7,7,7,
7,0,14,14,14,14,14,14,0,0,
0,0,0,0,0,0,0,0,0,7,
7,0,14,14,14,14,14,0,-22,-22,
-22,-22,-22,-22,-22,-22,-22,-22,-22,0,
7,0,14,14,14,14,0,-22,-22,-22,
-22,-22,-22,-22,-22,-22,-22,-22,-22,0,
7,0,14,14,14,0,-22,-22,-22,-22,
-22,-22,-22,-22,-22,-22,-22,-22,0,7,
7,0,14,14,0,-22,-22,-22,-22,-22,
-22,-22,-22,-22,-22,-22,-22,0,7,7,
7,0,14,0,-22,-22,-22,-22,-22,-22,
-22,-22,-22,-22,-22,-22,0,7,7,7,
7,0,14,-22,-22,-22,-22,-22,-22,-22,
-22,-22,-22,-22,-22,0,7,7,7,7,
7,7,0,0,0,0,0,0,0,0,
0,0,0,0,0,7,7,7,7,7
 };




// Java Code
/*
public static Image Cut;
static int CutWidth = 20;
static int CutHeight = 20;
static int[] CutRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-1,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-1,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-1,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-1,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-16777216,12829635,12829635,
12829635,12829635,-16777216,-1,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,12829635,12829635,
12829635,12829635,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-16777216,12829635,
12829635,-16777216,-1,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-1,-16777216,
-16777216,-1,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-16777088,
-16777088,-16777088,-16777088,-16777088,-16777088,
-16777088,-16777088,-16777088,-16777088,-16777088,
-16777088,-16777088,12829635,12829635,12829635,
12829635,12829635,-16777088,12829635,12829635,
-16777088,-16777088,-16777088,-16777088,12829635,
12829635,-16777088,-16777088,-16777088,12829635,
12829635,-16777088,-16777088,12829635,12829635,
12829635,-16777088,12829635,12829635,12829635,
12829635,12829635,-16777088,12829635,12829635,
12829635,12829635,-16777088,12829635,12829635,
12829635,12829635,12829635,-16777088,12829635,
12829635,-16777088,12829635,12829635,12829635,
12829635,12829635,-16777088,12829635,12829635,
12829635,12829635,-16777088,12829635,12829635,
12829635,12829635,12829635,-16777088,12829635,
12829635,-16777088,12829635,12829635,12829635,
12829635,-16777088,-16777088,12829635,12829635,
12829635,12829635,-16777088,-16777088,12829635,
12829635,12829635,12829635,-16777088,12829635,
12829635,-16777088,-16777088,12829635,12829635,
-16777088,-16777088,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-16777088,
12829635,12829635,-16777088,-16777088,12829635,
12829635,12829635,-16777088,-16777088,-16777088,
-16777088,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777088,
-16777088,-16777088,-16777088,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };

// Java Code

public static Image Copy;
static int CopyWidth = 20;
static int CopyHeight = 20;
static int[] CopyRGB = new int[] {
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-16777216,-2774528,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-16777216,-2774528,-2774528,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-16777216,-2774528,-2774528,
-2774528,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-1,-9737365,
-1,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-9737365,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-16777088,-16777088,
-16777088,-16777088,-16777088,-16777088,-16777088,
-16777088,-16777216,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-16777088,-1,
-1,-1,-1,-1,-1,
-16777088,-2774528,-16777216,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-16777088,-1,
-1,-1,-1,-1,-1,
-16777088,-2774528,-2774528,-16777216,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-16777088,-1,
-1,-1,-1,-1,-1,
-16777088,-2774528,-2774528,-2774528,-16777216,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-16777088,-1,
-1,-1,-1,-1,-1,
-16777088,-16777088,-16777088,-16777088,-16777088,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-16755286,-1,-16777088,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16755286,-16777088,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-16777088,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-16777088,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-16777088,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-16777088,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-16777088,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777088,-16777088,
-16777088,-16777088,-16777088,-16777088,-16777088,
-16777088,-16777088,-16777088,-16777088,-16777088,
 };



// Java Code

public static Image Paste;
static int PasteWidth = 20;
static int PasteHeight = 20;
static int[] PasteRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,-2763520,
-16777216,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-1,-1,-16777216,-2763520,
-2763520,-16777216,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-1,-1,-16777216,-2763520,
-2763520,-2763520,-16777216,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-1,-1,-16777216,-2763520,
-2763520,-2763520,-2763520,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-1,-1,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-1,-1,-1,-2763520,
-1,-2763520,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-1,-1,
-2763520,-1,-2763520,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-1,-1,-1,
-1,-2763520,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-16777216,-16777216,-16777216,
-16777216,-1,-1,-1,-1,
-1,-1,-2763520,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-16777216,-16777216,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };
*/

// Java Code

public static Image Search;
static int SearchWidth = 20;
static int SearchHeight = 20;
static int[] SearchRGB = new int[] {
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-11151958,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-11151958,-11151958,-11151958,
-1,-1,-1,-11151958,-11151958,
-11151958,-11151958,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11151958,-11151958,-11151958,-1,
-1,-1,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11151958,-11151958,-1,-1,
-1,-11151958,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11151958,-11151958,-1,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11151958,-11151958,-1,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11151958,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-11151958,-11151958,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-11151958,-11151958,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-11151958,-16777216,-43776,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-16777216,-11151958,
-11151958,-11151958,-11151958,-11151958,-11151958,
-16777216,-2807040,-2807040,-43776,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-11195648,-11195648,
-11195648,-2807040,-2807040,-2807040,-43776,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11195648,-2807040,-2807040,-2807040,
-43776,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-11195648,-2807040,-2807040,
-2807040,-43776,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-11195648,-2807040,
-2807040,-2807040,-43776,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-11195648,
-2807040,-2807040,-2807040,-43776,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-11195648,-2807040,-11195648,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-11195648,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-9737365,12829635,12829635,12829635,
 };


// Java Code

public static Image Replace;
static int ReplaceWidth = 20;
static int ReplaceHeight = 20;
static int[] ReplaceRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-1,-1,
-1,-1,-1,-1,-6974059,
-6974059,-6974059,-6974059,-6974059,-6974059,
-6974059,-6974059,12829635,12829635,12829635,
12829635,12829635,-1,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-9737365,-9737365,-16777216,12829635,12829635,
12829635,-1,-6974059,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-9737365,-16777216,12829635,12829635,12829635,
-1,-6974059,-6974059,-6974059,-6974059,
-6974059,-6974059,-6974059,-6974059,-9737365,
-9737365,-9737365,-9737365,-9737365,-9737365,
-16777216,12829635,12829635,12829635,12829635,
12829635,-9737365,-9737365,-9737365,-9737365,
-9737365,-9737365,-9737365,-9737365,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-2752768,-2752768,
-16733696,-16733696,-16733696,-16733696,-16733696,
-16733696,-16733696,-16733696,-16733696,-16733696,
-16733696,-16733696,-16733696,-16733696,12829635,
12829635,-2752768,-2752768,-2763520,-2763520,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,12829635,
-16777216,-2763520,-2763520,-2763520,-2763520,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,12829635,
12829635,-5603328,-5603328,-2763520,-2763520,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,-16744448,
-16744448,-16744448,-16744448,-16744448,12829635,
12829635,12829635,12829635,-5603328,-5603328,
-16755456,-16755456,-16755456,-16755456,-16755456,
-16755456,-16755456,-16755456,-16755456,-16755456,
-16755456,-16755456,-16755456,-16755456,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
 };


// Java Code

public static Image FileCopy;
static int FileCopyWidth = 20;
static int FileCopyHeight = 20;
static int[] FileCopyRGB = new int[] {
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-86,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-86,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-86,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-86,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-86,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16755328,
-16755328,-16755328,-16755328,-16755328,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-86,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-86,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-86,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-86,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-86,-86,-86,
-86,-86,-86,-86,-86,
-86,-86,-86,-86,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
 };



// Java Code
/*
public static Image DirHome;
static int DirHomeWidth = 32;
static int DirHomeHeight = 16;
static int[] DirHomeRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-11008,
-22016,-22016,-43776,-43776,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-11008,-22016,-22016,-22016,-22016,
-43776,-43776,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-11008,-22016,-22016,-256,
-2796288,-22016,-22016,-43776,-43776,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-11008,-22016,-22016,
-256,-256,-256,-2796288,-22016,
-22016,-43776,-43776,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-11008,-22016,
-22016,-256,-256,-256,-256,
-256,-2796288,-22016,-22016,-43776,
-43776,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-11008,
-22016,-22016,-256,-256,-256,
-256,-256,-256,-256,-2796288,
-22016,-22016,-43776,-43776,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-11008,-22016,-22016,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-2796288,-22016,-22016,
-43776,-43776,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-11008,-22016,-22016,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-2796288,-22016,-22016,-43776,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-11008,-22016,-22016,
-1,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-2796288,-22016,
-22016,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-1,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-2796288,-2796288,-2796288,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-1,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-2796288,-2796288,-2796288,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-1,-256,-256,-22016,
-22016,-22016,-2796288,-256,-256,
-22016,-22016,-22016,-256,-2796288,
-2796288,-2796288,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-1,-256,
-256,-22016,-22016,-22016,-2796288,
-256,-256,-22016,-22016,-22016,
-256,-2796288,-2796288,-2796288,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-1,-256,-256,-22016,-22016,
-22016,-2796288,-256,-256,-22016,
-22016,-22016,-256,-2796288,-2796288,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-1,-256,-256,
-22016,-22016,-22016,-2796288,-256,
-256,-256,-256,-256,-256,
-2796288,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635, };
*/
// Java Code

public static Image DirDel;
static int DirDelWidth = 24;
static int DirDelHeight = 16;
static int[] DirDelRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-1,
-1,-1,-1,-1,-1,
-1,-1,-16777216,-22016,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,-22016,-22016,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-1,-1,-1,
-1,-1,-1,-1,-1,
-16777216,-22016,-22016,-22016,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-1,-16777216,
-16777216,-16777216,-16777216,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
12829635,12829635,12829635,12829635,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,12829635,
12829635,12829635,12829635,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,-54528,-54528,
-54528,-54528,-54528,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-1,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-1,-1,
-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635, };

// Java Code

public static Image Cancel;
static int CancelWidth = 24;
static int CancelHeight = 16;
static int[] CancelRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16733696,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16733696,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16744448,-16744448,
-16744448,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16733696,
-16744448,-16744448,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16744448,-16744448,-16744448,
-16744448,12829635,12829635,12829635,12829635,
12829635,12829635,-16733696,-16744448,-16744448,
-16755456,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16744448,-16744448,-16744448,
-16744448,12829635,12829635,12829635,12829635,
-16733696,-16744448,-16744448,-16755456,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16744448,-16744448,-16744448,
-16744448,12829635,12829635,-16733696,-16744448,
-16744448,-16755456,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16744448,-16744448,-16744448,
-16733696,-16733696,-16744448,-16744448,-16755456,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16744448,-16744448,-16744448,
-16744448,-16744448,-16755456,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16733696,-16744448,-16744448,-16744448,
-16744448,-16744448,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16733696,
-16744448,-16744448,-16755456,-16755456,-16744448,
-16744448,-16744448,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16733696,-16744448,-16744448,
-16755456,12829635,12829635,-16755456,-16744448,
-16744448,-16744448,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16733696,-16744448,-16744448,-16755456,12829635,
12829635,12829635,12829635,-16755456,-16744448,
-16744448,-16744448,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16733696,-16744448,
-16744448,-16755456,12829635,12829635,12829635,
12829635,12829635,12829635,-16755456,-16744448,
-16744448,-16744448,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16744448,-16744448,-16755456,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16755456,-16744448,
-16744448,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16755456,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16755456,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635, };

// Java Code

public static Image DirHome;
static int DirHomeWidth = 32;
static int DirHomeHeight = 16;
static int[] DirHomeRGB = new int[] {
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-22016,-22016,-22016,-22016,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-22016,-22016,-256,
-2796288,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-22016,-22016,
-256,-256,-256,-2796288,-22016,
-22016,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-22016,
-22016,-256,-256,-256,-256,
-256,-2796288,-22016,-22016,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-22016,-22016,-256,-256,-256,
-256,-256,-256,-256,-2796288,
-22016,-22016,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-22016,-22016,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-2796288,-22016,-22016,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-22016,-22016,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-2796288,-22016,-22016,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-16777216,
-16777216,-256,-256,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-2796288,-2796288,-16777216,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-256,-256,
-256,-256,-256,-256,-256,
-256,-256,-256,-256,-2796288,
-2796288,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-256,-256,-256,-16777216,-16777216,
-16777216,-16777216,-16777216,-256,-256,
-256,-2796288,-2796288,-16777216,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,-16777216,-256,-256,-256,
-16777216,-22016,-22016,-22016,-16777216,
-256,-256,-256,-2796288,-2796288,
-16777216,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,-16777216,-256,
-256,-256,-16777216,-22016,-22016,
-22016,-16777216,-256,-256,-256,
-2796288,-2796288,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
-16777216,-256,-256,-256,-16777216,
-22016,-22016,-22016,-16777216,-256,
-256,-256,-2796288,-2796288,-16777216,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,-16777216,-256,-256,
-256,-16777216,-22016,-22016,-22016,
-16777216,-256,-256,-256,-2796288,
-2796288,-16777216,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635,12829635,12829635,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16777216,12829635,12829635,
12829635,12829635,12829635,12829635,12829635,
12829635,12829635, };



// Java Code

public static Image Microsoft;
static int MicrosoftWidth = 20;
static int MicrosoftHeight = 20;
static int[] MicrosoftRGB = new int[] {
16316664,16316664,16316664,16316664,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
16316664,16316664,16316664,16316664,16316664,
16316664,16316664,16316664,16316664,16316664,
16316664,16316664,-16777216,-16777216,-16777216,
-16777216,-524288,-524288,-16777216,-16777216,
-16777216,-16777216,-16777216,16316664,16316664,
16316664,16316664,16316664,16316664,16316664,
16316664,-16777216,-16777216,-524288,-524288,
-524288,-524288,-524288,-524288,-16777216,
-16777216,-16713728,-16777216,-16777216,16316664,
16316664,16316664,16316664,16316664,16316664,
-16777216,-16777216,-524288,-524288,-524288,
-524288,-524288,-524288,-524288,-16777216,
-16777216,-16713728,-16713728,-16777216,-16777216,
-16777216,16316664,16316664,-16777216,-16777216,
-16777216,-16777216,-524288,-524288,-524288,
-524288,-524288,-524288,-524288,-16777216,
-16777216,-16713728,-16713728,-16713728,-16713728,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-524288,-524288,-524288,
-524288,-524288,-524288,-524288,-16777216,
-16777216,-16713728,-16713728,-16713728,-16713728,
-16713728,-16713728,-16713728,-16777216,-16777216,
-16777216,-16777216,-524288,-524288,-524288,
-524288,-524288,-524288,-524288,-16777216,
-16777216,-16713728,-16713728,-16713728,-16713728,
-16713728,-16713728,-16713728,-16777216,-16777216,
-16777216,-16777216,-524288,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16713728,-16713728,-16713728,-16713728,
-16713728,-16713728,-16713728,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16776968,-16776968,-16777216,-16777216,-16777216,
-16777216,-16777216,-16713728,-16713728,-16713728,
-16713728,-16713728,-16713728,-16777216,-16777216,
-16777216,-16777216,-16776968,-16776968,-16776968,
-16776968,-16776968,-16776968,-16776968,-16777216,
-16777216,-16777216,-16777216,-16713728,-16713728,
-16713728,-16713728,-16713728,-16777216,-16777216,
-16777216,-16777216,-16776968,-16776968,-16776968,
-16776968,-16776968,-16776968,-16776968,-16777216,
-16777216,-460800,-16777216,-16777216,-16777216,
-16713728,-16713728,-16777216,-16777216,-16777216,
-16777216,-16777216,-16776968,-16776968,-16776968,
-16776968,-16776968,-16776968,-16776968,-16777216,
-16777216,-460800,-460800,-460800,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-16777216,-16776968,-16776968,-16776968,
-16776968,-16776968,-16776968,-16776968,-16777216,
-16777216,-460800,-460800,-460800,-460800,
-460800,-460800,-460800,-16777216,-16777216,
-16777216,-16777216,-16776968,-16776968,-16776968,
-16776968,-16776968,-16776968,-16776968,-16777216,
-16777216,-460800,-460800,-460800,-460800,
-460800,-460800,-460800,-16777216,-16777216,
-16777216,-16777216,-16776968,-16776968,-16776968,
-16776968,-16776968,-16776968,-16776968,-16777216,
-16777216,-460800,-460800,-460800,-460800,
-460800,-460800,-460800,-16777216,-16777216,
-16777216,-16777216,-16776968,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
-16777216,-460800,-460800,-460800,-460800,
-460800,-460800,-460800,-16777216,-16777216,
-16777216,-16777216,-16777216,-16777216,-16777216,
16316664,16316664,-16777216,-16777216,-16777216,
-16777216,-16777216,-460800,-460800,-460800,
-460800,-460800,-460800,-16777216,-16777216,
-16777216,-16777216,16316664,16316664,16316664,
16316664,16316664,16316664,16316664,16316664,
16316664,-16777216,-16777216,-460800,-460800,
-460800,-460800,-460800,-16777216,-16777216,
-16777216,16316664,16316664,16316664,16316664,
16316664,16316664,16316664,16316664,16316664,
16316664,16316664,-16777216,-16777216,-16777216,
-460800,-460800,-16777216,-16777216,-16777216,
16316664,16316664,16316664,16316664,16316664,
16316664,16316664,16316664,16316664,16316664,
16316664,16316664,16316664,16316664,-16777216,
-16777216,-16777216,-16777216,16316664,16316664,
 };


public static byte[] LRDesc = {
16,0,20,0,0,0,0,0,7,0 };

public static byte[] CopyLeft = {
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,32,
-48,-48,7,7,7,7,7,7,7,7,
7,7,7,7,7,32,60,60,-48,7,
7,7,-48,-48,-48,-48,-48,-48,-48,-48,
-48,-48,60,2,2,-48,7,7,-48,60,
60,60,60,60,60,60,60,60,60,2,
2,2,-48,7,-48,60,2,2,2,2,
2,2,2,2,2,2,2,2,2,-48,
-48,60,2,2,2,2,2,2,2,2,
2,2,2,2,2,-48,32,60,-86,-86,
-86,-86,-86,-86,-86,-86,2,2,2,2,
-48,7,-48,-48,-48,-48,-48,-48,-48,-48,
-48,-48,2,2,2,-48,7,7,7,7,
7,7,7,7,7,7,7,32,2,2,
-48,7,7,7,7,7,7,7,7,7,
7,7,7,32,-48,-48,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7
 };




/*
public static byte[] Run = {
20,0,20,0,0,0,0,0,7,0,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,9,9,9,9,9,9,9,9,9,
9,9,9,9,9,9,9,9,9,32,
32,9,9,9,9,9,9,9,9,9,
9,9,9,9,9,9,9,9,9,32,
32,9,9,9,9,9,9,9,9,9,
9,9,9,9,9,9,9,9,9,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,15,15,15,15,14,15,15,15,15,
14,15,15,15,15,14,15,15,15,32,
32,15,15,15,15,15,15,15,15,32,
32,32,15,15,14,15,15,15,15,32,
32,15,15,15,15,15,14,32,32,15,
15,15,32,32,15,15,15,15,15,32,
32,15,15,15,15,15,32,15,15,15,
14,15,15,15,32,15,15,15,15,32,
32,15,14,15,14,32,15,15,15,14,
14,14,15,15,15,32,15,14,15,32,
32,15,15,15,15,32,15,14,15,14,
-20,14,15,15,15,32,15,15,15,32,
32,15,15,15,15,15,32,15,15,14,
-20,14,15,15,32,15,15,15,15,32,
32,15,15,15,14,15,15,32,15,15,
-20,15,15,32,14,15,15,15,15,32,
32,15,15,15,15,15,15,15,32,15,
14,15,32,15,15,14,15,15,15,32,
32,15,15,15,15,15,15,15,32,-22,
-22,-22,32,15,15,15,15,15,15,32,
32,15,15,15,15,15,15,15,32,-22,
-22,-22,32,15,15,15,15,15,15,32,
32,15,15,15,15,15,15,15,32,32,
-22,32,32,15,15,15,15,15,15,32,
32,15,15,15,15,15,15,15,15,32,
32,32,15,15,15,15,15,15,15,32,
32,15,15,15,15,15,15,15,15,15,
15,15,15,15,15,15,15,15,15,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32
 };


public static byte[] Edit = {
20,0,20,0,0,0,0,0,7,0,
7,32,32,32,32,32,32,32,32,32,
32,32,32,7,7,7,7,7,7,7,
7,32,15,15,15,15,15,15,15,15,
15,15,32,32,7,7,7,7,7,7,
7,32,15,15,15,15,15,15,15,15,
15,15,32,-21,32,7,7,7,7,7,
7,32,15,15,15,15,15,15,15,15,
15,15,32,-21,-21,32,7,7,7,7,
7,32,15,15,0,0,15,0,0,15,
15,15,32,32,32,32,32,7,7,7,
7,32,15,15,15,15,15,15,15,15,
15,15,-21,15,-21,15,32,7,7,7,
7,32,15,15,0,0,0,0,15,15,
0,0,15,-21,15,-21,32,7,7,7,
7,32,15,15,15,15,15,15,15,15,
15,15,15,15,-21,15,32,7,7,7,
7,32,15,15,15,15,0,0,0,0,
15,15,15,15,15,-21,32,7,7,7,
7,32,15,15,15,15,15,15,15,15,
15,15,15,15,15,15,32,7,7,7,
0,0,0,0,15,15,15,15,15,15,
15,0,0,0,0,15,32,7,7,7,
0,76,76,0,15,15,15,15,15,15,
15,0,76,76,0,15,32,7,7,7,
0,76,76,0,15,15,15,15,15,15,
15,0,76,76,0,15,32,7,7,7,
7,32,76,76,0,15,15,15,15,15,
0,76,76,0,15,15,32,7,7,7,
7,32,76,76,0,15,15,0,15,15,
0,76,76,0,15,15,32,7,7,7,
7,32,0,76,76,0,0,76,0,0,
76,76,0,15,15,15,32,7,7,7,
7,7,0,76,76,76,76,76,76,76,
76,76,0,15,0,32,32,7,7,7,
7,7,7,0,76,76,76,0,76,76,
76,0,7,7,7,7,7,7,7,7,
7,7,7,0,76,76,0,7,0,76,
76,0,7,7,7,7,7,7,7,7,
7,7,7,7,0,0,7,7,7,0,
0,7,7,7,7,7,7,7,7,7
 };
*/


}
