/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class Input extends DDialog implements ActionListener
{
	Label labelInput;
	TextField fieldInput;
	Button buttonCancel;
	Button buttonOK;

    public Input(Frame parent)
    {
        this(parent, "", "");
     }

  public Input(Frame parent, String title, String text)
  {
	super(parent, true);

	setSize(432,108);
	setVisible(false);

        choice = false;
        int fieldSize = 30;
        if(OS.isWindows()) fieldSize = 24;

	labelInput = new java.awt.Label(text);
	labelInput.setBounds(16, 12, 400, 16);
	panel.add(labelInput);

	fieldInput = new java.awt.TextField("");
	fieldInput.setBounds(16, 32, 400, fieldSize);
	fieldInput.setBackground(getBackground().brighter());
        fieldInput.addKeyListener(this);
        panel.add(fieldInput);

	buttonCancel = new java.awt.Button("Cancel");
	buttonCancel.setBounds(140, 68, 96, 26);
	buttonCancel.setBackground(getBackground());
	buttonCancel.addActionListener(this);
	panel.add(buttonCancel);

	buttonOK = new java.awt.Button("Enter");
	buttonOK.setBounds(320, 68, 96, 26);
	buttonOK.setBackground(getBackground());
	buttonOK.addActionListener(this);
	panel.add(buttonOK);

        setTitle(title);
        keyEnabled = true;
    }


    public void actionPerformed(java.awt.event.ActionEvent event)
    {
	  Object object = event.getSource();

	  if (object == buttonOK)  choice = true;
	  else if (object == buttonCancel) choice = false;
	  else return;

          setVisible(false);
	  dispose();
	  return;
    }


public void setInput(String s)	   { fieldInput.setText(s);}
public String getInput()           { return fieldInput.getText();	}
public void setLabel(String s)     { labelInput.setText(s);}

public boolean ok() { return choice; }


}
