/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.Frame;
import common.*;

/**
   Gre les fichiers des bookmarks
   et menys dynamiques
 */


public class Memory
{
   static String AEListFile = "AE.Memory";

   DComboBox comboSrc;
   DComboBox comboDst;
   FileList progDyn;
   FileList textDyn;
   FileList lastDyn;
   CardPanel cardPanel;
   DComboBox comboExt;
   DComboBox comboAss;


   public String SetupPanel = "0";
   public String srcPath;
   public String dstPath;

   /** Constructeur */
   public Memory() { };

   public Memory(String dir) { AEListFile = dir; };


   /** Affecte les object concerns en sauvegarde de la mmoire:
       - combos
       - listes dynamiques
       - TabPanel
   */

   public void setComponents(
      DComboBox src, DComboBox dst,
      FileList prog, FileList text, FileList last,
      CardPanel tab1, DComboBox ext, DComboBox ass)
   {
     comboSrc = src;
     comboDst = dst;
     progDyn  = prog;
     textDyn  = text;
     lastDyn  = last;
     cardPanel = tab1;
     comboExt = ext;
     comboAss = ass;
   }

   /** Nombre d'units disque dans la liste de chemins */
   public static int getBaseSize(VectorString vs)
   {
     if(!OS.isWindows()) return Preferences.MemBaseSize;

     int l = vs.size();
     int bsize = 0;

     for(int i = 0; i < l; i++)
      if(Path.isDrive(vs.elementAt(i))) bsize++;

     return bsize;
   }


  public int save(String AEDir)
  {
    String[] AEMemorySrc = comboSrc.getListItems();
    String[] AEMemoryDst = comboDst.getListItems();

    int ls = AEMemorySrc.length;
    int ld = AEMemoryDst.length;
    int i;
    int j;
    int size = Preferences.MemorySize;

    if(ls > size) ls = size;
    if(ld > size) ld = size;

    VectorString vmem = new VectorString();

    vmem.addElement("SEB=" + srcPath);
    vmem.addElement("DEB=" + dstPath);

    for(i = 0; i < ls; i++)
     vmem.addElement("SRC=" + AEMemorySrc[i]);

    for(j = 0; j < ld; j++)
     vmem.addElement("DST=" + AEMemoryDst[j]);

    int index = progDyn.index;
    for(i = 0; i < index; i++)
     vmem.addElement("PRG=" + progDyn.get(i));

    index = textDyn.index;
    for(i = 0; i < index; i++)
     vmem.addElement("TXT=" + textDyn.get(i));

    index = lastDyn.index;
    for(i = 0; i < index; i++)
     vmem.addElement("REC=" + lastDyn.get(i));

    vmem.addElement("SPN=" + new Integer(cardPanel.getTab()).toString());

    // Ass
    String ExtArray[] = comboExt.getListItems();
    String AssArray[] = comboAss.getListItems();

    index = comboExt.countItems();
    for(i = 0; i < index; i++)
      vmem.addElement("ASS=" + ExtArray[i] + " " + AssArray[i]);


    int result = Disk.saveLines(AEDir, AEListFile, vmem);
    return result;
  }


  // Load mmoire

  public boolean load(String AEDir)
  {
    VectorString src   = new VectorString();
    VectorString dst   = new VectorString();
    VectorString vlist = new VectorString();
    int i;
    int loaded;

    //int maxsize = Preferences.MemorySize; // Nombre restant

    // Charger la liste complte sur fichier
    loaded = Disk.loadUnicLines(AEDir, AEListFile, vlist);

    int size = vlist.size();  // Taille de cette liste
    for(i = 0; i < size; i++)
    {
     String test = vlist.elementAt(i);

     int j = test.indexOf("=");
     if(j > 0)
     {
      String lft = test.substring(0, j);
      String rgt = test.substring(j + 1, test.length());

      if(lft != null && rgt != null)
      {
      if(rgt.length() < 1) System.out.println(lft + " Error: Empty field");
      else if(lft.equals("SRC")) src.addElement(rgt);
      else if(lft.equals("DST")) dst.addElement(rgt);
      else if(lft.equals("SEB")) srcPath = rgt;
      else if(lft.equals("DEB")) dstPath = rgt;
      else if(lft.equals("PRG")) progDyn.add(rgt);
      else if(lft.equals("TXT")) textDyn.add(rgt);
      else if(lft.equals("REC")) lastDyn.add(rgt);
      else if(lft.equals("SPN")) SetupPanel = rgt;
      else if(lft.equals("ASS"))
       {
         int x = rgt.indexOf(" ");
         int l = rgt.length();
         if(x > 0)
          if(x < l)
         {
           comboExt.addItem(rgt.substring(0, x));
           comboAss.addItem(rgt.substring(x + 1, l));
         }
       }
      }
     }
    } // for


    comboSrc.clear();
    comboSrc.setMaxItems(Preferences.MemorySize);

    comboDst.clear();
    comboDst.setMaxItems(Preferences.MemorySize);

    if(size < 1) return false;  // Test si AE.Memory pas charge

    // Mets les units en tte et les ordonne
    int lbs = src.separeDrives();
    comboSrc.setBaseSize(lbs);

    int dbs = dst.separeDrives();
    comboDst.setBaseSize(dbs);

    int l = src.size();
    for(i = 0; i < l; i++)
       comboSrc.addItem(src.elementAt(i));

    l = dst.size();
    for(i = 0; i < l; i++)
       comboDst.addItem(dst.elementAt(i));

   return true;

 } // load


 /** Setup tardif, correctif */
 public void addDrives(VectorString diskslist)
 {
    for(int i = 0; i < diskslist.size(); i++)
    {
     String drive = diskslist.elementAt(i);
     comboSrc.addUnicItem(drive);
     comboDst.addUnicItem(drive);
    }

    int newsize = getBaseSize(diskslist);
    if(newsize > Preferences.MemorySize)
     Preferences.MemorySize = newsize;
    comboSrc.setBaseSize(newsize);
    comboSrc.separeDrives();
    comboDst.setBaseSize(newsize);
    comboDst.separeDrives();
  }



};
