/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class PageSetup extends Panel implements ActionListener, ItemListener
{

  TextField colorField;
  Choice choiceColor;

  Frame parent;


  public PageSetup(Frame parent)
  {
    super();
    setLayout(null);
    setVisible(false);

    this.parent = parent;

    int textSize = 30;
    if(OS.isWindows()) textSize = 24;

    Label pc = new Label("Page color", Label.RIGHT);
    pc.setBounds(16, 96, 80, 20);
    add(pc);

    colorField = new TextField(Preferences.pageColor);
    colorField.setBounds(100, 96, 96, textSize);
    colorField.addActionListener(this);
    add(colorField);

    choiceColor = new Choice();
    choiceColor.setBackground(parent.getBackground());
    choiceColor.setBounds(200, 96,100, textSize);
    choiceColor.addItemListener(this);
    add(choiceColor);

    ColorList.fillChoice(choiceColor);
    choiceColor.select(0);
  }


  public void actionPerformed(java.awt.event.ActionEvent event)
  {
      Object object = event.getSource();

      if(object == colorField)
       Preferences.pageColor = colorField.getText();
   }


    /**
     * Fire an action event to the listeners.
     */

   ActionListener actionListener = null;

   protected void sourceActionEvent(int action)
   {
     if (actionListener == null) return;

     String actionCommand = new Integer(action).toString();
     actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, actionCommand));
   }

    /** Adds a to receive action events  */
   public void addActionListener(ActionListener l)
   {
	actionListener = AWTEventMulticaster.add(actionListener, l);
   }

    public void itemStateChanged(java.awt.event.ItemEvent event)
    {
       Object object = event.getSource();

       //String strevent = (String) event.getItem();

       if (object == choiceColor)
       {
  	 String strevent = (String) event.getItem();
         colorField.setText(strevent);
         Preferences.pageColor = strevent;
       }
    }

}
