/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.io.*;
import common.*;

public class SetupFind extends DDialog
{
    List textLocate;
    LocateEngine fre = null;
    SymAction lSymAction = new SymAction();
    boolean achieved = false; // recherche lance, termine

    public String progType = "file";             // Navigator, editor
    public String dirfound = null;
    public String filefound = null;

    public final static int CANCEL = 0;
    public final static int GO = 1;
    public final static int OPEN = 2;
    public int result;

    Color background;
    String CurDrive = "c:";

    DBPanel panelControl;
    java.awt.TextField inputFilename;
    java.awt.Button buttonStart;
    java.awt.Button buttonCancel;
    java.awt.Button buttonAccept;
    Label labelResult;
    Label labelInfo;
    java.awt.Panel panelText;

    SWThread searchThread = null;


public SetupFind(Frame parent)
  {
	super(parent);

        result = CANCEL;

        background = parent.getBackground();
        setBackground(background);

	setLayout(new BorderLayout(0,0));
	setVisible(false);
	setBounds(getInsets().left + 160,
                 getInsets().top + 160,
                 getInsets().left + getInsets().right + 556,
                 getInsets().top + getInsets().bottom + 360);

	panelControl = new DBPanel(DBPanel.BEVEL_RAISED);
	panelControl.setLayout(null);
	panelControl.setBounds(getInsets().left + 0,getInsets().top + 0,556,120);
        panelControl.setBackground(getBackground());
	panelControl.setFont(new Font("Dialog", Font.PLAIN, 14));
	add("North", panelControl);

	buttonStart = new java.awt.Button("Start");
	buttonStart.setBounds(16, 8,94, 32);
        buttonStart.setBackground(background);
	panelControl.add(buttonStart);

	buttonAccept = new java.awt.Button("Accept");
	buttonAccept.setBounds(128, 8,94, 32);
        buttonAccept.setBackground(background);
	panelControl.add(buttonAccept);

	buttonCancel = new java.awt.Button("Cancel");
	buttonCancel.setBounds(446, 8,94, 32);
        buttonCancel.setBackground(background);
	panelControl.add(buttonCancel);

	labelInfo = new java.awt.Label("Type the "+ progType +" name and click on  Start");
	labelInfo.setBounds(8, 56,480,16);
	panelControl.add(labelInfo);

	inputFilename = new java.awt.TextField();
	inputFilename.setBounds(8, 82, 300,24);
	panelControl.add(inputFilename);

	labelResult = new Label();
	labelResult.setBounds(340, 82, 180, 25);
        labelResult.setBackground(Color.black);
        labelResult.setForeground(Color.green);
        labelResult.setAlignment(Label.CENTER);
	panelControl.add(labelResult);

	panelText = new java.awt.Panel();
	panelText.setLayout(new GridLayout(1,0,0,0));
	panelText.setBounds(getInsets().left + 0,getInsets().top + 10,556,292);
	add("Center", panelText);

        textLocate = new List();
        textLocate.setBackground(background.brighter());
        textLocate.setForeground(Color.black);
        textLocate.setFont(new Font("Courier", Font.PLAIN, 14));
        textLocate.setMultipleMode(false);
 	panelText.add(textLocate);

	setTitle(" Locate a file or directory");

        buttonAccept.setEnabled(false);

        // Listeners

	buttonStart.addActionListener(lSymAction);
	buttonCancel.addActionListener(lSymAction);
	buttonAccept.addActionListener(lSymAction);

}


  public SetupFind(Frame parent, String type, String defname)
  {
    this(parent);
    progType = type;
    labelInfo.setText("Type the " + progType + " name and click on  Start");
    inputFilename.setText(defname);
  }

  public void setTextStyle(Style s)
    {
     textLocate.setFont(s.font);
     textLocate.setBackground(s.background);
     textLocate.setForeground(s.foreground);
    }


    class SWThread extends Thread implements Runnable
    {
       SWThread() { }

       public void run()
       {
         Find_Action();
       }
    }




class SymAction implements java.awt.event.ActionListener
{
   public void actionPerformed(java.awt.event.ActionEvent event)
   {
    //Disp.it("LD actionPerformed");
     Object object = event.getSource();
     if (object == buttonCancel)
     {
       if(searchThread != null)
       {
          searchThread.destroy();
          searchThread = null;

          if(!achieved)
          {
            setResult("Stopped");
            return;
          }
       }

       setVisible(false);
       return;
    }
    else if (object == buttonStart)
    {
       searchThread = new SWThread();
       setThread(searchThread);
       searchThread.start();
    }
    else if(object == buttonAccept) Accept();
    else if(object == fre) // un seul message, action non teste
    {
       textLocate.select(0);
       result = 1;
       buttonAccept.setEnabled(true);
    }

   }
  }


    // Lecture/Ecriture des variables

    final void setCurDrive(String drive) { CurDrive = drive; }
    final void setInput(String previous) { inputFilename.setText(previous);}
    final void setResult(String str)   { labelResult.setText(str); }
    public String getInput() { return inputFilename.getText(); }


    // Lancement de la recherche

    void Find_Action()
    {
        // Cre un engin avec nom et listbox

        String textToLocate = inputFilename.getText().trim();
        String basepath = CurDrive;
        int l;

        // Prendre disk
        if(textToLocate.length() == 0) return;

        int dskdelim = textToLocate.indexOf(":");
        if(dskdelim != -1)
        {
          l = textToLocate.length();
          basepath = textToLocate.substring(0, dskdelim + 1);
          textToLocate = textToLocate.substring(dskdelim + 1, l);
        }

        inputFilename.setText(basepath + textToLocate);

        fre = new LocateEngine(basepath, textToLocate, textLocate, false);
        fre.addActionListener(lSymAction);
        textLocate.removeAll();

        setResult("Searching...");
        fre.setOccur(0);
        fre.FindIt();         // Commande  l'engin la recherche

        Tool.beep();

        result = fre.getOccur();
        if(result > 0)
         {
          setResult("Found " + result);
          if(result > 1)
           labelInfo.setText("Select a " + progType + " and click on  Accept");
          else
           labelInfo.setText("Click on  Accept  or  Cancel");
         }
        else
          setResult("No found");

        achieved = true;
        Tool.beep();
	}


  void Accept()
  {
      if(searchThread != null)
        {
         searchThread.destroy();
         searchThread = null;
        }

      String name = textLocate.getSelectedItem();
      if(name == null) return;
      dirfound  = Path.splitPath(name);
      filefound = Path.splitFile(name);

      setVisible(false);
  }

}
