/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

/**
  Classe de tri
  qui distingue les units
  Hrite de super compare
  - Les fonctions sont statiques
  - Elles n'utilisent pas d'index
*/

public class SortDir
{
  static String staticBase[] = null;
  static boolean separeDrives = false;

  
  public SortDir() {			//{{INIT_CONTROLS
		//}}
};

  /**
    Compare deux chane en plaant toujours les units en tte
  */
  static int staticCompare(int a, int b)
  {
    String sa = staticBase[a];
    String sb = staticBase[b];

    if(separeDrives)
    {
     boolean aunit = (sa.charAt(1) == ':') && (sa.length() == 2);
     boolean bunit = (sb.charAt(1) == ':') && (sb.length() == 2);
     if(aunit != bunit)  // si tous deux ou aucun, on continue
     {
      if(aunit) return -1; // si seul a unit, infrieur
      return 1;            // si seul b unite, suprieur
     }
    }

    return Sort.superCompare(sa, sb);
  }





  static void staticSwap(int a, int b)
  {
    String s = staticBase[a]; 
    staticBase[a] = staticBase[b];  
    staticBase[b] = s;
  }

  /**
     Trie toute la liste
     en mettant les units toujours en tte
  */   
  static public void sortList(String[] t, int start, int limit)
  {
    staticBase = t;

    if(OS.isWindows())
     separeDrives = true;

    staticInsertion(start, limit);
    separeDrives = false;
	return;
  }


  // Fonction de sparation des units
  /*
  static boolean swapNeeded(int a, int b)
  {
    String sa = staticBase[a];
    String sb = staticBase[b];
    boolean aunit;
    boolean bunit;

    try { aunit = (sa.charAt(1) == ':') && (sa.length() == 2); }
    catch(StringIndexOutOfBoundsException e1) { aunit = false; }

    try { bunit = (sb.charAt(1) == ':') && (sb.length() == 2); }
    catch(StringIndexOutOfBoundsException e2) { bunit = false; }

    // vrai si aunit non dir et bunit dir
    return ( !aunit && bunit );
  }
  */


  /**
     Mets les dirs avant
     Et les trie
  */

 static int separeDrives(String[] t, int st, int limit)
  {
    if(!OS.isWindows()) return 0;
    
    int idx = st;
    staticBase = t;
    st++;

    while(st < limit)
    {
     if( (staticBase[idx].charAt(1) == ':') && 
            (staticBase[idx].length() == 2))
      {
        idx++;    
        if(st == idx) st++;
      }    
     else
      {  
       if( (staticBase[st].charAt(1) == ':') && 
         (staticBase[st].length() == 2))
       {
        staticSwap(idx, st);
        idx++;
       }
      st++;
      }
    } // fin while

     
    staticInsertion(0, idx);
    return idx;
  }

/**
   Tri par insertion
   qui tient compte des drives
*/
 static void staticInsertion(int start, int limit)
 {
  int i, j;

  j = start;
  i = j + 1;
  while(i < limit)
   {
    while((j >= start) && staticCompare(j, j + 1) > 0)
     {
      staticSwap(j, j + 1);
      j--;
     }

    j = i;
    i++;
   } // jusqu' lim
} // insertion


 static int countDrives(String list[])
 {
    int l = list.length;
    int count = 0;
    
    for(int i = 0; i < l; i++)
    {
     if( (list[i].charAt(1) == ':') && 
         (list[i].length() == 2))
            count++;
    }
   return count; 
 }
 
	
	//{{DECLARE_CONTROLS
	//}}
}; // class
